------------------------------------------------------------------------
r24587 | tlyu | 2010-12-22 15:37:18 -0500 (Wed, 22 Dec 2010) | 1 line
Changed paths:
   A /tags/krb5-1-9-final (from /branches/krb5-1-9:24586)

Create tag krb5-1-9-final
------------------------------------------------------------------------
r24586 | tlyu | 2010-12-22 15:36:11 -0500 (Wed, 22 Dec 2010) | 1 line
Changed paths:
   M /branches/krb5-1-9/README
   M /branches/krb5-1-9/src/patchlevel.h

README and patchlevel.h for krb5-1.9
------------------------------------------------------------------------
r24585 | tlyu | 2010-12-22 14:10:27 -0500 (Wed, 22 Dec 2010) | 14 lines
Changed paths:
   M /branches/krb5-1-9/doc/admin.texinfo
   M /branches/krb5-1-9/src/config-files/krb5.conf.M

ticket: 6794
version_fixed: 1.9
status: resolved

pull up r24584 from trunk

 ------------------------------------------------------------------------
 r24584 | tlyu | 2010-12-20 17:52:35 -0500 (Mon, 20 Dec 2010) | 6 lines

 ticket: 6794
 tags: pullup
 target_version: 1.9

 Document rdns libdefault setting.
------------------------------------------------------------------------
r24582 | tlyu | 2010-12-16 16:52:09 -0500 (Thu, 16 Dec 2010) | 1 line
Changed paths:
   M /branches/krb5-1-9/README

Add missing note about SA-2010-007.
------------------------------------------------------------------------
r24580 | tlyu | 2010-12-15 22:28:02 -0500 (Wed, 15 Dec 2010) | 1 line
Changed paths:
   M /branches/krb5-1-9/src/patchlevel.h

krb5-1.9-beta3-postrelease
------------------------------------------------------------------------
r24578 | tlyu | 2010-12-15 22:24:52 -0500 (Wed, 15 Dec 2010) | 1 line
Changed paths:
   M /branches/krb5-1-9/README
   M /branches/krb5-1-9/src/patchlevel.h

README and patchlevel.h for krb5-1.9-beta3
------------------------------------------------------------------------
r24577 | tlyu | 2010-12-15 22:15:29 -0500 (Wed, 15 Dec 2010) | 1 line
Changed paths:
   M /branches/krb5-1-9/src/lib/crypto/builtin/camellia/deps
   M /branches/krb5-1-9/src/lib/crypto/builtin/deps
   M /branches/krb5-1-9/src/lib/crypto/builtin/enc_provider/deps
   M /branches/krb5-1-9/src/lib/crypto/builtin/sha2/deps
   M /branches/krb5-1-9/src/lib/crypto/crypto_tests/deps
   M /branches/krb5-1-9/src/lib/crypto/krb/deps
   M /branches/krb5-1-9/src/lib/crypto/krb/dk/deps
   M /branches/krb5-1-9/src/lib/crypto/krb/prng/deps
   M /branches/krb5-1-9/src/lib/crypto/krb/prng/yarrow/deps
   M /branches/krb5-1-9/src/lib/gssapi/mechglue/deps
   M /branches/krb5-1-9/src/lib/kadm5/srv/deps
   M /branches/krb5-1-9/src/tests/gssapi/deps

make depend
------------------------------------------------------------------------
r24576 | tlyu | 2010-12-15 18:55:29 -0500 (Wed, 15 Dec 2010) | 1 line
Changed paths:
   M /branches/krb5-1-9/README

update acknowledgments
------------------------------------------------------------------------
r24573 | tlyu | 2010-12-14 18:10:52 -0500 (Tue, 14 Dec 2010) | 18 lines
Changed paths:
   M /branches/krb5-1-9/src/lib/gssapi/mechglue/g_accept_sec_context.c

ticket: 6842
version_fixed: 1.9
status: resolved

pull up r24568 from trunk

 ------------------------------------------------------------------------
 r24568 | ghudson | 2010-12-14 13:46:46 -0500 (Tue, 14 Dec 2010) | 10 lines

 ticket: 6842
 subject: Ensure time() is prototyped in g_accept_sec_context.c
 tags: pullup
 target_version: 1.9

 r22736 added a call to time() in g_accept_sec_context.c.  Include
 <time.h> to ensure that this call is correctly prototyped.  Previously
 <time.h> was only included implicitly through <pthread.h>, which
 doesn't apply when thread support is disabled.
------------------------------------------------------------------------
r24572 | tlyu | 2010-12-14 18:10:49 -0500 (Tue, 14 Dec 2010) | 15 lines
Changed paths:
   M /branches/krb5-1-9/src/lib/krb5/os/changepw.c

ticket: 6841
version_fixed: 1.9
status: resolved

pull up r24567 from trunk

 ------------------------------------------------------------------------
 r24567 | tlyu | 2010-12-14 12:34:48 -0500 (Tue, 14 Dec 2010) | 7 lines

 ticket: 6841
 subject: memory leak in changepw.c
 tags: pullup
 target_version: 1.9

 Apply patch from Marcus Watts to avoid a memory leak in changepw.c.
------------------------------------------------------------------------
r24571 | tlyu | 2010-12-14 18:10:45 -0500 (Tue, 14 Dec 2010) | 15 lines
Changed paths:
   M /branches/krb5-1-9/src/lib/krb5/error_tables/krb5_err.et

ticket: 6840
version_fixed: 1.9
status: resolved

pull up r24565 from trunk

 ------------------------------------------------------------------------
 r24565 | tlyu | 2010-12-14 12:24:21 -0500 (Tue, 14 Dec 2010) | 7 lines

 ticket: 6840
 subject: typo in plugin-related error message
 tags: pullup
 target_version: 1.9

 Apply patch from Marcus Watts to fix error message typo.
------------------------------------------------------------------------
r24570 | tlyu | 2010-12-14 18:10:42 -0500 (Tue, 14 Dec 2010) | 17 lines
Changed paths:
   M /branches/krb5-1-9/src/lib/krb5/krb/val_renew.c
   M /branches/krb5-1-9/src/tests/Makefile.in
   A /branches/krb5-1-9/src/tests/t_renew.py

ticket: 6838
version_fixed: 1.9
status: resolved

pull up r24566 from trunk

 ------------------------------------------------------------------------
 r24566 | ghudson | 2010-12-14 12:28:38 -0500 (Tue, 14 Dec 2010) | 9 lines

 ticket: 6838
 tags: pullups
 target_version: 1.9

 Fix a regression in the client-side ticket renewal code where KDC
 options were not folded into the renewal request (most notably, the
 KDC_OPT_RENEWABLE flag), so we didn't request renewable renewed
 tickets.  Add a simple test case for ticket renewal.
------------------------------------------------------------------------
r24569 | tlyu | 2010-12-14 18:10:36 -0500 (Tue, 14 Dec 2010) | 26 lines
Changed paths:
   M /branches/krb5-1-9/src/include/k5-trace.h
   M /branches/krb5-1-9/src/lib/krb5/krb/pac.c

ticket: 6839
version_fixed: 1.9
status: resolved

pull up r24564 from trunk

 ------------------------------------------------------------------------
 r24564 | tlyu | 2010-12-09 20:06:26 -0500 (Thu, 09 Dec 2010) | 18 lines

 ticket: 6839
 subject: handle MS PACs that lack server checksum
 target_version 1.9
 tags: pullup

 Apple Mac OS X Server's Open Directory KDC issues MS PAC like
 authorization data that lacks a server checksum.  If this checksum is
 missing, mark the PAC as unverfied, but allow
 krb5int_authdata_verify() to succeed.  Filter out the unverified PAC
 in subsequent calls to krb5_authdata_get_attribute().  Add trace
 points to indicate where this behavior occurs.

 Thanks to Helmut Grohne for help with analysis.  This bug is also
 Debian Bug #604925:
 http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=604925

 This change should also get backported to krb5-1.8.x.
------------------------------------------------------------------------
r24559 | tlyu | 2010-12-03 15:38:02 -0500 (Fri, 03 Dec 2010) | 1 line
Changed paths:
   M /branches/krb5-1-9/src/patchlevel.h

krb5-1.9-beta2-postrelease
------------------------------------------------------------------------
r24557 | tlyu | 2010-12-03 15:35:42 -0500 (Fri, 03 Dec 2010) | 1 line
Changed paths:
   M /branches/krb5-1-9/README
   M /branches/krb5-1-9/src/patchlevel.h

README and patchlevel.h for krb5-1.9-beta2
------------------------------------------------------------------------
r24556 | tlyu | 2010-12-03 13:47:59 -0500 (Fri, 03 Dec 2010) | 14 lines
Changed paths:
   M /branches/krb5-1-9/src/tests/Makefile.in
   A /branches/krb5-1-9/src/tests/t_keyrollover.py

ticket: 1219
version_fixed: 1.9
status: resolved

pull up r24555 from trunk

 ------------------------------------------------------------------------
 r24555 | tlyu | 2010-12-03 07:34:53 -0500 (Fri, 03 Dec 2010) | 6 lines

 ticket: 1219
 target_version: 1.9
 tags: pullup

 Test for key rollover for TGT, including purging old keys.
------------------------------------------------------------------------
r24554 | tlyu | 2010-12-02 19:24:15 -0500 (Thu, 02 Dec 2010) | 6 lines
Changed paths:
   M /branches/krb5-1-9/src/ccapi/server/win/Makefile.in
   M /branches/krb5-1-9/src/ccapi/server/win/Server.sln
   M /branches/krb5-1-9/src/ccapi/server/win/Server.vcproj
   M /branches/krb5-1-9/src/ccapi/server/win/WorkItem.cpp
   M /branches/krb5-1-9/src/ccapi/server/win/WorkQueue.cpp
   M /branches/krb5-1-9/src/ccapi/server/win/ccs_os_server.cpp

ticket: 6826
status: resolved

Fix svn:eol-style properties.


------------------------------------------------------------------------
r24553 | tlyu | 2010-12-02 19:05:44 -0500 (Thu, 02 Dec 2010) | 73 lines
Changed paths:
   M /branches/krb5-1-9/src/Makefile.in
   M /branches/krb5-1-9/src/appl/Makefile.in
   M /branches/krb5-1-9/src/appl/gss-sample/Makefile.in
   M /branches/krb5-1-9/src/appl/sample/Makefile.in
   M /branches/krb5-1-9/src/appl/sample/sclient/Makefile.in
   M /branches/krb5-1-9/src/appl/sample/sserver/Makefile.in
   M /branches/krb5-1-9/src/appl/simple/Makefile.in
   M /branches/krb5-1-9/src/appl/simple/client/Makefile.in
   M /branches/krb5-1-9/src/appl/simple/server/Makefile.in
   M /branches/krb5-1-9/src/appl/user_user/Makefile.in
   M /branches/krb5-1-9/src/ccapi/Makefile.in
   M /branches/krb5-1-9/src/ccapi/common/Makefile.in
   M /branches/krb5-1-9/src/ccapi/common/unix/Makefile.in
   M /branches/krb5-1-9/src/ccapi/lib/Makefile.in
   M /branches/krb5-1-9/src/ccapi/lib/ccapi_context.c
   M /branches/krb5-1-9/src/ccapi/lib/ccapi_ipc.c
   M /branches/krb5-1-9/src/ccapi/lib/ccapi_ipc.h
   M /branches/krb5-1-9/src/ccapi/lib/ccapi_os_ipc.h
   M /branches/krb5-1-9/src/ccapi/lib/mac/ccapi_os_ipc.c
   M /branches/krb5-1-9/src/ccapi/lib/unix/Makefile.in
   M /branches/krb5-1-9/src/ccapi/lib/win/Makefile.in
   M /branches/krb5-1-9/src/ccapi/lib/win/WINCCAPI.sln
   M /branches/krb5-1-9/src/ccapi/lib/win/WINCCAPI.vcproj
   M /branches/krb5-1-9/src/ccapi/lib/win/ccapi_os_ipc.cxx
   M /branches/krb5-1-9/src/ccapi/lib/win/debug.exports
   M /branches/krb5-1-9/src/ccapi/server/Makefile.in
   M /branches/krb5-1-9/src/ccapi/server/unix/Makefile.in
   M /branches/krb5-1-9/src/ccapi/server/win/Makefile.in
   M /branches/krb5-1-9/src/ccapi/server/win/Server.sln
   M /branches/krb5-1-9/src/ccapi/server/win/Server.vcproj
   M /branches/krb5-1-9/src/ccapi/server/win/WorkItem.cpp
   M /branches/krb5-1-9/src/ccapi/server/win/WorkQueue.cpp
   M /branches/krb5-1-9/src/ccapi/server/win/ccs_os_server.cpp
   M /branches/krb5-1-9/src/ccapi/test/Makefile.in
   M /branches/krb5-1-9/src/ccapi/test/pingtest.c
   M /branches/krb5-1-9/src/clients/Makefile.in
   M /branches/krb5-1-9/src/clients/kdestroy/Makefile.in
   M /branches/krb5-1-9/src/clients/kinit/Makefile.in
   M /branches/krb5-1-9/src/clients/kinit/kinit.c
   M /branches/krb5-1-9/src/clients/klist/Makefile.in
   M /branches/krb5-1-9/src/clients/klist/klist.c
   M /branches/krb5-1-9/src/clients/kpasswd/Makefile.in
   M /branches/krb5-1-9/src/clients/ksu/Makefile.in
   M /branches/krb5-1-9/src/clients/kvno/Makefile.in
   M /branches/krb5-1-9/src/config/pre.in
   M /branches/krb5-1-9/src/config/win-post.in
   M /branches/krb5-1-9/src/config/win-pre.in
   M /branches/krb5-1-9/src/include/Makefile.in
   M /branches/krb5-1-9/src/include/k5-int.h
   M /branches/krb5-1-9/src/include/win-mac.h
   M /branches/krb5-1-9/src/kadmin/cli/Makefile.in
   M /branches/krb5-1-9/src/kadmin/dbutil/Makefile.in
   M /branches/krb5-1-9/src/kadmin/ktutil/Makefile.in
   M /branches/krb5-1-9/src/kadmin/server/Makefile.in
   M /branches/krb5-1-9/src/kadmin/testing/Makefile.in
   M /branches/krb5-1-9/src/kadmin/testing/scripts/Makefile.in
   M /branches/krb5-1-9/src/kadmin/testing/util/Makefile.in
   M /branches/krb5-1-9/src/lib/Makefile.in
   M /branches/krb5-1-9/src/lib/apputils/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/builtin/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/builtin/aes/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/builtin/camellia/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/builtin/des/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/builtin/enc_provider/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/builtin/enc_provider/camellia.c
   M /branches/krb5-1-9/src/lib/crypto/builtin/hash_provider/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/builtin/md4/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/builtin/md5/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/builtin/sha1/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/builtin/sha2/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/crypto_tests/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/krb/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/krb/arcfour/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/krb/checksum/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/krb/crc32/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/krb/dk/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/krb/old/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/krb/prf/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/krb/prng/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/krb/prng/fortuna/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/krb/prng/nss/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/krb/prng/yarrow/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/krb/rand2key/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/krb/raw/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/nss/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/nss/aes/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/nss/camellia/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/nss/des/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/nss/enc_provider/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/nss/hash_provider/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/nss/md4/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/nss/md5/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/nss/sha1/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/nss/sha2/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/openssl/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/openssl/aes/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/openssl/camellia/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/openssl/des/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/openssl/enc_provider/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/openssl/hash_provider/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/openssl/md4/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/openssl/md5/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/openssl/sha1/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/openssl/sha2/Makefile.in
   M /branches/krb5-1-9/src/lib/gssapi/Makefile.in
   M /branches/krb5-1-9/src/lib/gssapi/generic/Makefile.in
   M /branches/krb5-1-9/src/lib/gssapi/krb5/Makefile.in
   M /branches/krb5-1-9/src/lib/gssapi/krb5/copy_ccache.c
   M /branches/krb5-1-9/src/lib/gssapi/krb5/get_tkt_flags.c
   M /branches/krb5-1-9/src/lib/gssapi/krb5/gssapiP_krb5.h
   M /branches/krb5-1-9/src/lib/gssapi/krb5/gssapi_krb5.c
   M /branches/krb5-1-9/src/lib/gssapi/krb5/krb5_gss_glue.c
   M /branches/krb5-1-9/src/lib/gssapi/krb5/lucid_context.c
   M /branches/krb5-1-9/src/lib/gssapi/krb5/set_allowable_enctypes.c
   M /branches/krb5-1-9/src/lib/gssapi/krb5/set_ccache.c
   M /branches/krb5-1-9/src/lib/gssapi/mechglue/Makefile.in
   M /branches/krb5-1-9/src/lib/gssapi/mechglue/g_mechattr.c
   M /branches/krb5-1-9/src/lib/gssapi/mechglue/g_oid_ops.c
   M /branches/krb5-1-9/src/lib/gssapi/mechglue/g_store_cred.c
   M /branches/krb5-1-9/src/lib/gssapi/mechglue/mglueP.h
   M /branches/krb5-1-9/src/lib/gssapi/spnego/Makefile.in
   M /branches/krb5-1-9/src/lib/gssapi/spnego/gssapiP_spnego.h
   M /branches/krb5-1-9/src/lib/gssapi/spnego/spnego_mech.c
   M /branches/krb5-1-9/src/lib/gssapi32.def
   M /branches/krb5-1-9/src/lib/kadm5/Makefile.in
   M /branches/krb5-1-9/src/lib/kadm5/clnt/Makefile.in
   M /branches/krb5-1-9/src/lib/kadm5/srv/Makefile.in
   M /branches/krb5-1-9/src/lib/kadm5/unit-test/Makefile.in
   M /branches/krb5-1-9/src/lib/kdb/Makefile.in
   M /branches/krb5-1-9/src/lib/krb5/Makefile.in
   M /branches/krb5-1-9/src/lib/krb5/asn.1/Makefile.in
   M /branches/krb5-1-9/src/lib/krb5/asn.1/krb5_decode.c
   M /branches/krb5-1-9/src/lib/krb5/ccache/Makefile.in
   M /branches/krb5-1-9/src/lib/krb5/ccache/ccapi/Makefile.in
   M /branches/krb5-1-9/src/lib/krb5/error_tables/Makefile.in
   M /branches/krb5-1-9/src/lib/krb5/keytab/Makefile.in
   M /branches/krb5-1-9/src/lib/krb5/krb/Makefile.in
   M /branches/krb5-1-9/src/lib/krb5/krb/auth_con.c
   M /branches/krb5-1-9/src/lib/krb5/krb/get_creds.c
   M /branches/krb5-1-9/src/lib/krb5/krb/kfree.c
   M /branches/krb5-1-9/src/lib/krb5/os/Makefile.in
   M /branches/krb5-1-9/src/lib/krb5/os/hst_realm.c
   M /branches/krb5-1-9/src/lib/krb5/rcache/Makefile.in
   M /branches/krb5-1-9/src/lib/krb5/unicode/Makefile.in
   M /branches/krb5-1-9/src/lib/krb5_32.def
   M /branches/krb5-1-9/src/lib/rpc/Makefile.in
   M /branches/krb5-1-9/src/lib/rpc/unit-test/Makefile.in
   M /branches/krb5-1-9/src/lib/win_glue.c
   M /branches/krb5-1-9/src/plugins/authdata/greet/Makefile.in
   M /branches/krb5-1-9/src/plugins/authdata/greet_client/Makefile.in
   M /branches/krb5-1-9/src/plugins/authdata/greet_server/Makefile.in
   M /branches/krb5-1-9/src/plugins/kadm5_hook/test/Makefile.in
   M /branches/krb5-1-9/src/plugins/kdb/db2/Makefile.in
   M /branches/krb5-1-9/src/plugins/kdb/db2/libdb2/Makefile.in
   M /branches/krb5-1-9/src/plugins/kdb/db2/libdb2/btree/Makefile.in
   M /branches/krb5-1-9/src/plugins/kdb/db2/libdb2/db/Makefile.in
   M /branches/krb5-1-9/src/plugins/kdb/db2/libdb2/hash/Makefile.in
   M /branches/krb5-1-9/src/plugins/kdb/db2/libdb2/mpool/Makefile.in
   M /branches/krb5-1-9/src/plugins/kdb/db2/libdb2/recno/Makefile.in
   M /branches/krb5-1-9/src/plugins/kdb/db2/libdb2/test/Makefile.in
   M /branches/krb5-1-9/src/plugins/kdb/hdb/Makefile.in
   M /branches/krb5-1-9/src/plugins/kdb/ldap/Makefile.in
   M /branches/krb5-1-9/src/plugins/kdb/ldap/ldap_util/Makefile.in
   M /branches/krb5-1-9/src/plugins/kdb/ldap/libkdb_ldap/Makefile.in
   M /branches/krb5-1-9/src/plugins/locate/python/Makefile.in
   M /branches/krb5-1-9/src/plugins/preauth/cksum_body/Makefile.in
   M /branches/krb5-1-9/src/plugins/preauth/encrypted_challenge/Makefile.in
   M /branches/krb5-1-9/src/plugins/preauth/pkinit/Makefile.in
   M /branches/krb5-1-9/src/plugins/preauth/securid_sam2/Makefile.in
   M /branches/krb5-1-9/src/plugins/preauth/wpse/Makefile.in
   M /branches/krb5-1-9/src/tests/asn.1/Makefile.in
   M /branches/krb5-1-9/src/tests/create/Makefile.in
   M /branches/krb5-1-9/src/tests/dejagnu/Makefile.in
   M /branches/krb5-1-9/src/tests/gss-threads/Makefile.in
   M /branches/krb5-1-9/src/tests/gssapi/Makefile.in
   M /branches/krb5-1-9/src/tests/hammer/Makefile.in
   M /branches/krb5-1-9/src/tests/misc/Makefile.in
   M /branches/krb5-1-9/src/tests/mkeystash_compat/Makefile.in
   M /branches/krb5-1-9/src/tests/resolve/Makefile.in
   M /branches/krb5-1-9/src/tests/shlib/Makefile.in
   M /branches/krb5-1-9/src/tests/threads/Makefile.in
   M /branches/krb5-1-9/src/tests/verify/Makefile.in
   M /branches/krb5-1-9/src/util/Makefile.in
   M /branches/krb5-1-9/src/util/collected-client-lib/Makefile.in
   M /branches/krb5-1-9/src/util/et/Makefile.in
   M /branches/krb5-1-9/src/util/profile/Makefile.in
   M /branches/krb5-1-9/src/util/profile/prof_parse.c
   M /branches/krb5-1-9/src/util/send-pr/Makefile.in
   M /branches/krb5-1-9/src/util/ss/Makefile.in
   M /branches/krb5-1-9/src/util/support/Makefile.in
   M /branches/krb5-1-9/src/windows/Makefile.in
   M /branches/krb5-1-9/src/windows/README
   M /branches/krb5-1-9/src/windows/build/bkw.pl
   D /branches/krb5-1-9/src/windows/ntsecapitest.c
   D /branches/krb5-1-9/src/windows/ntsecapitest.pl

ticket: 6826
version_fixed: 1.9
status: resolved

pull up r24469, r24530, r24533, r24534, r24535, r24537 from trunk

 ------------------------------------------------------------------------
 r24537 | ghudson | 2010-11-30 12:46:10 -0500 (Tue, 30 Nov 2010) | 5 lines

 ticket: 6826

 Install gssapi_ext.h on Windows.  Include gssapi_ext.h in the header
 files considered by def-check.pl in verify-calling-conventions-gssapi.

 ------------------------------------------------------------------------
 r24535 | ghudson | 2010-11-26 11:37:14 -0500 (Fri, 26 Nov 2010) | 5 lines

 ticket: 6826

 Supply static ordinals for new symbols in gssapi32.def and krb5_32.def,
 for consistency with KFW 3.x.

 ------------------------------------------------------------------------
 r24534 | ghudson | 2010-11-25 15:34:06 -0500 (Thu, 25 Nov 2010) | 5 lines

 ticket: 6826

 Fix how gssapi.h is rebuilt on Windows; accidentally omitted from
 r24533.

 ------------------------------------------------------------------------
 r24533 | ghudson | 2010-11-25 15:28:30 -0500 (Thu, 25 Nov 2010) | 29 lines

 ticket: 6826
 subject: Fix Windows build
 target_version: 1.9
 tags: pullup

 Repair the Windows build.  Tested with the prepare-on-Unix method.
 Some specific changes include:

 * Removed the IPC finalizer (no longer used after r20787) from
   ccapi/lib/ccapi_ipc.c, as it was creating a difficult dependency
   chain for the pingtest build in ccapi/test.  Also updated pingtest
   to use the k5_ipc_stream interfaces since cci_stream is gone.

 * Reverted the apparently non-functional r20277.

 * klist -V prints just "Kerberos for Windows", since it has no access
   to PACKAGE_NAME and PACKAGE_VERSION from autoconf.  This should be
   addressed correctly.

 * krb5, telnet, gssftp, and NIM are removed from the build.

 * Some files had CRLFs; these were replaced with LFs and the
   svn:eol-style property set on the files.  Otherwise the CRLFs became
   CRCRLFs after the zip transfer.

 * Windows does not have opendir/readdir, so added Windows code to
   prof_parse.c for includedir.  Probable fodder for a libkrb5support
   portability shim.

 ------------------------------------------------------------------------
 r24530 | ghudson | 2010-11-23 13:50:12 -0500 (Tue, 23 Nov 2010) | 3 lines

 Set svn:eol-style on some Windows files and remove the CRs from their
 repository representations.

 ------------------------------------------------------------------------
 r24469 | ghudson | 2010-10-21 20:01:56 -0400 (Thu, 21 Oct 2010) | 3 lines

 Make it possible to override CRYPTO_IMPL_CFLAGS and CRYPTO_IMPL_LIBS at
 make time.
------------------------------------------------------------------------
r24552 | tlyu | 2010-12-01 18:11:50 -0500 (Wed, 01 Dec 2010) | 12 lines
Changed paths:
   M /branches/krb5-1-9/doc/admin.texinfo

ticket: 6829
version_fixed: 1.9
status: resolved

pull up r24550 from trunk

 ------------------------------------------------------------------------
 r24550 | ghudson | 2010-12-01 17:36:38 -0500 (Wed, 01 Dec 2010) | 4 lines

 ticket: 6829

 Correct typo in admin documentation for restrict_anonymous_to_tgt.
------------------------------------------------------------------------
r24551 | tlyu | 2010-12-01 18:11:46 -0500 (Wed, 01 Dec 2010) | 15 lines
Changed paths:
   M /branches/krb5-1-9/src/include/Makefile.in

ticket: 6828
version_fixed: 1.9
status: resolved

pull up r24539 from trunk

 ------------------------------------------------------------------------
 r24539 | hartmans | 2010-11-30 17:46:54 -0500 (Tue, 30 Nov 2010) | 7 lines

 ticket: 6828
 Subject: Install kadm5_hook_plugin.h
 target_version: 1.9
 tags: pullup

 Install the kadm5 hook plugin header
------------------------------------------------------------------------
r24549 | tlyu | 2010-12-01 16:37:25 -0500 (Wed, 01 Dec 2010) | 18 lines
Changed paths:
   M /branches/krb5-1-9/doc/admin.texinfo
   M /branches/krb5-1-9/src/include/adm.h
   M /branches/krb5-1-9/src/include/k5-int.h
   M /branches/krb5-1-9/src/kdc/extern.h
   M /branches/krb5-1-9/src/kdc/kdc_util.c
   M /branches/krb5-1-9/src/kdc/main.c
   M /branches/krb5-1-9/src/lib/kadm5/admin.h
   M /branches/krb5-1-9/src/lib/kadm5/alt_prof.c
   M /branches/krb5-1-9/src/tests/t_anonpkinit.py
   M /branches/krb5-1-9/src/util/k5test.py

ticket: 6829
version_fixed: 1.9
status: resolved

pull up r24547 from trunk

 ------------------------------------------------------------------------
 r24547 | ghudson | 2010-12-01 15:01:46 -0500 (Wed, 01 Dec 2010) | 10 lines

 ticket: 6829
 subject: Implement restrict_anonymous_to_tgt realm flag
 target_version: 1.9
 tags: pullup

 Implement a new realm flag to reject ticket requests from anonymous
 principals to any principal other than the local TGT.  Allows FAST to
 be deployed using anonymous tickets as armor in realms where the set
 of authenticatable users must be constrained.
------------------------------------------------------------------------
r24548 | tlyu | 2010-12-01 15:49:06 -0500 (Wed, 01 Dec 2010) | 11 lines
Changed paths:
   M /branches/krb5-1-9/src/plugins/kdb/db2/kdb_db2.c

ticket: 6815
version_fixed: 1.9

Apply ported patch.

 If kdb5_util load (without -update) fails--say, due to an invalid dump
 file--it calls krb5_db_destroy to destroy the temporary DB.
 Unfortunately, this results in the destruction of the real DB instead.

 Luckily, this bug only applies to krb5 1.9, which hasn't been released
 yet.  In krb5 1.8 the destroy operation fails before it does any damage.
------------------------------------------------------------------------
r24546 | tlyu | 2010-11-30 21:16:37 -0500 (Tue, 30 Nov 2010) | 26 lines
Changed paths:
   M /branches/krb5-1-9/src/include/k5-int.h
   M /branches/krb5-1-9/src/include/krb5/krb5.hin
   M /branches/krb5-1-9/src/lib/krb5/krb/gic_pwd.c

ticket: 6825
version_fixed: 1.9
status: resolved

pull up r24529, r24532 from trunk

 ------------------------------------------------------------------------
 r24532 | tlyu | 2010-11-23 18:51:50 -0500 (Tue, 23 Nov 2010) | 6 lines

 ticket: 6825

 Update krb5_gic_opt_private and related code to reflect the change of
 krb5_expire_callback_func from a function typedef to a function
 pointer typedef.  This was causing segfaults.

 ------------------------------------------------------------------------
 r24529 | ghudson | 2010-11-22 23:50:40 -0500 (Mon, 22 Nov 2010) | 9 lines

 ticket: 6825
 subject: Add missing KRB5_CALLCONV in callback declaration
 target_version: 1.9
 tags: pullup

 krb5_get_init_creds_opt_set_expire_callback was correctly tagged with
 KRB5_CALLCONV but the corresponding callback type was not.  Add that
 in.
------------------------------------------------------------------------
r24545 | tlyu | 2010-11-30 21:16:31 -0500 (Tue, 30 Nov 2010) | 15 lines
Changed paths:
   M /branches/krb5-1-9/src/lib/krb5/libkrb5.exports

ticket: 6824
version_fixed: 1.9
status: resolved

pull up r24528 from trunk

 ------------------------------------------------------------------------
 r24528 | ghudson | 2010-11-22 23:41:08 -0500 (Mon, 22 Nov 2010) | 7 lines

 ticket: 6824
 subject: Export krb5_tkt_creds_get
 target_version: 1.9
 tags: pullup

 krb5_tkt_creds_get was overlooked in the export list; add it.
------------------------------------------------------------------------
r24544 | tlyu | 2010-11-30 21:16:25 -0500 (Tue, 30 Nov 2010) | 24 lines
Changed paths:
   M /branches/krb5-1-9/src/kadmin/cli/getdate.y

ticket: 6823
version_fixed: 1.9
status: resolved

pull up r24526, r24527 from trunk

 ------------------------------------------------------------------------
 r24527 | ghudson | 2010-11-21 22:58:15 -0500 (Sun, 21 Nov 2010) | 4 lines

 ticket: 6823

 Correct typo in r24526.

 ------------------------------------------------------------------------
 r24526 | hartmans | 2010-11-21 22:33:22 -0500 (Sun, 21 Nov 2010) | 9 lines

 ticket: 6823
 subject: getdate.y: declare yyparse
 target_version: 1.9
 tags: pullup

 At least on lucid, byacc doesn't declare yyparse, which creates
 problems because lucid treats calls to unprototyped functions as
 errors.
------------------------------------------------------------------------
r24543 | tlyu | 2010-11-30 21:16:14 -0500 (Tue, 30 Nov 2010) | 16 lines
Changed paths:
   M /branches/krb5-1-9/src/include/k5-int.h
   M /branches/krb5-1-9/src/lib/crypto/builtin/camellia/camellia-gen.c
   M /branches/krb5-1-9/src/lib/crypto/builtin/camellia/camellia.c
   M /branches/krb5-1-9/src/lib/crypto/builtin/enc_provider/Makefile.in
   A /branches/krb5-1-9/src/lib/crypto/builtin/enc_provider/camellia.c
   D /branches/krb5-1-9/src/lib/crypto/builtin/enc_provider/camellia_ctr.c
   M /branches/krb5-1-9/src/lib/crypto/builtin/enc_provider/enc_provider.h
   M /branches/krb5-1-9/src/lib/crypto/crypto_tests/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/crypto_tests/camellia-test.c
   D /branches/krb5-1-9/src/lib/crypto/crypto_tests/t_camellia_ccm.c
   A /branches/krb5-1-9/src/lib/crypto/crypto_tests/t_cksums.c
   M /branches/krb5-1-9/src/lib/crypto/crypto_tests/t_cmac.c
   A /branches/krb5-1-9/src/lib/crypto/crypto_tests/t_decrypt.c
   A /branches/krb5-1-9/src/lib/crypto/crypto_tests/t_derive.c
   M /branches/krb5-1-9/src/lib/crypto/crypto_tests/t_encrypt.c
   M /branches/krb5-1-9/src/lib/crypto/crypto_tests/t_short.c
   M /branches/krb5-1-9/src/lib/crypto/crypto_tests/t_str2key.c
   M /branches/krb5-1-9/src/lib/crypto/krb/checksum/cmac.c
   M /branches/krb5-1-9/src/lib/crypto/krb/cksumtypes.c
   M /branches/krb5-1-9/src/lib/crypto/krb/dk/Makefile.in
   M /branches/krb5-1-9/src/lib/crypto/krb/dk/checksum_cmac.c
   M /branches/krb5-1-9/src/lib/crypto/krb/dk/derive.c
   M /branches/krb5-1-9/src/lib/crypto/krb/dk/dk.h
   D /branches/krb5-1-9/src/lib/crypto/krb/dk/dk_ccm.c
   A /branches/krb5-1-9/src/lib/crypto/krb/dk/dk_cmac.c
   M /branches/krb5-1-9/src/lib/crypto/krb/dk/stringtokey.c
   M /branches/krb5-1-9/src/lib/crypto/krb/etypes.c
   M /branches/krb5-1-9/src/lib/crypto/krb/prf/cmac_prf.c
   M /branches/krb5-1-9/src/lib/crypto/libk5crypto.exports
   M /branches/krb5-1-9/src/lib/crypto/nss/enc_provider/camellia.c
   M /branches/krb5-1-9/src/lib/crypto/nss/enc_provider/enc_gen.c
   M /branches/krb5-1-9/src/lib/crypto/nss/enc_provider/enc_provider.h
   M /branches/krb5-1-9/src/lib/crypto/nss/nss_gen.h
   M /branches/krb5-1-9/src/lib/crypto/openssl/enc_provider/Makefile.in
   A /branches/krb5-1-9/src/lib/crypto/openssl/enc_provider/camellia.c
   D /branches/krb5-1-9/src/lib/crypto/openssl/enc_provider/camellia_ctr.c
   M /branches/krb5-1-9/src/lib/crypto/openssl/enc_provider/enc_provider.h
   M /branches/krb5-1-9/src/lib/krb5/krb/init_ctx.c
   M /branches/krb5-1-9/src/lib/krb5/krb/t_etypes.c
   M /branches/krb5-1-9/src/tests/dejagnu/config/default.exp
   M /branches/krb5-1-9/src/util/k5test.py
   M /branches/krb5-1-9/src/windows/identity/plugins/krb5/datarep.c
   M /branches/krb5-1-9/src/windows/identity/plugins/krb5/lang/en_us/langres.rc

ticket: 6822
version_fixed: 1.9
status: resolved

pull up r24524 from trunk

 ------------------------------------------------------------------------
 r24524 | ghudson | 2010-11-19 19:31:46 -0500 (Fri, 19 Nov 2010) | 8 lines

 ticket: 6822
 subject: Implement Camellia-CTS-CMAC instead of Camellia-CCM
 target_verion: 1.9
 tags: pullup

 Replace the Camellia-CCM enctypes with Camellia-CTS-CMAC.  Still not
 compiled in by default since we don't have enctype assignments yet.
------------------------------------------------------------------------
r24542 | tlyu | 2010-11-30 21:16:04 -0500 (Tue, 30 Nov 2010) | 16 lines
Changed paths:
   M /branches/krb5-1-9/src/slave/kpropd.c

ticket: 6820
version_fixed: 1.9
status: resolved

pull up r24519 from trunk

 ------------------------------------------------------------------------
 r24519 | ghudson | 2010-11-15 21:54:26 -0500 (Mon, 15 Nov 2010) | 8 lines

 ticket: 6820
 subject: Read KDC profile settings in kpropd
 target_version: 1.9
 tags: pullup

 kpropd can modify the KDB with ulog_replay(), so it should read the
 KDC profile settings in case the KDB configuration is in there.
------------------------------------------------------------------------
r24541 | tlyu | 2010-11-30 21:15:55 -0500 (Tue, 30 Nov 2010) | 20 lines
Changed paths:
   M /branches/krb5-1-9/src/slave/kprop.c

ticket: 6819
version_fixed: 1.9
status: resolved

pull up r24518 from trunk

 ------------------------------------------------------------------------
 r24518 | ghudson | 2010-11-15 21:30:16 -0500 (Mon, 15 Nov 2010) | 12 lines

 ticket: 6819
 subject: Handle referral realm in kprop client principal
 target_version: 1.9
 tags: pullup

 kprop uses krb5_sname_to_principal() to determine its client
 principal.  If the local hostname cannot be mapped to a realm based on
 the profile's domain_realm section, krb5_sname_to_principal() will (as
 of 1.6) return a principal with the referral realm (""), which does
 not work in a client principal.  Handle this by substituting the
 default realm.
------------------------------------------------------------------------
r24540 | tlyu | 2010-11-30 21:15:45 -0500 (Tue, 30 Nov 2010) | 35 lines
Changed paths:
   M /branches/krb5-1-9/src/lib/crypto/crypto_tests/t_kperf.c
   M /branches/krb5-1-9/src/lib/crypto/krb/cksumtypes.c
   M /branches/krb5-1-9/src/lib/crypto/krb/dk/checksum_hmac.c
   M /branches/krb5-1-9/src/lib/crypto/krb/dk/derive.c
   M /branches/krb5-1-9/src/lib/crypto/krb/etypes.c
   M /branches/krb5-1-9/src/lib/crypto/krb/etypes.h
   M /branches/krb5-1-9/src/lib/krb5/krb/fast.c
   M /branches/krb5-1-9/src/lib/krb5/krb/mk_req_ext.c
   M /branches/krb5-1-9/src/lib/krb5/krb/mk_safe.c
   M /branches/krb5-1-9/src/lib/krb5/krb/pac.c
   M /branches/krb5-1-9/src/lib/krb5/krb/preauth2.c
   M /branches/krb5-1-9/src/plugins/preauth/pkinit/pkinit_srv.c

ticket: 6827
version_fixed: 1.9
status: resolved

pull up r24538 from trunk

 ------------------------------------------------------------------------
 r24538 | ghudson | 2010-11-30 16:20:49 -0500 (Tue, 30 Nov 2010) | 27 lines

 ticket: 6827
 subject: SA-2010-007 Checksum vulnerabilities (CVE-2010-1324 and others)

 Fix multiple checksum handling bugs, as described in:
   CVE-2010-1324
   CVE-2010-1323
   CVE-2010-4020
   CVE-2010-4021

 * Return the correct (keyed) checksums as the mandatory checksum type
   for DES enctypes.
 * Restrict simplified-profile checksums to their corresponding etypes.
 * Add internal checks to reduce the risk of stream ciphers being used
   with simplified-profile key derivation or other algorithms relying
   on the block encryption primitive.
 * Use the mandatory checksum type for the PKINIT KDC signature,
   instead of the first-listed keyed checksum.
 * Use the mandatory checksum type when sending KRB-SAFE messages by
   default, instead of the first-listed keyed checksum.
 * Use the mandatory checksum type for the t_kperf test program.
 * Use the mandatory checksum type (without additional logic) for the
   FAST request checksum.
 * Preserve the existing checksum choices (unkeyed checksums for DES
   enctypes) for the authenticator checksum, using explicit logic.
 * Ensure that SAM checksums received from the KDC are keyed.
 * Ensure that PAC checksums are keyed.
------------------------------------------------------------------------
r24504 | tlyu | 2010-11-01 22:07:42 -0400 (Mon, 01 Nov 2010) | 1 line
Changed paths:
   M /branches/krb5-1-9/src/patchlevel.h

krb5-1.9-beta1-postrelease
------------------------------------------------------------------------
r24502 | tlyu | 2010-11-01 22:06:23 -0400 (Mon, 01 Nov 2010) | 1 line
Changed paths:
   M /branches/krb5-1-9/README
   M /branches/krb5-1-9/src/patchlevel.h

README and patchlevel.h for krb5-1.9-beta1
------------------------------------------------------------------------
r24501 | tlyu | 2010-11-01 16:36:48 -0400 (Mon, 01 Nov 2010) | 13 lines
Changed paths:
   M /branches/krb5-1-9/src/lib/krb5/krb/get_creds.c

ticket: 6812
version_fixed: 1.9
status: resolved

pull up r24488 from trunk

 ------------------------------------------------------------------------
 r24488 | ghudson | 2010-10-27 13:05:05 -0400 (Wed, 27 Oct 2010) | 5 lines

 ticket: 6812

 Don't fail out from krb5_get_credentials() if we can't store a ticket
 into the ccache.
------------------------------------------------------------------------
r24500 | tlyu | 2010-11-01 16:36:43 -0400 (Mon, 01 Nov 2010) | 16 lines
Changed paths:
   M /branches/krb5-1-9/src/include/k5-int.h

ticket: 6811
version_fixed: 1.9
status: resolved

pull up r24486 from trunk

 ------------------------------------------------------------------------
 r24486 | ghudson | 2010-10-26 13:34:41 -0400 (Tue, 26 Oct 2010) | 8 lines

 ticket: 6811
 subject: Mark Camellia-CCM code as experimental
 target_version: 1.9
 tags: pullup

 Add a comment noting that the Camellia-CCM code in 1.9 is
 experimental.
------------------------------------------------------------------------
r24499 | tlyu | 2010-11-01 16:36:37 -0400 (Mon, 01 Nov 2010) | 15 lines
Changed paths:
   M /branches/krb5-1-9/src/lib/gssapi/krb5/s4u_gss_glue.c

ticket: 6796
version_fixed: 1.9
status: resolved

pull up r24481 from trunk

 ------------------------------------------------------------------------
 r24481 | ghudson | 2010-10-25 16:17:54 -0400 (Mon, 25 Oct 2010) | 7 lines

 ticket: 6796
 target_version: 1.9
 tags: pullup

 Use safer output parameter handling in
 krb5_gss_acquire_cred_impersonate_name and its subsidiary helpers.
------------------------------------------------------------------------
r24498 | tlyu | 2010-11-01 16:36:33 -0400 (Mon, 01 Nov 2010) | 16 lines
Changed paths:
   M /branches/krb5-1-9/src/lib/gssapi/krb5/k5sealv3iov.c

ticket: 6809
version_fixed: 1.9
status: resolved

pull up r24483 from trunk

 ------------------------------------------------------------------------
 r24483 | ghudson | 2010-10-26 10:17:38 -0400 (Tue, 26 Oct 2010) | 8 lines

 ticket: 6809
 target_version: 1.9
 tags: pullup

 Set *conf_state on successful return from
 gss_krb5int_make_seal_token_v3_iov, fixing a case where it wasn't
 always set by gss_wrap_iov.  Patch from aberry@likewise.com.
------------------------------------------------------------------------
r24497 | tlyu | 2010-11-01 16:36:28 -0400 (Mon, 01 Nov 2010) | 16 lines
Changed paths:
   M /branches/krb5-1-9/src/lib/gssapi/krb5/accept_sec_context.c
   M /branches/krb5-1-9/src/lib/gssapi/krb5/acquire_cred.c
   M /branches/krb5-1-9/src/lib/gssapi/krb5/gssapiP_krb5.h
   M /branches/krb5-1-9/src/lib/gssapi/krb5/rel_cred.c
   M /branches/krb5-1-9/src/lib/gssapi/krb5/s4u_gss_glue.c

ticket: 6787
version_fixed: 1.9
status: resolved

pull up r24482 from trunk

 ------------------------------------------------------------------------
 r24482 | ghudson | 2010-10-25 17:55:54 -0400 (Mon, 25 Oct 2010) | 8 lines

 ticket: 6787
 target_version: 1.9
 tags: pullup

 When we create a temporary memory ccache for use within a
 krb5_gss_cred_id_rec, set a flag to indicate that the ccache should be
 destroyed rather than closed.  Patch from aberry@likewise.com.
------------------------------------------------------------------------
r24496 | tlyu | 2010-11-01 16:36:22 -0400 (Mon, 01 Nov 2010) | 16 lines
Changed paths:
   M /branches/krb5-1-9/src/lib/gssapi/krb5/acquire_cred.c

ticket: 6793
version_fixed: 1.9
status: resolved

pull up r24480 from trunk

 ------------------------------------------------------------------------
 r24480 | ghudson | 2010-10-25 15:37:03 -0400 (Mon, 25 Oct 2010) | 8 lines

 ticket: 6793
 target_version: 1.9
 tags: pullup

 In acquire_init_cred in the GSS krb5 mech, don't intern cred->name,
 since it's not used as an output parameter.  Fixes a memory leak.
 Reported by aberry@likewise.com.
------------------------------------------------------------------------
r24495 | tlyu | 2010-11-01 16:36:17 -0400 (Mon, 01 Nov 2010) | 18 lines
Changed paths:
   M /branches/krb5-1-9/src/configure.in
   M /branches/krb5-1-9/src/lib/crypto/crypto_tests/Makefile.in
   A /branches/krb5-1-9/src/lib/crypto/crypto_tests/t_fork.c
   M /branches/krb5-1-9/src/lib/crypto/nss/enc_provider/enc_gen.c

ticket: 6810
version_fixed: 1.9
status: resolved

pull up r24470 from trunk

 ------------------------------------------------------------------------
 r24470 | ghudson | 2010-10-22 20:38:17 -0400 (Fri, 22 Oct 2010) | 10 lines

 ticket: 6810
 subject: Better	libk5crypto NSS	fork safety
 target_version:	1.9
 tags: pullup

 Use SECMOD_RestartModules() from the forthcoming NSS 3.12.9 release to
 make the libk5crypto back end work after a fork.  Add a test program
 to exercise fork detection in the NSS back end.  Add a configure-time
 version check to ensure that we're using NSS 3.12.9 or later.
------------------------------------------------------------------------
r24494 | tlyu | 2010-11-01 15:49:44 -0400 (Mon, 01 Nov 2010) | 16 lines
Changed paths:
   M /branches/krb5-1-9/src/Makefile.in
   M /branches/krb5-1-9/src/configure.in
   M /branches/krb5-1-9/src/plugins/preauth/securid_sam2/Makefile.in
   A /branches/krb5-1-9/src/plugins/preauth/securid_sam2/README

ticket: 6807
version_fixed: 1.9
status: resolved

pull up r24467 from trunk

 ------------------------------------------------------------------------
 r24467 | hartmans | 2010-10-19 15:50:48 -0400 (Tue, 19 Oct 2010) | 8 lines

 ticket: 6807
 subject: SecurID build support
 target_version: 1.9
 tags: pullup

 Integrate SecurID into the build if libaceclnt is found.
 Add a README file with an example of how to build it.
------------------------------------------------------------------------
r24493 | tlyu | 2010-11-01 15:49:40 -0400 (Mon, 01 Nov 2010) | 16 lines
Changed paths:
   M /branches/krb5-1-9/src/plugins/preauth/securid_sam2/securid2.c
   M /branches/krb5-1-9/src/plugins/preauth/securid_sam2/securid_sam2_main.c

ticket: 6806
version_fixed: 1.9
status: resolved

pull up r24466 from trunk

 ------------------------------------------------------------------------
 r24466 | hartmans | 2010-10-19 15:50:42 -0400 (Tue, 19 Oct 2010) | 8 lines

 ticket: 6806
 subject: securID error handling fix
 target_version: 1.9
 tags: pullup

 In porting forward, I incorrectly used krb5_set_error_message instead of com_err.
 This commit reverts that change.
------------------------------------------------------------------------
r24492 | tlyu | 2010-11-01 15:49:36 -0400 (Mon, 01 Nov 2010) | 27 lines
Changed paths:
   M /branches/krb5-1-9/src/kdc/kdc_preauth.c
   M /branches/krb5-1-9/src/plugins/preauth/securid_sam2/extern.h
   M /branches/krb5-1-9/src/plugins/preauth/securid_sam2/securid2.c
   M /branches/krb5-1-9/src/plugins/preauth/securid_sam2/securid_sam2_main.c

ticket: 6805
version_fixed: 1.9
status: resolved

pull up r24465 from trunk

 ------------------------------------------------------------------------
 r24465 | hartmans | 2010-10-19 15:50:37 -0400 (Tue, 19 Oct 2010) | 19 lines

 ticket: 6805
 subject: securID code fixes
 target_version: 1.9
 tags: pullup

 Fixes to get securID preauth plugin working. A separate patch will
 address error handling and build issues.

 * Permit a preauth plugin to return KRB5KDC_ERR_PREAUTH_REQUIRED from
   the verify entry point.

 * If verify_securid2 fails, save the return value and return that
   rather than success after dealing with encoding the out_edata

 * Use the client key not the securid principal key for the sam
   checksum

 * indicate that securID is hardware authentication
------------------------------------------------------------------------
r24491 | tlyu | 2010-11-01 15:49:29 -0400 (Mon, 01 Nov 2010) | 17 lines
Changed paths:
   M /branches/krb5-1-9/doc/build.texinfo
   M /branches/krb5-1-9/src/configure.in
   M /branches/krb5-1-9/src/kdc/Makefile.in
   M /branches/krb5-1-9/src/kdc/extern.c
   M /branches/krb5-1-9/src/kdc/extern.h
   M /branches/krb5-1-9/src/kdc/kdc_util.c
   M /branches/krb5-1-9/src/kdc/kdc_util.h
   M /branches/krb5-1-9/src/kdc/main.c

ticket: 6804
version_fixed: 1.9
status: resolved

pull up r24464 from trunk

 ------------------------------------------------------------------------
 r24464 | ghudson | 2010-10-19 15:08:38 -0400 (Tue, 19 Oct 2010) | 9 lines

 ticket: 6804
 subject: Remove KDC replay cache
 target_version: 1.9
 tags: pullup

 Now that SAM1 support has been removed, the KDC does not need a replay
 replay cache.  Remove all code within USE_RCACHE and associated support.
 Rename --disable-kdc-replay-cache to --disable-kdc-lookaside-cache.
------------------------------------------------------------------------
r24490 | tlyu | 2010-11-01 15:21:45 -0400 (Mon, 01 Nov 2010) | 1 line
Changed paths:
   M /branches/krb5-1-9/README
   M /branches/krb5-1-9/src/patchlevel.h

Update README and patchlevel.h
------------------------------------------------------------------------
r24463 | tlyu | 2010-10-18 19:28:46 -0400 (Mon, 18 Oct 2010) | 11 lines
Changed paths:
   M /branches/krb5-1-9/NOTICE
   M /branches/krb5-1-9/doc/copyright.texinfo

ticket: 6802

pull up r24462 from trunk

 ------------------------------------------------------------------------
 r24462 | tlyu | 2010-10-18 18:52:28 -0400 (Mon, 18 Oct 2010) | 5 lines

 ticket: 6802

 Adjust copyright.texinfo to fix some TeX output issues.  Also do minor
 cleanup.
------------------------------------------------------------------------
r24457 | tlyu | 2010-10-15 16:42:30 -0400 (Fri, 15 Oct 2010) | 16 lines
Changed paths:
   M /branches/krb5-1-9/NOTICE
   M /branches/krb5-1-9/doc/Makefile
   M /branches/krb5-1-9/doc/admin.texinfo
   M /branches/krb5-1-9/doc/copyright.texinfo
   M /branches/krb5-1-9/doc/definitions.texinfo
   M /branches/krb5-1-9/doc/install.texinfo
   A /branches/krb5-1-9/doc/notice.texinfo
   M /branches/krb5-1-9/doc/user-guide.texinfo

ticket: 6802
version_fixed: 1.9

pull up r24455 from trunk

 ------------------------------------------------------------------------
 r24455 | tlyu | 2010-10-14 18:49:11 -0400 (Thu, 14 Oct 2010) | 9 lines

 ticket: 6802
 tags: pullup
 subject: copyright notice updates
 target_version: 1.9

 Update copyright.texinfo.  Move full copyright notices to appendices
 of documentation.  New rules to generate top-level NOTICE file from
 copyright.texinfo.  Regenerate NOTICE file.
------------------------------------------------------------------------
r24456 | tlyu | 2010-10-15 16:42:23 -0400 (Fri, 15 Oct 2010) | 31 lines
Changed paths:
   M /branches/krb5-1-9/src/config/pre.in
   M /branches/krb5-1-9/src/lib/krb5/krb/get_in_tkt.c

ticket: 6801
version_fixed: 1.9

pull up r24452, r24453, r24454 from trunk

 ------------------------------------------------------------------------
 r24454 | ghudson | 2010-10-13 13:20:36 -0400 (Wed, 13 Oct 2010) | 2 lines

 Whitespace.

 ------------------------------------------------------------------------
 r24453 | hartmans | 2010-10-12 21:19:20 -0400 (Tue, 12 Oct 2010) | 2 lines

 Adjust valgrind support to assume a modern valgrind that requires %p in log files.

 ------------------------------------------------------------------------
 r24452 | hartmans | 2010-10-12 21:19:14 -0400 (Tue, 12 Oct 2010) | 14 lines

 ticket: 6801
 target_version: 1.9
 Subject: Fix leaks in get_init_creds interface

 In Debian Bug 598032, Bastian Blank points out that there are two
 leaks in the get_init_creds interface:

 * Free ctx->request->padata after sending the KDC request so it is not
 overwritten the next time around the loop.

 * If options is NULL passed into krb5_get_init_creds_init, then set up
 a non-extended options structure so that krb5_get_init_creds_free will
 free the options.
------------------------------------------------------------------------
r24450 | tlyu | 2010-10-11 17:38:39 -0400 (Mon, 11 Oct 2010) | 1 line
Changed paths:
   A /branches/krb5-1-9 (from /trunk:24449)

branch krb5-1-9
------------------------------------------------------------------------
r24449 | tlyu | 2010-10-11 17:37:16 -0400 (Mon, 11 Oct 2010) | 1 line
Changed paths:
   M /trunk/NOTICE
   M /trunk/README

Interim update of README and NOTICE.
------------------------------------------------------------------------
r24448 | ghudson | 2010-10-11 12:43:42 -0400 (Mon, 11 Oct 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/krb5/keytab/kt_file.c

When returning KRB5_KT_NOTFOUND from krb5_ktfile_get_entry, set an
extended error message indicating which principal was not found.

------------------------------------------------------------------------
r24447 | ghudson | 2010-10-09 07:46:53 -0400 (Sat, 09 Oct 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/gssapi/mechglue/g_initialize.c

Plug a memory leak in gss_indicate_mechs.

------------------------------------------------------------------------
r24446 | tlyu | 2010-10-08 14:40:13 -0400 (Fri, 08 Oct 2010) | 2 lines
Changed paths:
   M /trunk/NOTICE
   M /trunk/src/include/gssrpc/auth.h
   M /trunk/src/include/gssrpc/auth_unix.h
   M /trunk/src/include/gssrpc/clnt.h
   M /trunk/src/include/gssrpc/netdb.h
   M /trunk/src/include/gssrpc/pmap_clnt.h
   M /trunk/src/include/gssrpc/pmap_prot.h
   M /trunk/src/include/gssrpc/pmap_rmt.h
   M /trunk/src/include/gssrpc/rpc.h
   M /trunk/src/include/gssrpc/rpc_msg.h
   M /trunk/src/include/gssrpc/svc.h
   M /trunk/src/include/gssrpc/svc_auth.h
   M /trunk/src/include/gssrpc/xdr.h
   M /trunk/src/lib/rpc/auth_none.c
   M /trunk/src/lib/rpc/auth_unix.c
   M /trunk/src/lib/rpc/authunix_prot.c
   M /trunk/src/lib/rpc/bindresvport.c
   M /trunk/src/lib/rpc/clnt_generic.c
   M /trunk/src/lib/rpc/clnt_perror.c
   M /trunk/src/lib/rpc/clnt_raw.c
   M /trunk/src/lib/rpc/clnt_simple.c
   M /trunk/src/lib/rpc/clnt_tcp.c
   M /trunk/src/lib/rpc/clnt_udp.c
   M /trunk/src/lib/rpc/get_myaddress.c
   M /trunk/src/lib/rpc/getrpcent.c
   M /trunk/src/lib/rpc/getrpcport.c
   M /trunk/src/lib/rpc/pmap_clnt.c
   M /trunk/src/lib/rpc/pmap_getmaps.c
   M /trunk/src/lib/rpc/pmap_getport.c
   M /trunk/src/lib/rpc/pmap_prot.c
   M /trunk/src/lib/rpc/pmap_prot2.c
   M /trunk/src/lib/rpc/pmap_rmt.c
   M /trunk/src/lib/rpc/rpc_callmsg.c
   M /trunk/src/lib/rpc/rpc_commondata.c
   M /trunk/src/lib/rpc/rpc_dtablesize.c
   M /trunk/src/lib/rpc/rpc_prot.c
   M /trunk/src/lib/rpc/svc.c
   M /trunk/src/lib/rpc/svc_auth.c
   M /trunk/src/lib/rpc/svc_auth_unix.c
   M /trunk/src/lib/rpc/svc_raw.c
   M /trunk/src/lib/rpc/svc_run.c
   M /trunk/src/lib/rpc/svc_simple.c
   M /trunk/src/lib/rpc/svc_tcp.c
   M /trunk/src/lib/rpc/svc_udp.c
   M /trunk/src/lib/rpc/xdr.c
   M /trunk/src/lib/rpc/xdr_alloc.c
   M /trunk/src/lib/rpc/xdr_array.c
   M /trunk/src/lib/rpc/xdr_float.c
   M /trunk/src/lib/rpc/xdr_mem.c
   M /trunk/src/lib/rpc/xdr_rec.c
   M /trunk/src/lib/rpc/xdr_reference.c
   M /trunk/src/lib/rpc/xdr_sizeof.c
   M /trunk/src/lib/rpc/xdr_stdio.c
   M /trunk/src/plugins/kdb/hdb/hdb.h
   M /trunk/src/plugins/kdb/hdb/windc_plugin.h

Encoding cleanup: curly quotes to ASCII quotes, and some ISO-8859-1
files to UTF-8.
------------------------------------------------------------------------
r24445 | ghudson | 2010-10-08 11:25:13 -0400 (Fri, 08 Oct 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/gssapi/mechglue/g_initialize.c

In gss_indicate_mechs, avoid setting the output pointer until success
is guaranteed.

------------------------------------------------------------------------
r24444 | ghudson | 2010-10-08 10:57:58 -0400 (Fri, 08 Oct 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/gssapi/mechglue/g_mechattr.c

In gss_inquire_attrs_for_mech, remove the assumption that mech_attrs
!= NULL in a particular error case.

------------------------------------------------------------------------
r24443 | ghudson | 2010-10-08 10:55:06 -0400 (Fri, 08 Oct 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/gssapi/spnego/spnego_mech.c

Remove duplicate code block in spnego_gss_set_cred_option().

------------------------------------------------------------------------
r24442 | tlyu | 2010-10-07 23:57:28 -0400 (Thu, 07 Oct 2010) | 11 lines
Changed paths:
   M /trunk/doc/admin.texinfo
   M /trunk/src/kadmin/cli/kadmin.M
   M /trunk/src/kadmin/cli/kadmin.c
   M /trunk/src/kadmin/cli/kadmin_ct.ct
   M /trunk/src/kadmin/server/kadm_rpc_svc.c
   M /trunk/src/kadmin/server/ovsec_kadmd.c
   M /trunk/src/kadmin/server/server_stubs.c
   M /trunk/src/lib/kadm5/admin.h
   M /trunk/src/lib/kadm5/clnt/client_principal.c
   M /trunk/src/lib/kadm5/clnt/client_rpc.c
   M /trunk/src/lib/kadm5/clnt/libkadm5clnt_mit.exports
   M /trunk/src/lib/kadm5/kadm_rpc.h
   M /trunk/src/lib/kadm5/kadm_rpc_xdr.c
   M /trunk/src/lib/kadm5/srv/libkadm5srv_mit.exports
   M /trunk/src/lib/kadm5/srv/svr_principal.c

ticket: 1219
status: open
target_version: 1.9

Add a kadm5 RPC for purging old keys from the KDB (e.g., from
change_password -keepold), and add a kadmin CLI command for it.

Keeping ticket open because an automated test needs to be added.

Long-term future work includes start/expire dates on keys, or
not-yet-valid flags.
------------------------------------------------------------------------
r24441 | ghudson | 2010-10-07 13:50:06 -0400 (Thu, 07 Oct 2010) | 6 lines
Changed paths:
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kerberos.ldif

ticket: 6701
target_version: 1.8.4
tags: pullup

Fix a typo in kerberos.ldif.  Reported by nalin@redhat.com.

------------------------------------------------------------------------
r24440 | ghudson | 2010-10-07 13:49:44 -0400 (Thu, 07 Oct 2010) | 7 lines
Changed paths:
   M /trunk/src/lib/kadm5/srv/svr_policy.c
   M /trunk/src/lib/krb5/error_tables/kdb5_err.et
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_pwd_policy.c

ticket: 6799
subject: Performance issue in LDAP policy fetch

Instead of performing a tree search to fill in the refcnt field of a
policy object whenever a policy is fetched, set the refcnt to 0 and
perform a check when policies are deleted.

------------------------------------------------------------------------
r24438 | tlyu | 2010-10-06 19:57:37 -0400 (Wed, 06 Oct 2010) | 10 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/get_in_tkt.c

ticket: 6798
subject: set NT-SRV-INST on TGS principal names
tags: pullup
target_version: 1.8.4

Set NT-SRV-INST on TGS principal names in
get_in_tkt.c:build_in_tkt_name because Windows Server 2008 R2 RODC
insists on it.

Thanks to Bill Fellows for reporting this problem.
------------------------------------------------------------------------
r24437 | ghudson | 2010-10-06 18:20:34 -0400 (Wed, 06 Oct 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/gssapi/generic/gssapi_generic.c

Correct a miscarriage of justice committed by the style police.

------------------------------------------------------------------------
r24436 | ghudson | 2010-10-06 14:25:04 -0400 (Wed, 06 Oct 2010) | 2 lines
Changed paths:
   M /trunk/src/appl/gss-sample/gss-client.c
   M /trunk/src/appl/gss-sample/gss-server.c
   M /trunk/src/lib/gssapi/generic/gssapi.hin
   M /trunk/src/lib/gssapi/generic/gssapiP_generic.h
   M /trunk/src/lib/gssapi/generic/gssapi_generic.c
   M /trunk/src/lib/gssapi/generic/util_buffer.c
   M /trunk/src/lib/gssapi/krb5/gssapi_krb5.c
   M /trunk/src/lib/gssapi/libgssapi_krb5.exports
   M /trunk/src/lib/gssapi/mechglue/Makefile.in
   M /trunk/src/lib/gssapi/mechglue/g_initialize.c
   A /trunk/src/lib/gssapi/mechglue/g_mechattr.c (from /users/lhoward/sasl-gs2/src/lib/gssapi/mechglue/g_mechattr.c:24434)
   A /trunk/src/lib/gssapi/mechglue/g_saslname.c (from /users/lhoward/sasl-gs2/src/lib/gssapi/mechglue/g_saslname.c:24434)
   M /trunk/src/lib/gssapi/mechglue/mglueP.h
   M /trunk/src/lib/gssapi/spnego/gssapiP_spnego.h
   M /trunk/src/lib/gssapi/spnego/spnego_mech.c
   M /trunk/src/tests/gssapi/Makefile.in
   A /trunk/src/tests/gssapi/t_saslname.c (from /users/lhoward/sasl-gs2/src/tests/gssapi/t_saslname.c:24434)

Merge users/lhoward/sasl-gs2 to trunk.

------------------------------------------------------------------------
r24433 | tsitkova | 2010-10-05 23:00:03 -0400 (Tue, 05 Oct 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/crypto/krb/prng/fortuna/entropy.c
   M /trunk/src/lib/crypto/krb/prng/fortuna/fortuna.h
   M /trunk/src/lib/crypto/krb/prng/fortuna/prng_fortuna.c
   M /trunk/src/lib/crypto/krb/prng/nss/prng_nss.c
   M /trunk/src/lib/crypto/krb/prng/nss/prng_nss.h

Minor comments related changed. 

------------------------------------------------------------------------
r24432 | ghudson | 2010-10-05 21:37:24 -0400 (Tue, 05 Oct 2010) | 3 lines
Changed paths:
   M /trunk/src/prototype/prototype.c
   M /trunk/src/prototype/prototype.h

Adjust prototype files for easier extraction of copyright/license
statements, per mailing list discussion.

------------------------------------------------------------------------
r24430 | ghudson | 2010-10-05 17:44:14 -0400 (Tue, 05 Oct 2010) | 2 lines
Changed paths:
   M /trunk/src/include/krb5/krb5.hin

Document that krb5_get_error_message() never returns NULL.

------------------------------------------------------------------------
r24429 | tlyu | 2010-10-05 17:05:19 -0400 (Tue, 05 Oct 2010) | 13 lines
Changed paths:
   M /trunk/src/kdc/kdc_authdata.c

ticket: 6797
subject: CVE-2010-1322 KDC uninitialized pointer crash in authorization data handling (MITKRB5-SA-2010-006)
tags: pullup
target_version: 1.8.4

When the KDC receives certain TGS-REQ messages, it may dereference an
uninitialized pointer while processing authorization data, causing a
crash, or in rare cases, unauthorized information disclosure, ticket
modification, or execution of arbitrary code.  The crash may be
triggered by legitimate requests.

Correctly implement the filtering of authorization data items to avoid
leaving uninitialized pointers when omitting items.
------------------------------------------------------------------------
r24428 | epeisach | 2010-10-05 15:59:49 -0400 (Tue, 05 Oct 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/crypto/krb/prng/fortuna/Makefile.in

Add RUN_SETUP so make check works by setting the proper LD_LIBRARY_PATH


------------------------------------------------------------------------
r24427 | ghudson | 2010-10-05 15:44:26 -0400 (Tue, 05 Oct 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/crypto/crypto_tests/Makefile.in
   M /trunk/src/lib/crypto/krb/Makefile.in
   M /trunk/src/lib/crypto/krb/prng/nss/Makefile.in

Fix the NSS PRNG build.  Fix the build for non-gmake make.  Revert a
no longer necessary change to lib/crypto/krb/Makefile.in.

------------------------------------------------------------------------
r24426 | ghudson | 2010-10-05 12:39:59 -0400 (Tue, 05 Oct 2010) | 3 lines
Changed paths:
   M /trunk/src/include/krb5/kadm5_hook_plugin.h

Constify the name field of a kadm5_hook vtable, since it holds a
string literal.

------------------------------------------------------------------------
r24425 | ghudson | 2010-10-05 12:00:23 -0400 (Tue, 05 Oct 2010) | 3 lines
Changed paths:
   M /trunk/src/include/krb5/pwqual_plugin.h
   M /trunk/src/lib/kadm5/server_internal.h
   M /trunk/src/lib/kadm5/srv/pwqual.c
   M /trunk/src/lib/kadm5/srv/pwqual_dict.c
   M /trunk/src/lib/kadm5/srv/pwqual_empty.c
   M /trunk/src/lib/kadm5/srv/pwqual_hesiod.c
   M /trunk/src/lib/kadm5/srv/pwqual_princ.c
   M /trunk/src/lib/kadm5/srv/server_misc.c

Add a name field to the pwqual plugin vtable and log pwqual module
rejections.

------------------------------------------------------------------------
r24424 | ghudson | 2010-10-05 10:53:09 -0400 (Tue, 05 Oct 2010) | 9 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/kadmin/cli/kadmin.c
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/lib/kdb/libkdb5.exports
   M /trunk/src/plugins/kdb/db2/lockout.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kerberos.ldif
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kerberos.schema
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_misc.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_principal.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_principal.h
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_principal2.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_service_rights.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/lockout.c
   M /trunk/src/tests/t_lockout.py

ticket: 6795
subject: Propagate modprinc -unlock from master to slave KDCs

Create a new tl-data type to hold the time of the last administrative
unlock, and factor it into decisions about account lockout.  Since
tl-data values are propagated from master to slave, this will cause
modprinc -unlock operations to reach slave KDCs on the next
propagation.

------------------------------------------------------------------------
r24423 | hartmans | 2010-10-05 09:57:27 -0400 (Tue, 05 Oct 2010) | 1 line
Changed paths:
   M /trunk/src/plugins/preauth/securid_sam2/securid2.c

Add additional NRL copyright
------------------------------------------------------------------------
r24422 | hartmans | 2010-10-05 09:57:23 -0400 (Tue, 05 Oct 2010) | 5 lines
Changed paths:
   M /trunk/doc/admin.texinfo
   M /trunk/src/config-files/krb5.conf.M
   M /trunk/src/include/krb5/kadm5_hook_plugin.h

Document kadm5_hook interface

* krb5.conf
* admin.texinfo
* kadm5_hook_plugin.h: document initvt requirement
------------------------------------------------------------------------
r24421 | tsitkova | 2010-10-04 23:29:35 -0400 (Mon, 04 Oct 2010) | 2 lines
Changed paths:
   A /trunk/src/lib/crypto/krb/prng/Makefile.in
   A /trunk/src/lib/crypto/krb/prng/deps
   A /trunk/src/lib/crypto/krb/prng/fortuna/Makefile.in
   A /trunk/src/lib/crypto/krb/prng/fortuna/deps
   A /trunk/src/lib/crypto/krb/prng/fortuna/entropy.c
   A /trunk/src/lib/crypto/krb/prng/fortuna/fortuna.h
   A /trunk/src/lib/crypto/krb/prng/fortuna/prng_fortuna.c
   A /trunk/src/lib/crypto/krb/prng/fortuna/t_fortuna.c
   A /trunk/src/lib/crypto/krb/prng/fortuna/t_fortuna_make_oct.c
   A /trunk/src/lib/crypto/krb/prng/fortuna/t_fortuna_make_oct.expected
   A /trunk/src/lib/crypto/krb/prng/nss/Makefile.in
   A /trunk/src/lib/crypto/krb/prng/nss/deps
   A /trunk/src/lib/crypto/krb/prng/nss/prng_nss.c
   A /trunk/src/lib/crypto/krb/prng/nss/prng_nss.h
   A /trunk/src/lib/crypto/krb/prng/prng.h
   A /trunk/src/lib/crypto/krb/prng/yarrow/prng_yarrow.c
   A /trunk/src/lib/crypto/nss/sha2/Makefile.in
   A /trunk/src/lib/crypto/nss/sha2/deps
   A /trunk/src/lib/crypto/nss/sha2/sha2.c
   A /trunk/src/lib/crypto/nss/sha2/sha2.h

Some missed files needed for rev #24420.

------------------------------------------------------------------------
r24420 | tsitkova | 2010-10-04 23:18:22 -0400 (Mon, 04 Oct 2010) | 5 lines
Changed paths:
   M /trunk/src/Makefile.in
   M /trunk/src/configure.in
   M /trunk/src/lib/crypto/Makefile.in
   M /trunk/src/lib/crypto/builtin/Makefile.in
   A /trunk/src/lib/crypto/builtin/sha2
   A /trunk/src/lib/crypto/builtin/sha2/Makefile.in
   A /trunk/src/lib/crypto/builtin/sha2/deps
   A /trunk/src/lib/crypto/builtin/sha2/sha2.h
   A /trunk/src/lib/crypto/builtin/sha2/sha256.c
   A /trunk/src/lib/crypto/builtin/sha2/t_sha256.c
   M /trunk/src/lib/crypto/crypto_tests/Makefile.in
   M /trunk/src/lib/crypto/krb/Makefile.in
   A /trunk/src/lib/crypto/krb/prng
   A /trunk/src/lib/crypto/krb/prng/fortuna
   A /trunk/src/lib/crypto/krb/prng/nss
   A /trunk/src/lib/crypto/krb/prng/prng.c (from /trunk/src/lib/crypto/krb/prng.c:24416)
   A /trunk/src/lib/crypto/krb/prng/yarrow (from /trunk/src/lib/crypto/krb/yarrow:24416)
   M /trunk/src/lib/crypto/krb/prng/yarrow/Makefile.in
   M /trunk/src/lib/crypto/krb/prng/yarrow/deps
   M /trunk/src/lib/crypto/krb/prng/yarrow/yarrow.h
   M /trunk/src/lib/crypto/krb/prng/yarrow/ycipher.c
   D /trunk/src/lib/crypto/krb/prng.c
   D /trunk/src/lib/crypto/krb/yarrow
   M /trunk/src/lib/crypto/nss/Makefile.in
   A /trunk/src/lib/crypto/nss/sha2
   M /trunk/src/lib/crypto/openssl/Makefile.in
   A /trunk/src/lib/crypto/openssl/sha2
   A /trunk/src/lib/crypto/openssl/sha2/Makefile.in
   A /trunk/src/lib/crypto/openssl/sha2/deps
   A /trunk/src/lib/crypto/openssl/sha2/sha2.h
   A /trunk/src/lib/crypto/openssl/sha2/sha256.c
   M /trunk/src/util/collected-client-lib/Makefile.in

Improves prng code modularity. Introduces fortuna-like prng that can be used in lieu of yarrow. 
Yarrow stays the default prng while fortuna may be engaged during configuration by using "--with-prng-alg=fortuna" flag.
Also, nss crypto backend continues to use its own prng.


------------------------------------------------------------------------
r24419 | tsitkova | 2010-10-04 23:01:01 -0400 (Mon, 04 Oct 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/crypto/openssl/des/des_int.h

Add mit_afs_string_to_key declaration

------------------------------------------------------------------------
r24418 | ghudson | 2010-10-04 20:16:10 -0400 (Mon, 04 Oct 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/crypto/nss/des/des_int.h

Add a missing protototype which was breaking the crypto build with the
NSS back end after r24409.

------------------------------------------------------------------------
r24417 | ghudson | 2010-10-04 14:23:00 -0400 (Mon, 04 Oct 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/kdb/kdb5.c

Protoize old-style function definitions in kdb5.c and normalize
formatting of definition headers.  No functional changes.

------------------------------------------------------------------------
r24416 | ghudson | 2010-10-02 13:21:54 -0400 (Sat, 02 Oct 2010) | 2 lines
Changed paths:
   M /trunk/NOTICE
   M /trunk/src/configure.in
   M /trunk/src/include/k5-int.h
   M /trunk/src/lib/crypto/Makefile.in
   M /trunk/src/lib/crypto/builtin/Makefile.in
   A /trunk/src/lib/crypto/builtin/init.c (from /branches/nss/src/lib/crypto/builtin/init.c:24415)
   M /trunk/src/lib/crypto/crypto_tests/Makefile.in
   M /trunk/src/lib/crypto/krb/Makefile.in
   M /trunk/src/lib/crypto/krb/crypto_libinit.c
   M /trunk/src/lib/crypto/krb/prng.c
   A /trunk/src/lib/crypto/nss (from /branches/nss/src/lib/crypto/nss:24415)
   M /trunk/src/lib/crypto/openssl/Makefile.in
   A /trunk/src/lib/crypto/openssl/init.c (from /branches/nss/src/lib/crypto/openssl/init.c:24415)

Merge branches/nss to trunk.

------------------------------------------------------------------------
r24415 | ghudson | 2010-10-02 13:17:35 -0400 (Sat, 02 Oct 2010) | 2 lines
Changed paths:
   M /trunk/src/plugins/preauth/securid_sam2/extern.h
   M /trunk/src/plugins/preauth/securid_sam2/securid2.c
   M /trunk/src/plugins/preauth/securid_sam2/securid_sam2_main.c

Copyright statements, whitespace, and other code formatting.

------------------------------------------------------------------------
r24413 | ghudson | 2010-10-02 07:48:06 -0400 (Sat, 02 Oct 2010) | 6 lines
Changed paths:
   M /trunk/src/lib/krb5/os/kuserok.c

ticket: 6792

In the krb5_kuserok implementation, fix an unintentional type change
to "gobble" (was an int, was accidentally changed to a char) which
could result in an infinite loop.

------------------------------------------------------------------------
r24412 | ghudson | 2010-10-02 07:34:27 -0400 (Sat, 02 Oct 2010) | 2 lines
Changed paths:
   M /trunk/src/tests/gssapi/t_gssexts.c

Fix type errors in t_gssexts.

------------------------------------------------------------------------
r24411 | ghudson | 2010-10-02 07:30:50 -0400 (Sat, 02 Oct 2010) | 3 lines
Changed paths:
   M /trunk/src/tests/gssapi/t_gssexts.c

Eliminate K&R-style function definition headers in t_gssexts.c, and
reformat other definitions according to coding practices.

------------------------------------------------------------------------
r24410 | raeburn | 2010-10-01 23:29:37 -0400 (Fri, 01 Oct 2010) | 1 line
Changed paths:
   M /trunk/src/lib/gssapi/spnego/spnego_mech.c

Use gss_set_cred_option instead of (undeclared) gssspi_set_cred_option.
------------------------------------------------------------------------
r24409 | raeburn | 2010-10-01 23:29:34 -0400 (Fri, 01 Oct 2010) | 7 lines
Changed paths:
   M /trunk/src/aclocal.m4

Try to require function declarations for GCC, as we already do for the
Sun compiler.

Change the cache variable name construction to distinguish "=" from
"-" in option names.  Prefer -Werror-implicit-function-declaration
over -Werror=implicit-function-declaration since in some versions of
GCC only the former works properly.
------------------------------------------------------------------------
r24407 | tlyu | 2010-10-01 16:15:00 -0400 (Fri, 01 Oct 2010) | 1 line
Changed paths:
   A /trunk/src/plugins/preauth/securid_sam2/deps

Add empty src/plugins/preauth/securid_sam2/deps to allow build to work again.
------------------------------------------------------------------------
r24406 | hartmans | 2010-10-01 13:12:41 -0400 (Fri, 01 Oct 2010) | 6 lines
Changed paths:
   M /trunk/src/kdc/do_as_req.c
   M /trunk/src/kdc/kdc_preauth.c
   M /trunk/src/lib/apputils/net-server.c
   M /trunk/src/lib/krb5/error_tables/k5e1_err.et

kdc: add KRB5KDC_ERR_DISCARD

Add an error to be returned by a preauth mechanism indicating that the KDC should not respond to a packet.

* Do not generate an error response in this case
* Drop a TCP connection if we are not going to respond to it.
------------------------------------------------------------------------
r24405 | hartmans | 2010-10-01 13:12:37 -0400 (Fri, 01 Oct 2010) | 2 lines
Changed paths:
   M /trunk/src/configure.in
   A /trunk/src/plugins/preauth/securid_sam2
   A /trunk/src/plugins/preauth/securid_sam2/Makefile.in (from /trunk/src/plugins/preauth/encrypted_challenge/Makefile.in:24404)
   A /trunk/src/plugins/preauth/securid_sam2/extern.h
   A /trunk/src/plugins/preauth/securid_sam2/securid2.c
   A /trunk/src/plugins/preauth/securid_sam2/securid_sam2.exports
   A /trunk/src/plugins/preauth/securid_sam2/securid_sam2_main.c

Initial securid2 support.
builds but untested
------------------------------------------------------------------------
r24404 | hartmans | 2010-10-01 13:12:30 -0400 (Fri, 01 Oct 2010) | 1 line
Changed paths:
   M /trunk/src/include/k5-int.h
   M /trunk/src/lib/krb5/asn.1/asn1_k_encode.c
   M /trunk/src/lib/krb5/libkrb5.exports

Enable sam_challenge_2 encoders
------------------------------------------------------------------------
r24403 | hartmans | 2010-10-01 13:12:26 -0400 (Fri, 01 Oct 2010) | 5 lines
Changed paths:
   M /trunk/src/kdc/kdc_preauth.c
   M /trunk/src/lib/krb5/krb/preauth2.c

preauth: remove pa-sam-challenge

Remove support for the old pa-sam-challenge and pa-sam-response
preauth type per discussion on krbdev.  The pa-sam-challenge-2 code
remains in the client.
------------------------------------------------------------------------
r24402 | ghudson | 2010-10-01 11:56:30 -0400 (Fri, 01 Oct 2010) | 5 lines
Changed paths:
   M /trunk/doc/admin.texinfo
   M /trunk/src/config-files/krb5.conf.M
   M /trunk/src/include/k5-int.h
   M /trunk/src/lib/krb5/os/kuserok.c

ticket: 6792
subject: Implement k5login_directory and k5login_authoritative options

Add and document two new options for controlling k5login behavior.

------------------------------------------------------------------------
r24401 | ghudson | 2010-10-01 09:44:12 -0400 (Fri, 01 Oct 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/krb5/os/Makefile.in
   A /trunk/src/lib/krb5/os/t_kuserok.c

Add a simple test harness for kuserok.  Build it during make check but
don't run any automated tests for the moment.

------------------------------------------------------------------------
r24400 | ghudson | 2010-09-30 23:47:38 -0400 (Thu, 30 Sep 2010) | 6 lines
Changed paths:
   M /trunk/src/include/krb5/krb5.hin
   M /trunk/src/lib/gssapi/krb5/init_sec_context.c
   M /trunk/src/lib/krb5/krb/auth_con.c
   M /trunk/src/lib/krb5/libkrb5.exports

ticket: 6768

A cleaner impleentation of r24399 which adds two new auth context APIs
(and is therefore less suitable for backporting to 1.8) but doesn't
reach inside the auth context structure in the krb5 mechanism code.

------------------------------------------------------------------------
r24399 | ghudson | 2010-09-30 23:45:43 -0400 (Thu, 30 Sep 2010) | 12 lines
Changed paths:
   M /trunk/src/lib/gssapi/krb5/init_sec_context.c

ticket: 6768
subject: GSSAPI forwarded credentials must be encrypted in session key
target_version: 1.8.4
tags: pullup

When IAKERB support was added, the krb5_mk_req checksum function
gained access to the send subkey.  This caused GSSAPI forwarded
credentials to be encrypted in the subkey, which violates RFC 4121
section 4.1.1 and is not accepted by Microsoft's implementation.
Temporarily null out the send subkey in the auth context so that
krb5_mk_ncred uses the session key instead.

------------------------------------------------------------------------
r24393 | ghudson | 2010-09-30 13:16:46 -0400 (Thu, 30 Sep 2010) | 1 line
Changed paths:
   M /trunk/src/plugins/kadm5_hook/test/main.c
   M /trunk/src/tests/Makefile.in
   M /trunk/src/tests/t_kadm5_hook.py

Whitespace.
------------------------------------------------------------------------
r24392 | ghudson | 2010-09-30 13:02:29 -0400 (Thu, 30 Sep 2010) | 1 line
Changed paths:
   M /trunk/src/include/krb5/kadm5_hook_plugin.h
   M /trunk/src/lib/kadm5/server_internal.h
   M /trunk/src/lib/kadm5/srv/kadm5_hook.c

Whitespace.
------------------------------------------------------------------------
r24391 | ghudson | 2010-09-30 13:01:30 -0400 (Thu, 30 Sep 2010) | 4 lines
Changed paths:
   M /trunk/src/lib/kadm5/srv/svr_principal.c

Use a different construction for defaulting ks_tuple and n_ks_tuple in
the libkadm5 server principal routines, to avoid repeated conditional
expressions.

------------------------------------------------------------------------
r24390 | ghudson | 2010-09-30 11:53:44 -0400 (Thu, 30 Sep 2010) | 2 lines
Changed paths:
   M /trunk/src/clients/kpasswd/kpasswd.c
   M /trunk/src/include/krb5/krb5.hin
   M /trunk/src/lib/krb5/krb/gic_opt.c

Whitespace and minor style changes.

------------------------------------------------------------------------
r24387 | ghudson | 2010-09-30 09:13:41 -0400 (Thu, 30 Sep 2010) | 2 lines
Changed paths:
   M /trunk/doc/admin.texinfo

Correct the admin documentation for auth_to_local.

------------------------------------------------------------------------
r24378 | ghudson | 2010-09-29 17:38:26 -0400 (Wed, 29 Sep 2010) | 5 lines
Changed paths:
   M /trunk/src/lib/krb5/error_tables/init_ets.c
   M /trunk/src/lib/krb5/krb5_libinit.c
   M /trunk/src/lib/krb5/libkrb5.exports

Follow-on to r24258: initialize the new k5e1 error table where we
initialize the krb5 error table, and add initialize_k5e1_error_table
to the libkrb5 exports list for consistency with the other error
tables.

------------------------------------------------------------------------
r24377 | hartmans | 2010-09-29 17:29:25 -0400 (Wed, 29 Sep 2010) | 2 lines
Changed paths:
   M /trunk/src/Makefile.in
   M /trunk/src/clients/kinit/deps
   M /trunk/src/lib/kadm5/srv/deps
   M /trunk/src/plugins/kadm5_hook/test/deps
   M /trunk/src/util/ss/deps

make depend
Add kadm5_hook test plugin to toplevel Makefile.in
------------------------------------------------------------------------
r24376 | hartmans | 2010-09-29 17:29:20 -0400 (Wed, 29 Sep 2010) | 3 lines
Changed paths:
   M /trunk/src/configure.in
   A /trunk/src/plugins/kadm5_hook
   A /trunk/src/plugins/kadm5_hook/test
   A /trunk/src/plugins/kadm5_hook/test/Makefile.in (from /trunk/src/plugins/preauth/wpse/Makefile.in:24375)
   A /trunk/src/plugins/kadm5_hook/test/deps (from /trunk/src/ccapi/test/deps:24375)
   A /trunk/src/plugins/kadm5_hook/test/kadm5_hook_test.exports
   A /trunk/src/plugins/kadm5_hook/test/main.c
   M /trunk/src/tests/Makefile.in
   A /trunk/src/tests/t_kadm5_hook.py

Automated tests for kadm5_hook plugin

Include a k5test Python test and test plugin for the kadm5_hook interface.
------------------------------------------------------------------------
r24375 | hartmans | 2010-09-29 17:29:14 -0400 (Wed, 29 Sep 2010) | 7 lines
Changed paths:
   M /trunk/src/include/k5-int.h
   A /trunk/src/include/krb5/kadm5_hook_plugin.h
   M /trunk/src/lib/kadm5/server_internal.h
   M /trunk/src/lib/kadm5/srv/Makefile.in
   A /trunk/src/lib/kadm5/srv/kadm5_hook.c
   M /trunk/src/lib/kadm5/srv/server_init.c
   M /trunk/src/lib/kadm5/srv/svr_principal.c
   M /trunk/src/lib/krb5/krb/plugin.c

ticket: 6791
subject: kadm5_hook: new plugin interface

Implement http://k5wiki.kerberos.org/wiki/Projects/Kadmin_hook_interface

This provides an interface that allows a plugin to track kadmin
operations. This can be used for projects like the krb5-sync project.
------------------------------------------------------------------------
r24370 | ghudson | 2010-09-28 15:09:11 -0400 (Tue, 28 Sep 2010) | 9 lines
Changed paths:
   M /trunk/src/lib/kdb/kdb_default.c

ticket: 6790
target_version: 1.8.4
tags: pullup

Make krb5_dbe_def_search_enctype skip key data entries with invalid
enctypes instead of erroring out on them.  We had this behavior prior
to 1.8 (more by accident than by design), but it changed as a
side-effect of r23599.

------------------------------------------------------------------------
r24363 | lhoward | 2010-09-27 14:51:55 -0400 (Mon, 27 Sep 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/gssapi/krb5/accept_sec_context.c
   M /trunk/src/lib/gssapi/krb5/iakerb.c
   M /trunk/src/lib/gssapi/krb5/init_sec_context.c
   M /trunk/src/lib/gssapi/krb5/rel_oid.c

Use IAKERB OID header for all IAKERB messages including AP-REQ

------------------------------------------------------------------------
r24360 | hartmans | 2010-09-27 13:16:47 -0400 (Mon, 27 Sep 2010) | 1 line
Changed paths:
   M /trunk/src/include/k5-buf.h

Doxygen for k5-buf.h
------------------------------------------------------------------------
r24359 | hartmans | 2010-09-27 13:16:41 -0400 (Mon, 27 Sep 2010) | 12 lines
Changed paths:
   M /trunk/src/clients/kpasswd/kpasswd.c
   M /trunk/src/include/krb5/krb5.hin
   M /trunk/src/lib/krb5/krb/gic_opt.c
   M /trunk/src/lib/krb5/libkrb5.exports
   M /trunk/src/tests/dejagnu/krb-standalone/kadmin.exp

ticket: 6786
subject: kpasswd: if a credential cache is present, use FAST

If a credentials cache is available, use it as an armor cache to enable FAST negotiation for kpasswd. This requires an attacker to attack both the user's long-term key for the old password as well as the ticket used for the armor cache in order to attack the password change. Depending on how the armor ticket is obtained, this may provide limited value. However, it provides users an easy option if they are concerned about their current password. Users can kinit with one principal to help protect changing the password of another principal.

* krb5_get_init_creds_opt_set_fast_ccache: new API to set fast ccache based on a krb5_ccache object rather than a resolvable string

* kpasswd: always open the current credential cache even if not needed
  for determining the principal. If the cache has tickets, use it as
  an armor cache.

* tests/dejagnu/krb-standalone/kadmin.exp: Arrange to test new code path
------------------------------------------------------------------------
r24357 | ghudson | 2010-09-26 23:46:57 -0400 (Sun, 26 Sep 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/gssapi/krb5/acquire_cred.c

Simplify acquire_accept_cred very slightly, avoiding some long lines
and repeated macro calls.

------------------------------------------------------------------------
r24356 | ghudson | 2010-09-26 23:39:22 -0400 (Sun, 26 Sep 2010) | 9 lines
Changed paths:
   M /trunk/src/lib/gssapi/generic/gssapi_ext.h
   M /trunk/src/lib/gssapi/krb5/acquire_cred.c
   M /trunk/src/lib/gssapi/krb5/copy_ccache.c
   M /trunk/src/lib/gssapi/krb5/gssapiP_krb5.h
   M /trunk/src/lib/gssapi/krb5/gssapi_krb5.c
   M /trunk/src/lib/gssapi/krb5/gssapi_krb5.hin
   M /trunk/src/lib/gssapi/krb5/krb5_gss_glue.c
   M /trunk/src/lib/gssapi/krb5/set_allowable_enctypes.c
   M /trunk/src/lib/gssapi/libgssapi_krb5.exports
   M /trunk/src/lib/gssapi/mechglue/g_set_cred_option.c
   M /trunk/src/lib/gssapi/mechglue/mglueP.h
   M /trunk/src/lib/gssapi/spnego/gssapiP_spnego.h
   M /trunk/src/lib/gssapi/spnego/spnego_mech.c
   M /trunk/src/lib/krb5/libkrb5.exports
   M /trunk/src/tests/gssapi/t_gssexts.c

ticket: 6785
subject: Add gss_krb5_import_cred

Add gss_krb5_import_cred from Heimdal; allows krb5 creds to be
acquired from a keytab or ccache into a GSSAPI credential without
using global process or thread variables.

Merged from the users/lhoward/import-cred branch.

------------------------------------------------------------------------
r24337 | ghudson | 2010-09-22 18:09:24 -0400 (Wed, 22 Sep 2010) | 4 lines
Changed paths:
   M /trunk/src/plugins/kdb/ldap/ldap_util/kdb5_ldap_util.c

Initialize kdb5_ldap_util's context with kadm5_init_krb5_context, like
kdb5_util does, in order to get the KDC profile settings as well as
the regular krb5 profile settings.

------------------------------------------------------------------------
r24336 | tlyu | 2010-09-22 17:50:48 -0400 (Wed, 22 Sep 2010) | 5 lines
Changed paths:
   M /trunk/NOTICE
   M /trunk/src/include/gssrpc/auth.h
   M /trunk/src/include/gssrpc/auth_unix.h
   M /trunk/src/include/gssrpc/clnt.h
   M /trunk/src/include/gssrpc/netdb.h
   M /trunk/src/include/gssrpc/pmap_clnt.h
   M /trunk/src/include/gssrpc/pmap_prot.h
   M /trunk/src/include/gssrpc/pmap_rmt.h
   M /trunk/src/include/gssrpc/rpc.h
   M /trunk/src/include/gssrpc/rpc_msg.h
   M /trunk/src/include/gssrpc/svc.h
   M /trunk/src/include/gssrpc/svc_auth.h
   M /trunk/src/include/gssrpc/types.hin
   M /trunk/src/include/gssrpc/xdr.h
   M /trunk/src/lib/rpc/auth_none.c
   M /trunk/src/lib/rpc/auth_unix.c
   M /trunk/src/lib/rpc/authunix_prot.c
   M /trunk/src/lib/rpc/bindresvport.c
   M /trunk/src/lib/rpc/clnt_generic.c
   M /trunk/src/lib/rpc/clnt_perror.c
   M /trunk/src/lib/rpc/clnt_raw.c
   M /trunk/src/lib/rpc/clnt_simple.c
   M /trunk/src/lib/rpc/clnt_tcp.c
   M /trunk/src/lib/rpc/clnt_udp.c
   M /trunk/src/lib/rpc/get_myaddress.c
   M /trunk/src/lib/rpc/getrpcent.c
   M /trunk/src/lib/rpc/getrpcport.c
   M /trunk/src/lib/rpc/pmap_clnt.c
   M /trunk/src/lib/rpc/pmap_getmaps.c
   M /trunk/src/lib/rpc/pmap_getport.c
   M /trunk/src/lib/rpc/pmap_prot.c
   M /trunk/src/lib/rpc/pmap_prot2.c
   M /trunk/src/lib/rpc/pmap_rmt.c
   M /trunk/src/lib/rpc/rpc_callmsg.c
   M /trunk/src/lib/rpc/rpc_commondata.c
   M /trunk/src/lib/rpc/rpc_dtablesize.c
   M /trunk/src/lib/rpc/rpc_prot.c
   M /trunk/src/lib/rpc/svc.c
   M /trunk/src/lib/rpc/svc_auth.c
   M /trunk/src/lib/rpc/svc_auth_unix.c
   M /trunk/src/lib/rpc/svc_raw.c
   M /trunk/src/lib/rpc/svc_run.c
   M /trunk/src/lib/rpc/svc_simple.c
   M /trunk/src/lib/rpc/svc_tcp.c
   M /trunk/src/lib/rpc/svc_udp.c
   M /trunk/src/lib/rpc/xdr.c
   M /trunk/src/lib/rpc/xdr_alloc.c
   M /trunk/src/lib/rpc/xdr_array.c
   M /trunk/src/lib/rpc/xdr_float.c
   M /trunk/src/lib/rpc/xdr_mem.c
   M /trunk/src/lib/rpc/xdr_rec.c
   M /trunk/src/lib/rpc/xdr_reference.c
   M /trunk/src/lib/rpc/xdr_sizeof.c
   M /trunk/src/lib/rpc/xdr_stdio.c

ticket: 6784
subject: relicense Sun RPC to 3-clause BSD-style

Per e-mail from Wim Coekaerts, Oracle America authorizes the
relicensing of Sun RPC to 3-clause BSD-style.
------------------------------------------------------------------------
r24335 | ghudson | 2010-09-20 14:25:18 -0400 (Mon, 20 Sep 2010) | 2 lines
Changed paths:
   M /trunk/src/gen-manpages/k5login.M

Adjust the k5login man page to have a slightly more neutral tone.

------------------------------------------------------------------------
r24329 | ghudson | 2010-09-19 08:03:18 -0400 (Sun, 19 Sep 2010) | 6 lines
Changed paths:
   M /trunk/src/kdc/main.c

Slight revisions to create_workers() in the KDC:
* Use calloc() to allocate the pids array; squashes a Coverity false
  positive.
* Don't leak the pids array in worker processes.
* Use consistent terminology in comments.

------------------------------------------------------------------------
r24328 | ghudson | 2010-09-17 13:42:31 -0400 (Fri, 17 Sep 2010) | 7 lines
Changed paths:
   M /trunk/src/include/net-server.h
   M /trunk/src/kadmin/server/ovsec_kadmd.c
   M /trunk/src/kdc/Makefile.in
   M /trunk/src/kdc/krb5kdc.M
   M /trunk/src/kdc/main.c
   A /trunk/src/kdc/t_workers.py
   M /trunk/src/lib/apputils/net-server.c

ticket: 6783
subject: KDC worker processes feature

Add support for a krb5kdc -w option which causes the KDC to spawn
worker processes which can process requests in parallel.  See also:
http://k5wiki.kerberos.org/wiki/Projects/Parallel_KDC

------------------------------------------------------------------------
r24327 | ghudson | 2010-09-17 12:06:34 -0400 (Fri, 17 Sep 2010) | 2 lines
Changed paths:
   M /trunk/src/util/k5test.py

Add an extra arguments parameter to k5test's realm.start_kdc().

------------------------------------------------------------------------
r24326 | ghudson | 2010-09-17 11:52:23 -0400 (Fri, 17 Sep 2010) | 4 lines
Changed paths:
   M /trunk/src/clients/kinit/kinit_kdb.c

In kinit_kdb_init(), ensure that we don't return an error with the
old, freed value of *pcontext still there--that would result in a
double free.

------------------------------------------------------------------------
r24324 | ghudson | 2010-09-16 13:38:30 -0400 (Thu, 16 Sep 2010) | 3 lines
Changed paths:
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/libkdb_ldap.exports

Follow-on to r24315: remove get/set_mkey_list from export list of
libkdb_ldap.

------------------------------------------------------------------------
r24323 | ghudson | 2010-09-15 18:43:00 -0400 (Wed, 15 Sep 2010) | 6 lines
Changed paths:
   M /trunk/src/plugins/preauth/pkinit/pkinit_crypto_openssl.c

ticket: 6774

In the PKINIT OpenSSL crypto code, use a signed int to hold the result
of X509_get_ext_by_NID so we can detect negative return values.
Reported by nalin@redhat.com.

------------------------------------------------------------------------
r24322 | ghudson | 2010-09-15 16:07:39 -0400 (Wed, 15 Sep 2010) | 2 lines
Changed paths:
   M /trunk/src/clients/kinit/kinit.M
   M /trunk/src/clients/kinit/kinit.c
   M /trunk/src/clients/kinit/kinit_kdb.c

Whitespace.

------------------------------------------------------------------------
r24319 | ghudson | 2010-09-15 13:45:31 -0400 (Wed, 15 Sep 2010) | 4 lines
Changed paths:
   M /trunk/src/clients/kinit/extern.h

Add a license statement to the new extern.h in kinit, use an include
blocker which does not impinge on the system's symbol namespace, and
use the recommended formatting for function prototypes.

------------------------------------------------------------------------
r24318 | ghudson | 2010-09-15 13:30:17 -0400 (Wed, 15 Sep 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/kdb/kdb5.c

Whitespace.

------------------------------------------------------------------------
r24317 | ghudson | 2010-09-15 13:22:57 -0400 (Wed, 15 Sep 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/kadm5/srv/svr_principal.c

Formatting fix.

------------------------------------------------------------------------
r24316 | hartmans | 2010-09-15 13:13:41 -0400 (Wed, 15 Sep 2010) | 13 lines
Changed paths:
   M /trunk/src/clients/kinit/Makefile.in
   A /trunk/src/clients/kinit/extern.h
   M /trunk/src/clients/kinit/kinit.M
   M /trunk/src/clients/kinit/kinit.c
   A /trunk/src/clients/kinit/kinit_kdb.c (from /trunk/src/lib/krb5/krb/etype_list.c:24315)
   M /trunk/src/tests/t_general.py

ticket: 6779
subject: kinit: add KDB keytab support

This implements
http://k5wiki.kerberos.org/Projects/What_does_God_need_with_a_password.
If the KDB keytab is selected by command line options, then kinit will
register the KDB keytab and open the database.  This permits an
administrator to obtain tickets as a user without knowing that user's
password.

As a result kinit links against libkadm5srv and libkdb5. Discussion is
ongoing about whether this is desirable or about whether two versions
of kinit are required.
------------------------------------------------------------------------
r24315 | hartmans | 2010-09-15 13:13:34 -0400 (Wed, 15 Sep 2010) | 3 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/plugins/kdb/db2/db2_exp.c
   M /trunk/src/plugins/kdb/db2/kdb_db2.c
   M /trunk/src/plugins/kdb/db2/kdb_db2.h
   M /trunk/src/plugins/kdb/ldap/ldap_exp.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/Makefile.in
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap.h
   D /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_fetch_mkey.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_realm.h

kdb: remove get/set_mkey_list

Remove dead code from DAL and kdb plugins.
------------------------------------------------------------------------
r24314 | hartmans | 2010-09-15 13:13:23 -0400 (Wed, 15 Sep 2010) | 18 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/kadmin/server/ovsec_kadmd.c
   M /trunk/src/kdc/do_as_req.c
   M /trunk/src/kdc/do_tgs_req.c
   M /trunk/src/kdc/kdc_preauth.c
   M /trunk/src/kdc/kdc_util.c
   M /trunk/src/kdc/main.c
   M /trunk/src/lib/kadm5/srv/svr_principal.c
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/lib/kdb/kdb5.h
   M /trunk/src/lib/kdb/keytab.c
   M /trunk/src/lib/kdb/libkdb5.exports
   M /trunk/src/tests/verify/kdb5_verify.c

ticket: 6778
subject: kdb: store mkey list in context and permit NULL mkey for kdb_dbe_decrypt_key_data

Previously, code needed to run a loop to find the current master key,
possibly fetch a new master key list and try finding the master key
again around each key decryption.  This was not universally done;
there are cases where only the current master key was used.  In
addition, the correct ideom for decrypting key data is too complicated
and is potentially unavailable to plugins that do not have access to
the master key.  Instead, store the master key list in the dal_handle
whenever it is fetched and permit a NULL master key for
krb5_dbe_decrypt_key_data.

* Remove APIs for krb5_db_{get|set}_mkey_list
* krb5_db_fetch_mkey_list: memoize master key list in dal_handle
* krb5_db_free_mkey_list: don't free the memoized list; arrange for it to be freed later
* krb5_dbe_decrypt_key_data: Search for correct master key on NULL argument
* change call sites to take advantage
------------------------------------------------------------------------
r24313 | ghudson | 2010-09-15 13:10:05 -0400 (Wed, 15 Sep 2010) | 5 lines
Changed paths:
   M /trunk/src/plugins/preauth/pkinit/pkinit_crypto_openssl.c

ticket: 6775

In the PKINIT OpenSSL code, ensure that appropriate cerficiate fields
have been set before using ku_reject.  Patch from nalin@redhat.com.

------------------------------------------------------------------------
r24312 | ghudson | 2010-09-15 13:06:43 -0400 (Wed, 15 Sep 2010) | 5 lines
Changed paths:
   M /trunk/src/plugins/preauth/pkinit/pkinit_crypto_openssl.c

ticket: 6776

Use correct CRL stack macros in pkinit OpenSSL code.  Patch from Olaf
Flebbe.

------------------------------------------------------------------------
r24311 | ghudson | 2010-09-15 12:51:31 -0400 (Wed, 15 Sep 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/kdb/decrypt_key.c

Whitespace.

------------------------------------------------------------------------
r24310 | hartmans | 2010-09-15 12:40:32 -0400 (Wed, 15 Sep 2010) | 4 lines
Changed paths:
   M /trunk/src/lib/kdb/decrypt_key.c
   M /trunk/src/lib/kdb/encrypt_key.c

kdb: fix warnings

Fix warnings in encrypt_key and decrypt_key. Avoid a segfault if NULL
master key is passed into default decryption function.
------------------------------------------------------------------------
r24309 | ghudson | 2010-09-15 11:50:15 -0400 (Wed, 15 Sep 2010) | 5 lines
Changed paths:
   M /trunk/src/lib/krb5/os/sn2princ.c

ticket: 6777

In krb5_sname_to_principal, correctly handle failures from
krb5_build_principal.

------------------------------------------------------------------------
r24304 | lhoward | 2010-09-09 11:54:32 -0400 (Thu, 09 Sep 2010) | 5 lines
Changed paths:
   M /trunk/src/lib/crypto/krb/verify_checksum_iov.c

Allow a zero checksum type to be passed into krb5_k_verify_checksum_iov;
this indicates that the mandatory checksum type for the key is to be used.
This interface is necessary because there is no public interface through
which the mandatory checksum type for an encryption type can be determined.

------------------------------------------------------------------------
r24303 | lhoward | 2010-09-09 11:39:47 -0400 (Thu, 09 Sep 2010) | 5 lines
Changed paths:
   M /trunk/src/lib/crypto/krb/make_checksum_iov.c

krb5_k_make_checksum will use the mandatory checksum type if 0 is
passed in as the checksum type; however krb5_k_make_checksum_iov
does not support this. Add the same logic for the behaviour is
consistent.

------------------------------------------------------------------------
r24299 | ghudson | 2010-09-08 13:38:22 -0400 (Wed, 08 Sep 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/crypto/openssl/Makefile.in

Add dummy camellia subdir to openssl back end makefile.

------------------------------------------------------------------------
r24298 | ghudson | 2010-09-07 23:51:31 -0400 (Tue, 07 Sep 2010) | 1 line
Changed paths:
   M /trunk/src/clients/ksu/deps
   M /trunk/src/clients/kvno/deps
   M /trunk/src/kadmin/cli/deps
   M /trunk/src/kadmin/dbutil/deps
   M /trunk/src/kadmin/ktutil/deps
   M /trunk/src/kadmin/server/deps
   M /trunk/src/kdc/deps
   M /trunk/src/lib/apputils/deps
   M /trunk/src/lib/crypto/builtin/camellia/deps
   M /trunk/src/lib/crypto/builtin/deps
   M /trunk/src/lib/crypto/builtin/des/deps
   M /trunk/src/lib/crypto/builtin/enc_provider/deps
   M /trunk/src/lib/crypto/builtin/hash_provider/deps
   M /trunk/src/lib/crypto/builtin/md4/deps
   M /trunk/src/lib/crypto/builtin/md5/deps
   M /trunk/src/lib/crypto/builtin/sha1/deps
   M /trunk/src/lib/crypto/crypto_tests/deps
   M /trunk/src/lib/crypto/krb/arcfour/deps
   M /trunk/src/lib/crypto/krb/checksum/deps
   M /trunk/src/lib/crypto/krb/crc32/deps
   M /trunk/src/lib/crypto/krb/deps
   M /trunk/src/lib/crypto/krb/dk/deps
   M /trunk/src/lib/crypto/krb/old/deps
   M /trunk/src/lib/crypto/krb/prf/deps
   M /trunk/src/lib/crypto/krb/rand2key/deps
   M /trunk/src/lib/crypto/krb/raw/deps
   M /trunk/src/lib/crypto/krb/yarrow/deps
   M /trunk/src/lib/gssapi/krb5/deps
   M /trunk/src/lib/gssapi/mechglue/deps
   M /trunk/src/lib/gssapi/spnego/deps
   M /trunk/src/lib/kadm5/clnt/deps
   M /trunk/src/lib/kadm5/deps
   M /trunk/src/lib/kadm5/srv/deps
   M /trunk/src/lib/kadm5/unit-test/deps
   M /trunk/src/lib/kdb/deps
   M /trunk/src/lib/krb5/asn.1/deps
   M /trunk/src/lib/krb5/ccache/deps
   M /trunk/src/lib/krb5/deps
   M /trunk/src/lib/krb5/error_tables/deps
   M /trunk/src/lib/krb5/keytab/deps
   M /trunk/src/lib/krb5/krb/deps
   M /trunk/src/lib/krb5/os/deps
   M /trunk/src/lib/krb5/rcache/deps
   M /trunk/src/lib/krb5/unicode/deps
   M /trunk/src/plugins/kdb/db2/deps
   M /trunk/src/plugins/kdb/ldap/deps
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/deps
   M /trunk/src/plugins/preauth/encrypted_challenge/deps
   M /trunk/src/plugins/preauth/pkinit/deps
   M /trunk/src/slave/deps
   M /trunk/src/tests/asn.1/deps
   M /trunk/src/tests/create/deps
   M /trunk/src/tests/hammer/deps
   M /trunk/src/tests/misc/deps
   M /trunk/src/tests/verify/deps

Make depend.
------------------------------------------------------------------------
r24297 | ghudson | 2010-09-07 23:48:05 -0400 (Tue, 07 Sep 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/crypto/builtin/camellia/camellia-gen.c
   M /trunk/src/lib/crypto/builtin/camellia/camellia.c

Don't build the built-in Camellia block cipher code if Camellia-CCM
enctypes aren't enabled.

------------------------------------------------------------------------
r24296 | ghudson | 2010-09-07 23:15:49 -0400 (Tue, 07 Sep 2010) | 4 lines
Changed paths:
   M /trunk/src/plugins/preauth/pkinit/pkinit_crypto_openssl.c

X509_verify_cert can return without setting cert_ctx.current_cert.  If
it does, don't dereference a null pointer when creating the pkiDebug
message.

------------------------------------------------------------------------
r24295 | ghudson | 2010-09-07 13:54:15 -0400 (Tue, 07 Sep 2010) | 6 lines
Changed paths:
   M /trunk/src/configure.in
   M /trunk/src/include/k5-int.h
   M /trunk/src/lib/crypto/Makefile.in
   M /trunk/src/lib/crypto/builtin/Makefile.in
   A /trunk/src/lib/crypto/builtin/camellia (from /branches/camellia-ccm/src/lib/crypto/builtin/camellia:24294)
   M /trunk/src/lib/crypto/builtin/des/d3_aead.c
   M /trunk/src/lib/crypto/builtin/des/f_aead.c
   M /trunk/src/lib/crypto/builtin/enc_provider/Makefile.in
   M /trunk/src/lib/crypto/builtin/enc_provider/aes.c
   A /trunk/src/lib/crypto/builtin/enc_provider/camellia_ctr.c (from /branches/camellia-ccm/src/lib/crypto/builtin/enc_provider/camellia_ctr.c:24294)
   M /trunk/src/lib/crypto/builtin/enc_provider/enc_provider.h
   M /trunk/src/lib/crypto/crypto_tests/Makefile.in
   A /trunk/src/lib/crypto/crypto_tests/camellia-expect-vt.txt (from /branches/camellia-ccm/src/lib/crypto/crypto_tests/camellia-expect-vt.txt:24294)
   A /trunk/src/lib/crypto/crypto_tests/camellia-test.c (from /branches/camellia-ccm/src/lib/crypto/crypto_tests/camellia-test.c:24294)
   A /trunk/src/lib/crypto/crypto_tests/t_camellia_ccm.c (from /branches/camellia-ccm/src/lib/crypto/crypto_tests/t_camellia_ccm.c:24294)
   A /trunk/src/lib/crypto/crypto_tests/t_cmac.c (from /branches/camellia-ccm/src/lib/crypto/crypto_tests/t_cmac.c:24294)
   M /trunk/src/lib/crypto/crypto_tests/t_encrypt.c
   M /trunk/src/lib/crypto/crypto_tests/t_short.c
   A /trunk/src/lib/crypto/crypto_tests/t_str2key.c (from /branches/camellia-ccm/src/lib/crypto/crypto_tests/t_str2key.c:24294)
   M /trunk/src/lib/crypto/crypto_tests/vectors.c
   M /trunk/src/lib/crypto/krb/Makefile.in
   M /trunk/src/lib/crypto/krb/aead.c
   M /trunk/src/lib/crypto/krb/aead.h
   M /trunk/src/lib/crypto/krb/checksum/Makefile.in
   A /trunk/src/lib/crypto/krb/checksum/cmac.c (from /branches/camellia-ccm/src/lib/crypto/krb/checksum/cmac.c:24294)
   M /trunk/src/lib/crypto/krb/cksumtypes.c
   M /trunk/src/lib/crypto/krb/cksumtypes.h
   M /trunk/src/lib/crypto/krb/combine_keys.c
   M /trunk/src/lib/crypto/krb/dk/Makefile.in
   D /trunk/src/lib/crypto/krb/dk/checksum.c
   A /trunk/src/lib/crypto/krb/dk/checksum_cmac.c (from /branches/camellia-ccm/src/lib/crypto/krb/dk/checksum_cmac.c:24294)
   A /trunk/src/lib/crypto/krb/dk/checksum_hmac.c (from /branches/camellia-ccm/src/lib/crypto/krb/dk/checksum_hmac.c:24294)
   M /trunk/src/lib/crypto/krb/dk/derive.c
   M /trunk/src/lib/crypto/krb/dk/dk.h
   M /trunk/src/lib/crypto/krb/dk/dk_aead.c
   A /trunk/src/lib/crypto/krb/dk/dk_ccm.c (from /branches/camellia-ccm/src/lib/crypto/krb/dk/dk_ccm.c:24294)
   M /trunk/src/lib/crypto/krb/dk/stringtokey.c
   M /trunk/src/lib/crypto/krb/etypes.c
   M /trunk/src/lib/crypto/krb/etypes.h
   M /trunk/src/lib/crypto/krb/prf/Makefile.in
   A /trunk/src/lib/crypto/krb/prf/cmac_prf.c (from /branches/camellia-ccm/src/lib/crypto/krb/prf/cmac_prf.c:24294)
   M /trunk/src/lib/crypto/krb/prf/dk_prf.c
   M /trunk/src/lib/crypto/krb/prf/prf_int.h
   M /trunk/src/lib/crypto/krb/rand2key/Makefile.in
   A /trunk/src/lib/crypto/krb/rand2key/camellia_rand2key.c (from /branches/camellia-ccm/src/lib/crypto/krb/rand2key/camellia_rand2key.c:24294)
   M /trunk/src/lib/crypto/krb/rand2key/rand2key.h
   M /trunk/src/lib/crypto/krb/state.c
   M /trunk/src/lib/crypto/libk5crypto.exports
   A /trunk/src/lib/crypto/openssl/camellia (from /branches/camellia-ccm/src/lib/crypto/openssl/camellia:24294)
   M /trunk/src/lib/crypto/openssl/enc_provider/Makefile.in
   A /trunk/src/lib/crypto/openssl/enc_provider/camellia_ctr.c (from /branches/camellia-ccm/src/lib/crypto/openssl/enc_provider/camellia_ctr.c:24294)
   M /trunk/src/lib/crypto/openssl/enc_provider/enc_provider.h
   M /trunk/src/lib/krb5/krb/init_ctx.c
   M /trunk/src/lib/krb5/krb/t_etypes.c
   M /trunk/src/tests/dejagnu/config/default.exp
   M /trunk/src/util/collected-client-lib/Makefile.in
   M /trunk/src/util/k5test.py
   M /trunk/src/windows/identity/plugins/krb5/datarep.c
   M /trunk/src/windows/identity/plugins/krb5/lang/en_us/langres.rc

Merge the camellia-ccm branch to trunk.  Since there are no IANA
assignments for Camellia-CCM enctypes or cksumtypes yet, they are
disabled in a default build.  They can be made available by defining
(via CPPFLAGS) local-use enctype numbers for the enctypes and
cksumtypes.

------------------------------------------------------------------------
r24292 | epeisach | 2010-09-04 17:46:53 -0400 (Sat, 04 Sep 2010) | 8 lines
Changed paths:
   M /trunk/src/lib/crypto/krb/yarrow/ycipher.c

ticket: 6772
subject: Ensure valid key in krb5int_yarrow_cipher_encrypt_block

Under low memory conditions (or when testing memory allocation failures), 
the key pointer will be 0 - and not initialized. Test and return failure
before deref a NULL.


------------------------------------------------------------------------
r24291 | epeisach | 2010-09-04 17:43:04 -0400 (Sat, 04 Sep 2010) | 6 lines
Changed paths:
   M /trunk/src/tests/verify/kdb5_verify.c

ticket: 6771
subject: Fix memory leaks in kdb5_verify

Minor leaks.  Just cleaning up code.


------------------------------------------------------------------------
r24290 | ghudson | 2010-09-04 10:50:27 -0400 (Sat, 04 Sep 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/kadm5/srv/pwqual.c

In k5_pwqual_load(), if the last vtable initializer fails, return 0
and not its exit value.

------------------------------------------------------------------------
r24289 | ghudson | 2010-09-03 18:24:25 -0400 (Fri, 03 Sep 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/kadm5/server_internal.h
   M /trunk/src/lib/kadm5/srv/pwqual.c
   M /trunk/src/lib/kadm5/srv/server_misc.c

Fix output argument ordering and handling in k5_pwqual_load().

------------------------------------------------------------------------
r24288 | ghudson | 2010-09-03 18:21:39 -0400 (Fri, 03 Sep 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/kadm5/srv/pwqual.c

Prevent a double free in k5_pwqual_load().

------------------------------------------------------------------------
r24287 | epeisach | 2010-09-02 22:43:21 -0400 (Thu, 02 Sep 2010) | 8 lines
Changed paths:
   M /trunk/src/lib/crypto/crypto_tests/t_prf.c
   M /trunk/src/lib/crypto/crypto_tests/t_short.c

ticket: 6769
subject: clean up memory leak and potential unused variable in crypto tests

t_prf.c:  Ensure prfsz is set before use (not exercised in current tests)

t_short.c: Fix memory leak


------------------------------------------------------------------------
r24286 | ghudson | 2010-09-02 11:35:25 -0400 (Thu, 02 Sep 2010) | 7 lines
Changed paths:
   M /trunk/src/kdc/kdc_authdata.c

ticket: 6764
tags: pullup
target_version: 1.8.4

Properly search for MANDATORY-FOR-KDC authdata elements.  Reported by
Mike Roszkowski.

------------------------------------------------------------------------
r24285 | ghudson | 2010-09-01 17:16:05 -0400 (Wed, 01 Sep 2010) | 3 lines
Changed paths:
   D /trunk/pwqual_combo

Oops, pwqual_combo wasn't supposed to make it out of the plugins2
branch.  Delete it.

------------------------------------------------------------------------
r24284 | ghudson | 2010-09-01 12:40:22 -0400 (Wed, 01 Sep 2010) | 8 lines
Changed paths:
   M /trunk/doc/admin.texinfo
   M /trunk/doc/krb5conf.texinfo
   A /trunk/pwqual_combo (from /branches/plugins2/pwqual_combo:24283)
   M /trunk/src/config-files/krb5.conf.M
   M /trunk/src/include/Makefile.in
   M /trunk/src/include/k5-int.h
   A /trunk/src/include/krb5/pwqual_plugin.h (from /branches/plugins2/src/include/krb5/pwqual_plugin.h:24283)
   M /trunk/src/lib/kadm5/kadm_err.et
   M /trunk/src/lib/kadm5/server_internal.h
   M /trunk/src/lib/kadm5/srv/Makefile.in
   M /trunk/src/lib/kadm5/srv/libkadm5srv_mit.exports
   A /trunk/src/lib/kadm5/srv/pwqual.c (from /branches/plugins2/src/lib/kadm5/srv/pwqual.c:24283)
   A /trunk/src/lib/kadm5/srv/pwqual_dict.c (from /branches/plugins2/src/lib/kadm5/srv/pwqual_dict.c:24283)
   A /trunk/src/lib/kadm5/srv/pwqual_empty.c (from /branches/plugins2/src/lib/kadm5/srv/pwqual_empty.c:24283)
   A /trunk/src/lib/kadm5/srv/pwqual_hesiod.c (from /branches/plugins2/src/lib/kadm5/srv/pwqual_hesiod.c:24283)
   A /trunk/src/lib/kadm5/srv/pwqual_princ.c (from /branches/plugins2/src/lib/kadm5/srv/pwqual_princ.c:24283)
   D /trunk/src/lib/kadm5/srv/server_dict.c
   M /trunk/src/lib/kadm5/srv/server_init.c
   M /trunk/src/lib/kadm5/srv/server_misc.c
   M /trunk/src/lib/kadm5/srv/svr_principal.c
   M /trunk/src/lib/krb5/krb/Makefile.in
   M /trunk/src/lib/krb5/krb/plugin.c

ticket: 6765
subject: Password quality pluggable interface

Merge branches/plugins2 to trunk.  Adds a password quality pluggable
interface described in this project page:

http://k5wiki.kerberos.org/wiki/Projects/Password_quality_pluggable_interface

------------------------------------------------------------------------
r24282 | ghudson | 2010-08-31 17:37:51 -0400 (Tue, 31 Aug 2010) | 4 lines
Changed paths:
   M /trunk/src/util/profile/prof_test1

ticket: 6761

Make the new profile tcl tests work with tcl 8.3.

------------------------------------------------------------------------
r24277 | ghudson | 2010-08-30 12:20:34 -0400 (Mon, 30 Aug 2010) | 5 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/plugin.c

ticket: 6763

Make relative plugin module paths be interpreted as relative to
LIBDIR/krb5/plugins.

------------------------------------------------------------------------
r24274 | ghudson | 2010-08-29 18:35:41 -0400 (Sun, 29 Aug 2010) | 4 lines
Changed paths:
   M /trunk/src/util/profile/prof_parse.c

ticket: 6761

Fix a resource leak in the profile include support.

------------------------------------------------------------------------
r24269 | ghudson | 2010-08-29 11:39:08 -0400 (Sun, 29 Aug 2010) | 2 lines
Changed paths:
   M /trunk/src/tests/Makefile.in
   A /trunk/src/tests/t_lockout.py

Add simple automated tests for account lockout support.

------------------------------------------------------------------------
r24268 | ghudson | 2010-08-29 11:32:04 -0400 (Sun, 29 Aug 2010) | 4 lines
Changed paths:
   M /trunk/src/kdc/kdc_util.c

Fix an account lockout error-handling regression by converting the
result of krb5_db_check_policy_as/tgs from a krb5_error_code to a
protocol error number.

------------------------------------------------------------------------
r24264 | tlyu | 2010-08-27 14:01:14 -0400 (Fri, 27 Aug 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/Makefile.in

ticket: 6763

Add plugin.o to T_ETYPES_OBJS because init_ctx.o needs it now.
------------------------------------------------------------------------
r24263 | ghudson | 2010-08-27 00:29:11 -0400 (Fri, 27 Aug 2010) | 6 lines
Changed paths:
   M /trunk/src/include/Makefile.in
   M /trunk/src/include/k5-int.h
   A /trunk/src/include/krb5/plugin.h (from /branches/plugins2/src/include/krb5/plugin.h:24262)
   M /trunk/src/lib/krb5/error_tables/k5e1_err.et
   M /trunk/src/lib/krb5/krb/Makefile.in
   M /trunk/src/lib/krb5/krb/init_ctx.c
   A /trunk/src/lib/krb5/krb/plugin.c (from /branches/plugins2/src/lib/krb5/krb/plugin.c:24262)
   M /trunk/src/lib/krb5/libkrb5.exports

ticket: 6763
subject: New plugin infrastructure

Merge domain-independent plugin framework code from branches/plugins2,
leaving out the password quality interface.

------------------------------------------------------------------------
r24258 | ghudson | 2010-08-26 12:59:37 -0400 (Thu, 26 Aug 2010) | 2 lines
Changed paths:
   M /trunk/src/Makefile.in
   M /trunk/src/include/Makefile.in
   M /trunk/src/lib/krb5/error_tables/Makefile.in
   A /trunk/src/lib/krb5/error_tables/k5e1_err.et

Add an expansion error table for libkrb5, since krb5_err.et is full.

------------------------------------------------------------------------
r24257 | hartmans | 2010-08-25 19:31:59 -0400 (Wed, 25 Aug 2010) | 1 line
Changed paths:
   M /trunk/src/lib/krb5/krb/rd_req_dec.c

rd_req_decoded: clarify behavior in comment
------------------------------------------------------------------------
r24256 | ghudson | 2010-08-25 14:22:53 -0400 (Wed, 25 Aug 2010) | 5 lines
Changed paths:
   M /trunk/doc/krb5conf.texinfo
   M /trunk/src/config-files/krb5.conf.M
   M /trunk/src/util/profile/prof_parse.c
   M /trunk/src/util/profile/prof_test1

ticket: 6761

Revise the profile include design so that included files are
syntactically independent of parent files.

------------------------------------------------------------------------
r24255 | ghudson | 2010-08-24 18:57:40 -0400 (Tue, 24 Aug 2010) | 4 lines
Changed paths:
   M /trunk/src/util/profile/prof_parse.c

ticket: 6761

Correct a comment.

------------------------------------------------------------------------
r24254 | ghudson | 2010-08-24 18:45:37 -0400 (Tue, 24 Aug 2010) | 7 lines
Changed paths:
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_misc.c

ticket: 6762

In the LDAP KDB module's populate_krb5_db_entry, fix the checks for
the KDB_PRINC_EXPIRE_TIME_ATTR and KDB_PWD_EXPIRE_TIME_ATTR flags so
that they properly succeed when the flags are set.  Bug report from
Rob Crittenden, patch from nalin@redhat.com.

------------------------------------------------------------------------
r24253 | ghudson | 2010-08-24 17:52:32 -0400 (Tue, 24 Aug 2010) | 7 lines
Changed paths:
   M /trunk/doc/krb5conf.texinfo
   M /trunk/src/config-files/krb5.conf.M
   M /trunk/src/util/profile
   M /trunk/src/util/profile/prof_err.et
   M /trunk/src/util/profile/prof_parse.c
   M /trunk/src/util/profile/prof_test1

ticket: 6761
subject: add profile include support

Add support for "include" and "includedir" directives in profile files.
See http://k5wiki.kerberos.org/wiki/Projects/Profile_Includes for more
details.

------------------------------------------------------------------------
r24250 | ghudson | 2010-08-23 18:03:25 -0400 (Mon, 23 Aug 2010) | 13 lines
Changed paths:
   M /trunk/src/util/profile/prof_init.c

ticket: 6760
subject: Fail properly when profile can't be accessed

Make profile_init() return EACCESS or EPERM if one of those errors was
encountered when failing to open any of the specified profile files.
This causes krb5_init_os_context() to fail properly when krb5.conf is
unreadable, instead of treating that situation like a nonexistent
krb5.conf.

The library will continue to soldier on if one profile file is
readable and another is not.  This is deliberate as of r14116, whether
or not it's a good idea.

------------------------------------------------------------------------
r24242 | ghudson | 2010-08-19 12:38:30 -0400 (Thu, 19 Aug 2010) | 10 lines
Changed paths:
   M /trunk/src/lib/gssapi/krb5/acquire_cred.c
   M /trunk/src/lib/gssapi/krb5/krb5_gss_glue.c

ticket: 6758
subject: Allow krb5_gss_register_acceptor_identity to unset keytab name

krb5_gss_register_acceptor_identity sets a mutex-locked global (not
thread-specific) variable containing a keytab name.  This change
allows the variable to be unset by passing a null value.

A more elegant long-term solution to the problem is Heimdal's
gss_krb5_import_cred function.

------------------------------------------------------------------------
r24241 | ghudson | 2010-08-12 13:41:41 -0400 (Thu, 12 Aug 2010) | 9 lines
Changed paths:
   M /trunk/src/include/k5-int.h
   M /trunk/src/include/krb5/krb5.hin
   M /trunk/src/lib/krb5/krb/Makefile.in
   M /trunk/src/lib/krb5/krb/gic_opt.c
   M /trunk/src/lib/krb5/krb/gic_pwd.c
   A /trunk/src/lib/krb5/krb/t_expire_warn.c
   A /trunk/src/lib/krb5/krb/t_expire_warn.py
   M /trunk/src/lib/krb5/libkrb5.exports

ticket: 6755
subject: Add GIC option for password/account expiration callback

Add a new GIC option to specify a callback to receive password and
account expiration times found in an AS reply.

See also:
http://k5wiki.kerberos.org/wiki/Projects/Password_expiration_API

------------------------------------------------------------------------
r24240 | ghudson | 2010-08-12 13:39:09 -0400 (Thu, 12 Aug 2010) | 6 lines
Changed paths:
   M /trunk/src/kdc/do_as_req.c

ticket: 2032

In AS replies, set the key-expiration field to the minimum of account
and password expiration time as specified in RFC 4120.  Reported by
Mary Cushion <mary@eiger.demon.co.uk>.

------------------------------------------------------------------------
r24239 | ghudson | 2010-08-12 13:15:17 -0400 (Thu, 12 Aug 2010) | 2 lines
Changed paths:
   M /trunk/src/util/k5test.py

Correct the documentation for the start_kadmind keyword in k5test.py.

------------------------------------------------------------------------
r24238 | ghudson | 2010-08-12 10:28:13 -0400 (Thu, 12 Aug 2010) | 1 line
Changed paths:
   D /trunk/src/lib/gssapi/generic/util_canonhost.c
   D /trunk/src/lib/gssapi/generic/util_localhost.c

Remove two unused source files in lib/gssapi/generic.
------------------------------------------------------------------------
r24237 | ghudson | 2010-08-10 15:02:23 -0400 (Tue, 10 Aug 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/gic_pwd.c

Move the password expiry warning code out of
krb5_get_init_creds_password() into a helper function.

------------------------------------------------------------------------
r24211 | ghudson | 2010-07-26 14:19:49 -0400 (Mon, 26 Jul 2010) | 4 lines
Changed paths:
   M /trunk/src/lib/kadm5/kadm_rpc_xdr.c

Use xdr_int32 instead of xdr_u_int in xdr_krb5_enctype(), since
enctypes are signed 32-bit values.  Wire representation does not
change.

------------------------------------------------------------------------
r24210 | ghudson | 2010-07-26 14:18:57 -0400 (Mon, 26 Jul 2010) | 16 lines
Changed paths:
   M /trunk/src/lib/rpc/xdr.c

ticket: 6753
subject: Fix XDR decoding of large values in xdr_u_int

Our ancient RPC value internally decodes 32-bit wire values into a
signed long, which is then casted to the appropriate type.
xdr_u_int() contains a check intended to catch wire values that don't
fit into a u_int on platforms with 16-ints, but on platforms with
64-bit longs it was failing on values of 2^31 or larger because the
sign-extended value appeared larger than UINT_MAX.  Fix the check by
casting the value to uint32_t before comparing.

This bug, in combination with a poor choice of types in
kadm_rpc_xdr.c's xdr_krb5_enctype(), prevented negative enctype values
from being transported properly in kadmin's change_password command
result.

------------------------------------------------------------------------
r24201 | ghudson | 2010-07-21 16:37:51 -0400 (Wed, 21 Jul 2010) | 5 lines
Changed paths:
   M /trunk/src/plugins/kdb/ldap/ldap_util/kdb5_ldap_util.c

ticket: 6749

Addendum to r24200: fix kdb5_ldap_util call site of
krb5_ldap_lib_init.

------------------------------------------------------------------------
r24200 | ghudson | 2010-07-21 15:01:35 -0400 (Wed, 21 Jul 2010) | 8 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/plugins/kdb/db2/db2_exp.c
   M /trunk/src/plugins/kdb/hdb/kdb_hdb.c
   M /trunk/src/plugins/kdb/ldap/ldap_exp.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap.h
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap_conn.c

ticket: 6749

Revert the part of r24157 which added the dal_version argument to the
init_library interface.  Instead use the already existing maj_ver
field of the DAL vtable to detect incompatibilities.  Since maj_ver
is a short int, use an incrementing number instead of a date for the
major version.

------------------------------------------------------------------------
r24193 | ghudson | 2010-07-20 04:52:41 -0400 (Tue, 20 Jul 2010) | 5 lines
Changed paths:
   M /trunk/src/plugins/kdb/hdb/kdb_hdb.c
   M /trunk/src/plugins/kdb/hdb/kdb_hdb.h
   M /trunk/src/plugins/kdb/hdb/kdb_marshal.c
   M /trunk/src/plugins/kdb/hdb/kdb_windc.c

ticket: 6749

Get the kdb_hdb module to compile again.  Probably still buggy,
particularly around the master key logic.

------------------------------------------------------------------------
r24192 | ghudson | 2010-07-19 06:05:13 -0400 (Mon, 19 Jul 2010) | 5 lines
Changed paths:
   M /trunk/src/plugins/kdb/ldap/ldap_util/kdb5_ldap_realm.c

ticket: 6749

In kdb5_util's kdb5_ldap_create(), add back the assignment of
rblock.key which was erroneously removed in r24162.

------------------------------------------------------------------------
r24191 | ghudson | 2010-07-19 01:01:45 -0400 (Mon, 19 Jul 2010) | 15 lines
Changed paths:
   M /trunk/src/lib/crypto/krb/checksum/hmac_md5.c
   M /trunk/src/lib/crypto/krb/cksumtypes.c

ticket: 6751
subject: Allow Microsoft HMAC-MD5 checksum types to use non-RC4 keys
target_version: 1.8.3
tags: pullup

In PAC signatures, the hmac-md5 checksum type can be used with AES
keys.  Make this work by removing the enc field from the hmac-md5 and
md5-hmac checksum types, and adding a check in
krb5int_hmacmd5_checksum() for a null key or a key which is longer
than the hash block size (64 bytes for MD5).  The checksum algorithm
only uses the key bits; it does invoke the cipher.

The checksum type names are kind of wrong, but we'll leave them alone
for compatibility.  The descriptions are updated.

------------------------------------------------------------------------
r24190 | ghudson | 2010-07-19 00:30:47 -0400 (Mon, 19 Jul 2010) | 3 lines
Changed paths:
   M /trunk/src/include/kdb.h

In the DAL documentation, describe how a module can supply referral
encrypted padata.

------------------------------------------------------------------------
r24189 | ghudson | 2010-07-15 00:18:00 -0400 (Thu, 15 Jul 2010) | 6 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/kdc/kdc_util.c
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/lib/kdb/libkdb5.exports
   M /trunk/src/plugins/kdb/db2/Makefile.in
   M /trunk/src/plugins/kdb/db2/db2_exp.c
   M /trunk/src/plugins/kdb/db2/kdb_db2.h
   D /trunk/src/plugins/kdb/db2/kdb_ext.c
   M /trunk/src/plugins/kdb/ldap/ldap_exp.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/Makefile.in
   D /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ext.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap.h
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/libkdb_ldap.exports

ticket: 6749

Add check_allowed_to_delegate to the DAL with a corresponding libkdb5
API, replacing the last method (CHECK_ALLOWED_TO_DELEGATE) of
db_invoke.  Remove db_invoke since it no longer has any methods.

------------------------------------------------------------------------
r24188 | ghudson | 2010-07-14 23:17:08 -0400 (Wed, 14 Jul 2010) | 6 lines
Changed paths:
   M /trunk/src/include/kdb.h

ticket: 6749
status: open

Addendum to r24182: Fix a comment referencing the db_invoke
SIGN_DB_AUTHDATA method.

------------------------------------------------------------------------
r24187 | ghudson | 2010-07-14 23:12:57 -0400 (Wed, 14 Jul 2010) | 6 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/kdc/kdc_util.c
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/lib/kdb/libkdb5.exports
   M /trunk/src/plugins/kdb/db2/db2_exp.c
   M /trunk/src/plugins/kdb/ldap/ldap_exp.c

ticket: 6749
status: open

Add refresh_config to the DAL with a corresponding libkdb5 API,
replacing the REFRESH_POLICY method of db_invoke.

------------------------------------------------------------------------
r24186 | ghudson | 2010-07-13 12:09:01 -0400 (Tue, 13 Jul 2010) | 7 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/kdc/kdc_util.c
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/plugins/kdb/db2/db2_exp.c
   M /trunk/src/plugins/kdb/db2/kdb_db2.c
   M /trunk/src/plugins/kdb/db2/kdb_db2.h
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap.h

ticket: 6749
status: open

Addendum to r24185: make audit_as_req return void, since it's an
informational method and we're not going to do anything with the
result.

------------------------------------------------------------------------
r24185 | ghudson | 2010-07-13 11:53:23 -0400 (Tue, 13 Jul 2010) | 9 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/kdc/kdc_util.c
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/lib/kdb/libkdb5.exports
   M /trunk/src/plugins/kdb/db2/db2_exp.c
   M /trunk/src/plugins/kdb/db2/kdb_db2.c
   M /trunk/src/plugins/kdb/db2/kdb_db2.h
   M /trunk/src/plugins/kdb/db2/kdb_ext.c
   M /trunk/src/plugins/kdb/ldap/ldap_exp.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ext.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap.h
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/libkdb_ldap.exports

ticket: 6749
status: open

Add audit_as_req to the DAL with a corresponding libkdb5 API,
replacing the AUDIT_AS_REQ method of db_invoke.  Remove the
AUDIT_TGS_REQ method of db_invoke without adding a replacement, as
there was no KDC support for it.  (It can be added at a later time if
necessary.)

------------------------------------------------------------------------
r24184 | ghudson | 2010-07-12 20:53:46 -0400 (Mon, 12 Jul 2010) | 7 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/kdc/kdc_util.c
   M /trunk/src/kdc/policy.c
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/lib/kdb/libkdb5.exports
   M /trunk/src/plugins/kdb/db2/db2_exp.c
   M /trunk/src/plugins/kdb/db2/kdb_db2.c
   M /trunk/src/plugins/kdb/db2/kdb_db2.h
   M /trunk/src/plugins/kdb/db2/kdb_ext.c
   M /trunk/src/plugins/kdb/ldap/ldap_exp.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ext.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap.h
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/libkdb_ldap.exports

ticket: 6749
status: open

Add check_policy_as and check_policy_tgs to the DAL table with
corresponding libkdb5 APIs, replacing the CHECK_POLICY_AS and
CHECK_POLICY_TGS methods of db_invoke.

------------------------------------------------------------------------
r24183 | ghudson | 2010-07-12 14:53:54 -0400 (Mon, 12 Jul 2010) | 6 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/kdc/kdc_util.c
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/lib/kdb/libkdb5.exports
   M /trunk/src/plugins/kdb/db2/db2_exp.c
   M /trunk/src/plugins/kdb/ldap/ldap_exp.c

ticket: 6749
status: open

Add check_transited_realms to the DAL table with a corresponding
libkdb5 API, replacing the CHECK_TRANSITED_REALMS method of db_invoke.

------------------------------------------------------------------------
r24182 | ghudson | 2010-07-12 14:33:05 -0400 (Mon, 12 Jul 2010) | 6 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/kdc/kdc_authdata.c
   M /trunk/src/kdc/kdc_util.c
   M /trunk/src/kdc/kdc_util.h
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/lib/kdb/libkdb5.exports
   M /trunk/src/plugins/kdb/db2/db2_exp.c
   M /trunk/src/plugins/kdb/ldap/ldap_exp.c

ticket: 6749
status: open

Add sign_authdata to the DAL table with a corresponding libkdb5 API,
replacing the SIGN_AUTH_DATA method of db_invoke.

------------------------------------------------------------------------
r24181 | ghudson | 2010-07-09 08:25:50 -0400 (Fri, 09 Jul 2010) | 3 lines
Changed paths:
   M /trunk/src/plugins/kdb/db2/adb_policy.c

Addendum to r24180: make sure osa_adb_get_policy sets its output
parameter in all cases, per coding standards.

------------------------------------------------------------------------
r24180 | ghudson | 2010-07-08 21:22:38 -0400 (Thu, 08 Jul 2010) | 3 lines
Changed paths:
   M /trunk/src/plugins/kdb/db2/adb_policy.c

Improve output variable handling of osa_adb_get_policy() in the db2
KDB module, and close some unlikely memory leaks.

------------------------------------------------------------------------
r24179 | ghudson | 2010-07-08 19:51:24 -0400 (Thu, 08 Jul 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/kadm5/clnt/client_init.c

Fix a memory leak in libkadm5clnt's get_init_creds().

------------------------------------------------------------------------
r24178 | ghudson | 2010-07-08 19:34:35 -0400 (Thu, 08 Jul 2010) | 8 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/kdc/do_as_req.c
   M /trunk/src/kdc/do_tgs_req.c
   M /trunk/src/lib/kadm5/srv/server_kdb.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_principal2.c

ticket: 6749
status: open

Create a KRB5_KDB_FLAG_ALIAS_OK to control whether plugin modules
should return in-realm aliases.  Set it where appropriate, and use it
in the LDAP module instead of intuiting the result based on other
flags.

------------------------------------------------------------------------
r24176 | ghudson | 2010-07-07 16:52:06 -0400 (Wed, 07 Jul 2010) | 7 lines
Changed paths:
   M /trunk/src/kdc/main.c

ticket: 6750
target_version: 1.8.3
tags: pullup

Add a missing break in the parsing of krb5kdc's -P option.  Reported
by nalin@redhat.com.

------------------------------------------------------------------------
r24175 | ghudson | 2010-07-06 17:53:23 -0400 (Tue, 06 Jul 2010) | 8 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/include/kdb_log.h
   M /trunk/src/kadmin/dbutil/dump.c
   M /trunk/src/kadmin/dbutil/kdb5_create.c
   M /trunk/src/kadmin/dbutil/kdb5_mkey.c
   M /trunk/src/kadmin/dbutil/kdb5_util.c
   M /trunk/src/kadmin/dbutil/ovload.c
   M /trunk/src/kdc/do_as_req.c
   M /trunk/src/kdc/do_tgs_req.c
   M /trunk/src/kdc/kdc_preauth.c
   M /trunk/src/kdc/kdc_util.c
   M /trunk/src/kdc/kdc_util.h
   M /trunk/src/lib/kadm5/server_internal.h
   M /trunk/src/lib/kadm5/srv/libkadm5srv_mit.exports
   M /trunk/src/lib/kadm5/srv/server_kdb.c
   M /trunk/src/lib/kadm5/srv/svr_policy.c
   M /trunk/src/lib/kadm5/srv/svr_principal.c
   M /trunk/src/lib/kadm5/unit-test/lock-test.c
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/lib/kdb/kdb5int.h
   M /trunk/src/lib/kdb/kdb_convert.c
   M /trunk/src/lib/kdb/kdb_cpw.c
   M /trunk/src/lib/kdb/kdb_default.c
   M /trunk/src/lib/kdb/kdb_log.c
   M /trunk/src/lib/kdb/keytab.c
   M /trunk/src/lib/kdb/libkdb5.exports
   M /trunk/src/plugins/kdb/db2/adb_policy.c
   M /trunk/src/plugins/kdb/db2/db2_exp.c
   M /trunk/src/plugins/kdb/db2/kdb_db2.c
   M /trunk/src/plugins/kdb/db2/kdb_db2.h
   M /trunk/src/plugins/kdb/db2/kdb_xdr.c
   M /trunk/src/plugins/kdb/db2/kdb_xdr.h
   M /trunk/src/plugins/kdb/db2/lockout.c
   M /trunk/src/plugins/kdb/db2/policy_db.h
   M /trunk/src/plugins/kdb/ldap/ldap_util/kdb5_ldap_realm.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_misc.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_principal.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_principal.h
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_principal2.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_pwd_policy.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_pwd_policy.h
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_realm.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/lockout.c
   M /trunk/src/tests/create/kdb5_mkdums.c
   M /trunk/src/tests/verify/kdb5_verify.c

ticket: 6749
status: open

Remove count parameters from get_principal, put_principal,
free_principal, delete_principal, and get_policy.  Make get_principal
allocate the DB entry container.  Fold krb5_db_get_principal_ext into
krb5_db_get_principal.

------------------------------------------------------------------------
r24174 | ghudson | 2010-07-04 14:34:04 -0400 (Sun, 04 Jul 2010) | 7 lines
Changed paths:
   M /trunk/src/plugins/kdb/ldap/ldap_util/kdb5_ldap_realm.c

ticket: 6749
status: open

Follow-on to r24168: in kdb5_ldap_util, indirect through
krb5_db_store_master_key instead of using the (now removed) default
implementation directly.

------------------------------------------------------------------------
r24173 | ghudson | 2010-07-03 15:56:17 -0400 (Sat, 03 Jul 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/kdb/kdb5.c

In kdb5.c, simplify the code for getting the profile config section.

------------------------------------------------------------------------
r24172 | ghudson | 2010-07-03 15:25:00 -0400 (Sat, 03 Jul 2010) | 6 lines
Changed paths:
   M /trunk/src/lib/kdb/kdb5.c

ticket: 6749
status: open

Remove assertions for non-nullity of init_module and fini_module in
kdb5.c for consistency with other uses of mandatory vtable functions.

------------------------------------------------------------------------
r24171 | ghudson | 2010-07-03 15:22:08 -0400 (Sat, 03 Jul 2010) | 7 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/lib/kdb/kdb_default.c

ticket: 6749

Make the APIs for iterate, get_master_key_list, set_master_key_list,
and promote_db return KRB5_PLUGIN_OP_NOTSUPP if the KDB module does
not implement them, avoiding the need for stub default
implementations.

------------------------------------------------------------------------
r24170 | ghudson | 2010-07-03 15:02:41 -0400 (Sat, 03 Jul 2010) | 7 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/kdc/kdc_authdata.c
   M /trunk/src/kdc/kdc_util.c
   M /trunk/src/kdc/policy.c
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/plugins/kdb/db2/kdb_ext.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ext.c

ticket: 6749
status: open

Use KRB5_PLUGIN_OP_NOTSUPP uniformly as the error code for operations
not supported by a KDB module.  (Previously KRB5_KDB_DBTYPE_NOSUP was
used in some cases and KRB5_PLUGIN_OP_NOTSUPP in others.)

------------------------------------------------------------------------
r24169 | raeburn | 2010-07-03 11:23:45 -0400 (Sat, 03 Jul 2010) | 1 line
Changed paths:
   M /trunk/src/plugins/kdb/db2/kdb_db2.c

Remove return value from void function.
------------------------------------------------------------------------
r24168 | ghudson | 2010-07-02 16:16:21 -0400 (Fri, 02 Jul 2010) | 6 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/lib/kdb/kdb_default.c
   M /trunk/src/lib/kdb/libkdb5.exports
   M /trunk/src/plugins/kdb/db2/db2_exp.c
   M /trunk/src/plugins/kdb/ldap/ldap_exp.c

ticket: 6749
status: open

Remove store_master_key from the DAL table, and implement
krb5_store_master_key in terms of krb5_store_master_key_list.

------------------------------------------------------------------------
r24167 | ghudson | 2010-07-02 15:18:12 -0400 (Fri, 02 Jul 2010) | 6 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/plugins/kdb/db2/db2_exp.c
   M /trunk/src/plugins/kdb/db2/kdb_db2.c
   M /trunk/src/plugins/kdb/db2/kdb_db2.h
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_principal.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_principal.h

ticket: 6749
status: open

Make krb5_db_free_principal and krb5_db_free_mkey_list return void.
Remove the stale prototype for krb5_db_free_master_key.

------------------------------------------------------------------------
r24166 | ghudson | 2010-07-02 15:09:20 -0400 (Fri, 02 Jul 2010) | 8 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/kadmin/dbutil/dump.c
   M /trunk/src/kadmin/dbutil/kdb5_util.c
   M /trunk/src/kdc/main.c
   M /trunk/src/lib/kadm5/srv/server_kdb.c
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/lib/kdb/kdb_default.c
   M /trunk/src/lib/kdb/libkdb5.exports
   M /trunk/src/plugins/kdb/db2/db2_exp.c
   M /trunk/src/plugins/kdb/ldap/ldap_exp.c
   M /trunk/src/tests/create/kdb5_mkdums.c
   M /trunk/src/tests/verify/kdb5_verify.c

ticket: 6749
status: open

Remove verify_master_key from the DAL table, as well as its associated
libkdb5 interface.  Callers can (and mostly already do) use
krb5_fetch_mkey_list to verify master keyblocks.  Adjust tests/create,
tests/verify, and kdb5_util dump to do so.

------------------------------------------------------------------------
r24165 | ghudson | 2010-07-02 13:58:41 -0400 (Fri, 02 Jul 2010) | 7 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/plugins/kdb/db2/db2_exp.c
   M /trunk/src/plugins/kdb/db2/kdb_db2.c
   M /trunk/src/plugins/kdb/db2/kdb_db2.h
   M /trunk/src/plugins/kdb/db2/lockout.c
   M /trunk/src/plugins/kdb/ldap/ldap_exp.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap.h
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/libkdb_ldap.exports

ticket: 6749
status: open

Remove db_ and similar prefixes from DAL function names, for
consistency.  Follow suit inside the DB2 and LDAP modules.  (No change
to the caller-facing libkdb5 APIs.)

------------------------------------------------------------------------
r24164 | ghudson | 2010-07-02 13:33:44 -0400 (Fri, 02 Jul 2010) | 6 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/kadmin/dbutil/dump.c
   M /trunk/src/kadmin/dbutil/kdb5_create.c
   M /trunk/src/kadmin/dbutil/kdb5_mkey.c
   M /trunk/src/kdc/do_as_req.c
   M /trunk/src/kdc/do_tgs_req.c
   M /trunk/src/kdc/kdc_preauth.c
   M /trunk/src/kdc/kdc_util.c
   M /trunk/src/lib/kadm5/srv/server_kdb.c
   M /trunk/src/lib/kadm5/srv/svr_principal.c
   M /trunk/src/lib/kdb/decrypt_key.c
   M /trunk/src/lib/kdb/encrypt_key.c
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/lib/kdb/kdb_cpw.c
   M /trunk/src/lib/kdb/kdb_default.c
   M /trunk/src/lib/kdb/keytab.c
   M /trunk/src/lib/kdb/libkdb5.exports
   M /trunk/src/plugins/kdb/ldap/ldap_util/kdb5_ldap_realm.c
   M /trunk/src/tests/create/kdb5_mkdums.c
   M /trunk/src/tests/verify/kdb5_verify.c

ticket: 6749
status: open

Rename krb5_dbekd_encrypt_key_data and krb5_dbekd_decrypt_key_data to
just use the krb5_dbe prefix.

------------------------------------------------------------------------
r24163 | ghudson | 2010-07-02 13:18:46 -0400 (Fri, 02 Jul 2010) | 5 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/plugins/kdb/db2/db2_exp.c
   M /trunk/src/plugins/kdb/ldap/ldap_exp.c

ticket: 6749
status: open

Remove setup_master_key_name from the DAL table as it was not used.

------------------------------------------------------------------------
r24162 | ghudson | 2010-07-02 13:13:40 -0400 (Fri, 02 Jul 2010) | 9 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/kadmin/dbutil/kdb5_util.c
   M /trunk/src/kadmin/server/ovsec_kadmd.c
   M /trunk/src/kdc/main.c
   M /trunk/src/lib/kadm5/srv/libkadm5srv_mit.exports
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/lib/kdb/kdb_default.c
   M /trunk/src/lib/kdb/libkdb5.exports
   M /trunk/src/plugins/kdb/db2/db2_exp.c
   M /trunk/src/plugins/kdb/db2/kdb_db2.c
   M /trunk/src/plugins/kdb/db2/kdb_db2.h
   M /trunk/src/plugins/kdb/ldap/ldap_exp.c
   M /trunk/src/plugins/kdb/ldap/ldap_util/kdb5_ldap_realm.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap.h
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_fetch_mkey.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_realm.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_realm.h
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/libkdb_ldap.exports

ticket: 6749
status: open

Remove the set_master_key and get_master_key DAL interfaces and their
corresponding libkdb5 APIs, as they were not productively used.  In
kdb5_ldap_util, stop using the realm data's mkey field as a container
to communicate the master key to static helper functions, since the
field no longer exists.

------------------------------------------------------------------------
r24161 | ghudson | 2010-07-02 12:59:33 -0400 (Fri, 02 Jul 2010) | 5 lines
Changed paths:
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap_conn.c

ticket: 6749

Follow-up to r24157: return correctly from krb5_ldap_lib_init() if
there is no version mismatch.

------------------------------------------------------------------------
r24160 | ghudson | 2010-07-02 10:41:26 -0400 (Fri, 02 Jul 2010) | 5 lines
Changed paths:
   M /trunk/src/plugins/kdb/ldap/ldap_util/kdb5_ldap_util.c

ticket: 6749

Follow-on to r24157: pass KRB5_KDB_DAL_VERSION to krb5_ldap_lib_init()
in kdb5_ldap_util.c.

------------------------------------------------------------------------
r24159 | ghudson | 2010-07-02 10:19:39 -0400 (Fri, 02 Jul 2010) | 7 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/plugins/kdb/db2/db2_exp.c
   M /trunk/src/plugins/kdb/ldap/ldap_exp.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap.h
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_misc.c

ticket: 6749
status: open

Remove errcode_2_string and release_errcode_string from the DAL table,
and stop using them in kdb5.c.  Modules can simply set error messages
in the krb5 context on error.

------------------------------------------------------------------------
r24158 | ghudson | 2010-07-02 10:08:20 -0400 (Fri, 02 Jul 2010) | 7 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/plugins/kdb/db2/db2_exp.c
   M /trunk/src/plugins/kdb/ldap/ldap_exp.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap.h
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_misc.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/libkdb_ldap.exports

ticket: 6749
status: open

Remove db_supported_realms and db_free_supported_realms from the DAL
table, and remove the corresponding libkdb5 interfaces (which don't
seem to have been in the library export table).

------------------------------------------------------------------------
r24157 | ghudson | 2010-07-01 23:23:21 -0400 (Thu, 01 Jul 2010) | 16 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/lib/kdb/Makefile.in
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/lib/krb5/error_tables/kdb5_err.et
   M /trunk/src/plugins/kdb/db2/db2_exp.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap.h
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap_conn.c

ticket: 6749
subject: DAL improvements
status: open

Add KRB5_KDB_API_VERSION to allow callers to adjust to incompatible
changes in libkdb; to be kept in sync with the libkdb major version,
which is bumped to 5 in anticipation of other changes.

Add KRB5_KDB_DAL_VERSION to allow database modules to detect when they
are mismatched with the KDB version.  Since KDB modules are often
developed concurrently with trunk code, this is defined to be the date
of the last incompatible DAL change.  The DAL version is passed to the
init_library DAL function; the module should check it against the value
of KRB5_KDB_DAL_VERSION it was compiled with and return
KRB5_KDB_DBTYPE_MISMATCH if it doesn't match.

------------------------------------------------------------------------
r24156 | ghudson | 2010-07-01 12:56:22 -0400 (Thu, 01 Jul 2010) | 14 lines
Changed paths:
   M /trunk/src/slave/kpropd.c

ticket: 6686

In kpropd, when getting a wildcard address to listen on, try IPv6
explicitly (with AI_ADDRCONFIG specified where available, to avoid
IPv6 on hosts with no IPv6 interface) and then fall back to IPv4.
Only set IPV6_V6ONLY on the listener socket if the resulting address
is IPv6.

Note: we have mostly confirmed that OpenBSD does not have dual-stack
support, meaning that it would be better to open separate IPv4 and
IPv6 listener sockets, as we do in krb5kdc and kadmind.
Unfortunately, the complicated iprop retry-and-backoff logic makes
this less than straightforward.

------------------------------------------------------------------------
r24153 | ghudson | 2010-06-30 12:45:47 -0400 (Wed, 30 Jun 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/apputils/net-server.c

Factor out a common socket creation sequence in net-server.c, which
happens to coincide with what setup_a_rpc_listener does.

------------------------------------------------------------------------
r24152 | ghudson | 2010-06-30 12:11:33 -0400 (Wed, 30 Jun 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/apputils/net-server.c

Eliminate warnings in net-server.c.

------------------------------------------------------------------------
r24151 | ghudson | 2010-06-30 12:03:22 -0400 (Wed, 30 Jun 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/apputils/net-server.c

Improve coding style conformance in net-server.c.

------------------------------------------------------------------------
r24148 | ghudson | 2010-06-26 13:37:20 -0400 (Sat, 26 Jun 2010) | 5 lines
Changed paths:
   M /trunk/src/lib/rpc/svc_tcp.c

ticket: 6746

Fix a bug in r24147 where svctcp_create() was passing the wrong length
argument to bind(), causing it to fail on Solaris.

------------------------------------------------------------------------
r24147 | ghudson | 2010-06-25 23:32:55 -0400 (Fri, 25 Jun 2010) | 21 lines
Changed paths:
   M /trunk/src/kadmin/testing/util/tcl_kadm5.c
   M /trunk/src/lib/apputils/net-server.c
   M /trunk/src/lib/kadm5/alt_prof.c
   M /trunk/src/lib/kadm5/clnt/client_init.c
   M /trunk/src/lib/kadm5/unit-test/api.current/init-v2.exp
   M /trunk/src/lib/rpc/clnt_tcp.c
   M /trunk/src/lib/rpc/svc_tcp.c

ticket: 6746
subject: Make kadmin work over IPv6

Make gssrpc work over IPv6 TCP sockets provided that the client
creates and connects/binds the sockets and doesn't query their
addresses or use bindresvport().  Make kadmin work within those
constraints and handle IPv6.  Specific changes:

* Make svctcp_create() able to extract the port from an IPv6 socket,
  using a new helper function getport().
* Make clnttcp_create() handle a null raddr value if *sockp is set.
* Make kadm5_get_service_name() use getaddrinfo() to canonicalize the
  admin server name.
* Make libkadm5clnt's init_any() responsible for connecting its socket
  using a new helper function connect_to_server(), which uses
  getaddrinfo instead of gethostbyname.  Pass a null address to
  clnttcp_create().
* Make libapputil's net-server.c set up IPv6 as well as IPv4 listener
  ports for RPC connections.
* Adjust the error code expected in a libkadm5 unit test.

------------------------------------------------------------------------
r24146 | ghudson | 2010-06-25 18:26:04 -0400 (Fri, 25 Jun 2010) | 4 lines
Changed paths:
   M /trunk/src/lib/kadm5/clnt/client_init.c

Adjust function names and declarations in libkadm5's client_init.c; in
particular, avoid the use of library namespace prefixes for static
helper functions.

------------------------------------------------------------------------
r24145 | ghudson | 2010-06-25 18:14:53 -0400 (Fri, 25 Jun 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/kadm5/clnt/client_init.c

Simplify the iprop conditionalization of _kadm5_init_any().

------------------------------------------------------------------------
r24144 | ghudson | 2010-06-22 09:09:58 -0400 (Tue, 22 Jun 2010) | 2 lines
Changed paths:
   M /trunk/src/kadmin/dbutil/kdb5_stash.c

Remove some dead code in kdb5_stash() left behind by r24142.

------------------------------------------------------------------------
r24143 | ghudson | 2010-06-22 08:52:03 -0400 (Tue, 22 Jun 2010) | 3 lines
Changed paths:
   M /trunk/src/slave/kprop_sock.c

In kprop's sockaddr2krbaddr(), fill in addr.magic to avoid copying
around uninitialized values.

------------------------------------------------------------------------
r24142 | ghudson | 2010-06-21 16:29:12 -0400 (Mon, 21 Jun 2010) | 3 lines
Changed paths:
   M /trunk/src/kadmin/dbutil/kdb5_stash.c

Eliminate a bunch of duplicated code in kdb5_stash() by using
util_context.

------------------------------------------------------------------------
r24141 | ghudson | 2010-06-21 15:56:29 -0400 (Mon, 21 Jun 2010) | 10 lines
Changed paths:
   M /trunk/src/kadmin/dbutil/kdb5_stash.c

ticket: 6345
target_version: 1.8.3
tags: pullup

kdb5_stash() contains its own kdb5_db_open() call (because it doesn't
use util_context for some reason), which didn't work with the LDAP
back end because LDAP doesn't recognize KRB5_KDB_SRV_TYPE_OTHER.  As a
minimal fix, change that to KRB5_KDB_SRV_TYPE_ADMIN to be consistent
with open_db_and_mkey()--see also r18736.

------------------------------------------------------------------------
r24140 | tlyu | 2010-06-21 11:25:38 -0400 (Mon, 21 Jun 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/krb5/os/Makefile.in

ticket: 6744

Make OFFLINE!=no work again.
------------------------------------------------------------------------
r24139 | ghudson | 2010-06-21 11:18:37 -0400 (Mon, 21 Jun 2010) | 12 lines
Changed paths:
   M /trunk/src/lib/gssapi/krb5/gssapi_krb5.c

ticket: 6745
subject: Add correct error table when initializing gss-krb5
target_version: 1.8.3
tags: pullup

gss_krb5int_lib_init was adding the generic GSS error table (again)
instead of the krb5 error table, which could lead to crashes on
library unload.  This bug was introduced in krb5 1.7; the fix is also
applicable there.

Patch from Leonardo Chiquitto <leonardo.lists@gmail.com>.

------------------------------------------------------------------------
r24138 | tlyu | 2010-06-18 15:41:48 -0400 (Fri, 18 Jun 2010) | 12 lines
Changed paths:
   M /trunk/src/configure.in
   M /trunk/src/lib/krb5/os/Makefile.in

ticket: 6744
subject: only test t_locate_kdc if known-good DNS name is present
target_version: 1.8.3
tags: pullup

Running "make check" while offline or on a firewalled network may
result in failure in lib/krb5/os because the invocation of
t_locate_kdc requires that the DNS servers for ATHENA.MIT.EDU be
reachable.  Autodetect DNS utilities "dig" and "nslookup", and use
them to check for existence of the known-good DNS name.  Also
parameterize the test so that the known-good DNS name can be
overridden on the make command line.
------------------------------------------------------------------------
r24137 | ghudson | 2010-06-14 16:46:27 -0400 (Mon, 14 Jun 2010) | 7 lines
Changed paths:
   M /trunk/src/plugins/preauth/pkinit/pkinit_crypto_openssl.c

ticket: 6738
target_version: 1.8.3
tags: pullup

In PKINIT, notice if DH_compute_key() returns a value less than the
buffer size, and pad it on the left if so.

------------------------------------------------------------------------
r24136 | ghudson | 2010-06-14 16:00:03 -0400 (Mon, 14 Jun 2010) | 7 lines
Changed paths:
   M /trunk/src/plugins/preauth/pkinit/pkinit_crypto_openssl.c

Adjust the PKINIT DH debugging code:
  * Use %p and void * for pointers instead of %x and int
  * Don't call the computed symmetric key the "secret key" since
    that's easily confused with the private key g^x.
  * Print the private key when printing DH parameters, instead of the
    q value (not even sure what they is).

------------------------------------------------------------------------
r24134 | ghudson | 2010-06-11 17:03:03 -0400 (Fri, 11 Jun 2010) | 10 lines
Changed paths:
   M /trunk/src/slave/Makefile.in
   M /trunk/src/slave/kprop.c
   M /trunk/src/slave/kprop.h
   A /trunk/src/slave/kprop_sock.c
   M /trunk/src/slave/kpropd.c

ticket: 6686

Use getaddrinfo() in kprop and kpropd, and recognize IPv6 addresses
when setting up krb5_address structures.  kpropd still only binds to
one socket to avoid the need for a select() loop, so we turn off
IPV6_V6ONLY on that socket to ensure that IPv4 connections will still
be accepted.

Based on a patch from Michael Stapelberg <michael@stapelberg.de>.

------------------------------------------------------------------------
r24133 | ghudson | 2010-06-11 16:01:26 -0400 (Fri, 11 Jun 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/copy_addrs.c

Remove the code for krb5_append_addresses(), which was never used and
was ifdef'd out fifteen years ago in r5464.

------------------------------------------------------------------------
r24132 | ghudson | 2010-06-11 15:58:55 -0400 (Fri, 11 Jun 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/auth_con.c

Eliminate actx_copy_addr in auth_con.c; use krb5_copy_addr instead
(it's exactly the same).

------------------------------------------------------------------------
r24126 | ghudson | 2010-06-10 10:57:33 -0400 (Thu, 10 Jun 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/crypto/krb/yarrow/yarrow.c

In yarrow.c, undefine k5-trace.h's TRACE before defining it to avoid a
conflict.

------------------------------------------------------------------------
r24125 | ghudson | 2010-06-10 10:54:28 -0400 (Thu, 10 Jun 2010) | 2 lines
Changed paths:
   M /trunk/src/include/k5-trace.h

Remove some unused (as of yet) trace macro definitions.

------------------------------------------------------------------------
r24124 | ghudson | 2010-06-10 10:50:09 -0400 (Thu, 10 Jun 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/krb5/os/trace.c

Fix a couple of minor defects in trace.c.

------------------------------------------------------------------------
r24123 | ghudson | 2010-06-08 14:18:03 -0400 (Tue, 08 Jun 2010) | 11 lines
Changed paths:
   M /trunk/src/kadmin/cli/kadmin.h
   M /trunk/src/kadmin/cli/keytab.c

ticket: 6740
subject: kadmin ktadd may display wrong name of default keytab
target_version: 1.8.2
tags: pullup

kadmin's ktadd (and ktrem) displays WRFILE:/etc/krb5.keytab whenever
it uses the default keytab, even if the default has been overridden
(e.g. by KRB5_KTNAME).  Use krb5_kt_get_name to get the correct name
of the default cache instead of displaying the string we think was
used to open it.

------------------------------------------------------------------------
r24122 | ghudson | 2010-06-08 13:53:19 -0400 (Tue, 08 Jun 2010) | 6 lines
Changed paths:
   M /trunk/src/clients/klist/klist.c
   M /trunk/src/kadmin/cli/kadmin.c
   M /trunk/src/kadmin/cli/keytab.c
   M /trunk/src/kadmin/dbutil/kdb5_mkey.c
   M /trunk/src/kadmin/dbutil/kdb5_stash.c
   M /trunk/src/kadmin/ktutil/ktutil.c

ticket: 5014

When we display enctypes, display the input name rather than the
description.  Affects klist -e, kdb5_util list_mkeys, kdb5_util stash
(error message), kadmin getprinc, kadmin ktadd, and ktutil list -e.

------------------------------------------------------------------------
r24121 | ghudson | 2010-06-08 12:26:23 -0400 (Tue, 08 Jun 2010) | 13 lines
Changed paths:
   M /trunk/src/lib/gssapi/krb5/k5seal.c
   M /trunk/src/lib/gssapi/krb5/k5sealiov.c
   M /trunk/src/lib/gssapi/krb5/k5unseal.c

ticket: 6739

Stop checking the current time against the context expiration time in
the message wrap/unwrap functions in the krb5 GSS mech.  Heimdal
doesn't do it, and it generally results in poor app behavior when a
ticket expires.  In exchange, it doesn't provide much security benefit
since it's not enforced across the board--for example, ssh sessions
can persist beyond ticket expiration time since they don't use GSS to
wrap payload data.

(This is a continuation of r24120, which should have contained the
changes to all four files.)

------------------------------------------------------------------------
r24120 | ghudson | 2010-06-08 12:14:24 -0400 (Tue, 08 Jun 2010) | 12 lines
Changed paths:
   M /trunk/src/lib/gssapi/krb5/k5unsealiov.c

ticket: 6739
target_version: 1.8.2
tags: pullup

Stop checking the current time against the context expiration time in
the message wrap/unwrap functions in the krb5 GSS mech.  Heimdal
doesn't do it, and it generally results in poor app behavior when a
ticket expires.  In exchange, it doesn't provide much security benefit
since it's not enforced across the board--for example, ssh sessions
can persist beyond ticket expiration time since they don't use GSS to
wrap payload data.

------------------------------------------------------------------------
r24119 | ghudson | 2010-06-07 14:28:05 -0400 (Mon, 07 Jun 2010) | 1 line
Changed paths:
   M /trunk/src/clients/ksu/deps
   M /trunk/src/clients/kvno/deps
   M /trunk/src/kadmin/cli/deps
   M /trunk/src/kadmin/dbutil/deps
   M /trunk/src/kadmin/ktutil/deps
   M /trunk/src/kadmin/server/deps
   M /trunk/src/kdc/deps
   M /trunk/src/lib/apputils/deps
   M /trunk/src/lib/crypto/builtin/deps
   M /trunk/src/lib/crypto/builtin/des/deps
   M /trunk/src/lib/crypto/builtin/enc_provider/deps
   M /trunk/src/lib/crypto/builtin/hash_provider/deps
   M /trunk/src/lib/crypto/builtin/md4/deps
   M /trunk/src/lib/crypto/builtin/md5/deps
   M /trunk/src/lib/crypto/builtin/sha1/deps
   M /trunk/src/lib/crypto/crypto_tests/deps
   M /trunk/src/lib/crypto/krb/arcfour/deps
   M /trunk/src/lib/crypto/krb/checksum/deps
   M /trunk/src/lib/crypto/krb/crc32/deps
   M /trunk/src/lib/crypto/krb/deps
   M /trunk/src/lib/crypto/krb/dk/deps
   M /trunk/src/lib/crypto/krb/old/deps
   M /trunk/src/lib/crypto/krb/prf/deps
   M /trunk/src/lib/crypto/krb/rand2key/deps
   M /trunk/src/lib/crypto/krb/raw/deps
   M /trunk/src/lib/crypto/krb/yarrow/deps
   M /trunk/src/lib/gssapi/krb5/deps
   M /trunk/src/lib/gssapi/mechglue/deps
   M /trunk/src/lib/gssapi/spnego/deps
   M /trunk/src/lib/kadm5/clnt/deps
   M /trunk/src/lib/kadm5/deps
   M /trunk/src/lib/kadm5/srv/deps
   M /trunk/src/lib/kadm5/unit-test/deps
   M /trunk/src/lib/kdb/deps
   M /trunk/src/lib/krb5/asn.1/deps
   M /trunk/src/lib/krb5/ccache/deps
   M /trunk/src/lib/krb5/deps
   M /trunk/src/lib/krb5/keytab/deps
   M /trunk/src/lib/krb5/krb/deps
   M /trunk/src/lib/krb5/os/deps
   M /trunk/src/lib/krb5/rcache/deps
   M /trunk/src/lib/krb5/unicode/deps
   M /trunk/src/plugins/kdb/db2/deps
   M /trunk/src/plugins/kdb/ldap/deps
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/deps
   M /trunk/src/plugins/preauth/encrypted_challenge/deps
   M /trunk/src/plugins/preauth/pkinit/deps
   M /trunk/src/slave/deps
   M /trunk/src/tests/asn.1/deps
   M /trunk/src/tests/create/deps
   M /trunk/src/tests/hammer/deps
   M /trunk/src/tests/misc/deps
   M /trunk/src/tests/verify/deps
   M /trunk/src/util/ss/deps

make depend.
------------------------------------------------------------------------
r24118 | ghudson | 2010-06-07 14:26:17 -0400 (Mon, 07 Jun 2010) | 13 lines
Changed paths:
   M /trunk/src/include/cm.h
   M /trunk/src/include/k5-int.h
   A /trunk/src/include/k5-trace.h
   M /trunk/src/include/krb5/krb5.hin
   M /trunk/src/lib/krb5/ccache/ccbase.c
   M /trunk/src/lib/krb5/ccache/ccfns.c
   M /trunk/src/lib/krb5/error_tables/krb5_err.et
   M /trunk/src/lib/krb5/keytab/ktfns.c
   M /trunk/src/lib/krb5/krb/fast.c
   M /trunk/src/lib/krb5/krb/gc_via_tkt.c
   M /trunk/src/lib/krb5/krb/get_creds.c
   M /trunk/src/lib/krb5/krb/get_in_tkt.c
   M /trunk/src/lib/krb5/krb/gic_pwd.c
   M /trunk/src/lib/krb5/krb/init_ctx.c
   M /trunk/src/lib/krb5/krb/mk_rep.c
   M /trunk/src/lib/krb5/krb/mk_req_ext.c
   M /trunk/src/lib/krb5/krb/preauth2.c
   M /trunk/src/lib/krb5/krb/rd_rep.c
   M /trunk/src/lib/krb5/krb/rd_req_dec.c
   M /trunk/src/lib/krb5/krb/send_tgs.c
   M /trunk/src/lib/krb5/libkrb5.exports
   M /trunk/src/lib/krb5/os/Makefile.in
   M /trunk/src/lib/krb5/os/sendto_kdc.c
   A /trunk/src/lib/krb5/os/trace.c

ticket: 6737
subject: Trace logging

Add trace logging infrastructure code, enabled by the KRB5_TRACE
environment variable or the API functions krb5_set_trace_callback()
or krb5_set_trace_filename().  As a start, add tracing events for:
  * AS-REQ client code, including FAST and preauth
  * TGS-REQ client code
  * AP-REQ and AP-REP code (client and server)
  * sendto_kdc
  * Selected ccache operations
  * Selected keytab operations

------------------------------------------------------------------------
r24117 | ghudson | 2010-06-04 14:33:26 -0400 (Fri, 04 Jun 2010) | 7 lines
Changed paths:
   M /trunk/src/include/krb5/krb5.hin
   M /trunk/src/lib/crypto/krb/enctype_util.c
   M /trunk/src/lib/crypto/krb/etypes.h
   M /trunk/src/lib/crypto/libk5crypto.exports

ticket: 6736
subject: Add krb5_enctype_to_name() API

Add an API to return the input name, or optionally the shortest alias,
of an enctype.  Similar to krb5_enctype_to_string() which returns a
description.

------------------------------------------------------------------------
r24110 | ghudson | 2010-05-28 14:26:43 -0400 (Fri, 28 May 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/krb5/ccache/ccfns.c

In krb5_cc_set_config, don't call krb5_cc_remove_cred; it's redundant
with the krb5_cc_remove_cred call in krb5_cc_store_cred.

------------------------------------------------------------------------
r24109 | ghudson | 2010-05-28 11:56:05 -0400 (Fri, 28 May 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/gssapi/krb5/deps
   M /trunk/src/lib/krb5/krb/deps

make depend.

------------------------------------------------------------------------
r24107 | ghudson | 2010-05-28 10:38:37 -0400 (Fri, 28 May 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/s4u_authdata.c

From Luke: make copies of S4U2Proxy authdata modules work when there
is no S4U2Proxy authdata.

------------------------------------------------------------------------
r24106 | ghudson | 2010-05-27 18:25:51 -0400 (Thu, 27 May 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/krb5/os/locate_kdc.c
   M /trunk/src/lib/krb5/os/t_locate_kdc.c

Remove the get_masters logic in locate_srv_conf_1 which was orphaned
by r15736 when we added the master_kdc profile variable.

------------------------------------------------------------------------
r24105 | ghudson | 2010-05-27 18:17:23 -0400 (Thu, 27 May 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/Makefile.in

Get t_ser to build again after the S4U authdata branch merge.

------------------------------------------------------------------------
r24103 | ghudson | 2010-05-25 11:36:40 -0400 (Tue, 25 May 2010) | 3 lines
Changed paths:
   M /trunk/src/util/testrealm.py

In testrealm.py, stash the passwords in testdir/passwords so that they
can be retrieved after they've scrolled away.

------------------------------------------------------------------------
r24102 | ghudson | 2010-05-24 22:44:45 -0400 (Mon, 24 May 2010) | 11 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/fast.c

ticket: 6734
subject: FAST negotiation could erroneously succeed
target_version: 1.8.2
tags: pullup

When FAST negotiation is performed against an older KDC
(rep->enc_part2->flags & TKT_FLG_ENC_PA_REP not set),
krb5int_fast_verify_nego did not set the value of *fast_avail, causing
stack garbage to be used in init_creds_step_reply.  Initialize
*fast_avail at the beginning of the function per coding practices.

------------------------------------------------------------------------
r24101 | ghudson | 2010-05-24 15:22:02 -0400 (Mon, 24 May 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/fast.h

Fix long lines and other formatting issues in fast.h.

------------------------------------------------------------------------
r24100 | ghudson | 2010-05-24 15:17:36 -0400 (Mon, 24 May 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/fast.c

Fix long lines and other formatting issues in fast.c.

------------------------------------------------------------------------
r24097 | ghudson | 2010-05-23 23:14:57 -0400 (Sun, 23 May 2010) | 3 lines
Changed paths:
   M /trunk/src/kdc/do_as_req.c
   M /trunk/src/kdc/do_tgs_req.c

Don't include nul characters in the text we send with krb-error
responses from the KDC.

------------------------------------------------------------------------
r24094 | ghudson | 2010-05-23 16:23:31 -0400 (Sun, 23 May 2010) | 7 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/Makefile.in
   M /trunk/src/lib/krb5/krb/authdata.c
   M /trunk/src/lib/krb5/krb/authdata.h
   M /trunk/src/lib/krb5/krb/pac.c
   A /trunk/src/lib/krb5/krb/s4u_authdata.c (from /users/lhoward/signedpath-naming-exts/src/lib/krb5/krb/s4u_authdata.c:24093)

ticket: 6733
subject: Make signedpath authdata visible via GSS naming exts

Merge users/lhoward/signedpath-naming-exts to trunk.  Adds an authdata
provider which makes non-PAC S4U2Proxy signedpath authdata visible to
application servers via GSS naming extensions.

------------------------------------------------------------------------
r24085 | ghudson | 2010-05-21 15:29:04 -0400 (Fri, 21 May 2010) | 4 lines
Changed paths:
   M /trunk/src/kadmin/dbutil/dump.c

Remove a non-functional and unnecessary check in kdb5_util's
master_key_convert().  (key_data->key_data_length is an array, so its
address is never null.)

------------------------------------------------------------------------
r24084 | ghudson | 2010-05-21 15:23:21 -0400 (Fri, 21 May 2010) | 3 lines
Changed paths:
   M /trunk/src/kadmin/dbutil/dump.c

Fix an error case in kdb_util's dump.c where the dump file handle was
leaked.

------------------------------------------------------------------------
r24083 | ghudson | 2010-05-21 15:15:20 -0400 (Fri, 21 May 2010) | 3 lines
Changed paths:
   M /trunk/src/kadmin/cli/keytab.c

Remove an unneeded conditional in the cleanup for kadmin's keytab
add_principal(), squashing a false-positive memory leak from Coverity.

------------------------------------------------------------------------
r24082 | ghudson | 2010-05-21 15:08:41 -0400 (Fri, 21 May 2010) | 3 lines
Changed paths:
   M /trunk/src/kadmin/cli/getdate.y

In getdate.y, remove an error check from r19656 which couldn't ever
trigger (Convert() does not use an error parameter).

------------------------------------------------------------------------
r24081 | ghudson | 2010-05-21 15:03:45 -0400 (Fri, 21 May 2010) | 2 lines
Changed paths:
   M /trunk/src/kadmin/cli/getdate.y

Use ANSI-style function definitions in our copy of getdate.y.

------------------------------------------------------------------------
r24078 | ghudson | 2010-05-20 23:08:18 -0400 (Thu, 20 May 2010) | 6 lines
Changed paths:
   M /trunk/doc/admin.texinfo
   M /trunk/src/config-files/krb5.conf.M

ticket: 6719

Document the disable_last_success and disable_lockout variables in
krb5.conf.M.  Also document database_name in krb5.conf.M and slightly
adjust the wording in admin.texinfo.

------------------------------------------------------------------------
r24075 | tlyu | 2010-05-20 17:32:47 -0400 (Thu, 20 May 2010) | 7 lines
Changed paths:
   M /trunk/src/lib/gssapi/spnego/spnego_mech.c

ticket: 6726
target_version: 1.8.2
tags: pullup

Apply patch from Arlene Berry to detect and ignore a duplicate
mechanism token sent in the mechListMIC field, such as sent by Windows
2000 Server.
------------------------------------------------------------------------
r24074 | tlyu | 2010-05-20 16:42:26 -0400 (Thu, 20 May 2010) | 10 lines
Changed paths:
   M /trunk/src/config-files/kdc.conf.M

ticket: 6730
subject: kdc_tcp_ports not documented in kdc.conf.M
target_version: 1.8.2
tags: pullup

The kdc.conf setting kdc_tcp_ports was not documented in kdc.conf.M,
though it was documented in doc/admin.texinfo.  Copy text from there
for now.  The setting defaults to an empty string at the moment,
causing the KDC to not listen on TCP by default, confusing some users.
Changing this behavior is a separate issue.
------------------------------------------------------------------------
r24072 | ghudson | 2010-05-20 11:13:06 -0400 (Thu, 20 May 2010) | 4 lines
Changed paths:
   M /trunk/src/lib/gssapi/mechglue/g_acquire_cred_with_pw.c

In gss_acquire_cred_with_password() and gss_add_cred_with_password(),
require desired_name to be set, and always honor it.  This is
consistent with the Sun implementation and simplifies the code.

------------------------------------------------------------------------
r24056 | tlyu | 2010-05-19 14:09:37 -0400 (Wed, 19 May 2010) | 7 lines
Changed paths:
   M /trunk/src/lib/gssapi/krb5/accept_sec_context.c

ticket: 6725
subject: CVE-2010-1321 GSS-API lib null pointer deref (MITKRB5-SA-2010-005)
tags: pullup
target_version: 1.8.2

Make krb5_gss_accept_sec_context() check for a null authenticator
checksum pointer before attempting to dereference it.
------------------------------------------------------------------------
r24055 | ghudson | 2010-05-18 13:19:15 -0400 (Tue, 18 May 2010) | 6 lines
Changed paths:
   M /trunk/doc/admin.texinfo
   M /trunk/src/lib/kadm5/alt_prof.c
   M /trunk/src/lib/krb5/os/locate_kdc.c

ticket:	6562

When parsing a KDC or admin server string, allow the name or address
to be enclosed in brackets so that IPv6 addresses can be represented.
(IPv6 addresses contain colons, which look like port separators.)

------------------------------------------------------------------------
r24054 | ghudson | 2010-05-18 12:17:15 -0400 (Tue, 18 May 2010) | 4 lines
Changed paths:
   M /trunk/src/lib/kadm5/alt_prof.c
   M /trunk/src/lib/kadm5/clnt/client_init.c
   M /trunk/src/lib/kadm5/kadm_err.et

Improve the error message from kadmin when hostname resolution fails
for the admin server.  (The extended message won't be displayed by
kadmin currently; that's a separate issue.)

------------------------------------------------------------------------
r24052 | ghudson | 2010-05-17 16:38:24 -0400 (Mon, 17 May 2010) | 5 lines
Changed paths:
   M /trunk/src/lib/gssapi/mechglue/g_inq_cred.c

If gss_inquire_cred is called with a null credential, acquire a
default initiator credential and process it normally, instead of using
a completely different code path (the default mechanism's inquire_cred
handler).

------------------------------------------------------------------------
r24051 | ghudson | 2010-05-17 16:01:29 -0400 (Mon, 17 May 2010) | 4 lines
Changed paths:
   M /trunk/src/lib/gssapi/krb5/accept_sec_context.c
   M /trunk/src/lib/gssapi/krb5/acquire_cred.c
   M /trunk/src/lib/gssapi/krb5/gssapiP_krb5.h
   M /trunk/src/lib/gssapi/krb5/iakerb.c
   M /trunk/src/lib/gssapi/krb5/init_sec_context.c
   M /trunk/src/lib/gssapi/krb5/inq_cred.c
   M /trunk/src/lib/gssapi/krb5/s4u_gss_glue.c

The mechglue always passes null for desired_mechs and actual_mechs
when invoking gss_acquire_cred and friends.  Eliminate a lot of unused
and untestable logic in the krb5 mech which processed those arguments.

------------------------------------------------------------------------
r24050 | ghudson | 2010-05-17 13:11:28 -0400 (Mon, 17 May 2010) | 5 lines
Changed paths:
   M /trunk/src/lib/gssapi/krb5/Makefile.in
   D /trunk/src/lib/gssapi/krb5/add_cred.c
   M /trunk/src/lib/gssapi/krb5/gssapiP_krb5.h
   M /trunk/src/lib/gssapi/krb5/gssapi_krb5.c

The mechglue never invokes a mech's gss_add_cred function.  Remove the
krb5 mech's add_cred implementation and null it out in the table.
(This has the effect of removing the IAKERB add_cred implementation.
SPNEGO already had it nulled out.)

------------------------------------------------------------------------
r24043 | raeburn | 2010-05-15 23:18:38 -0400 (Sat, 15 May 2010) | 1 line
Changed paths:
   M /trunk/src/lib/crypto/Makefile.in

Reformat with shorter lines.
------------------------------------------------------------------------
r24042 | raeburn | 2010-05-15 23:09:48 -0400 (Sat, 15 May 2010) | 1 line
Changed paths:
   M /trunk/src/lib/crypto/ISSUES

Delete an old pre-Yarrow item.
------------------------------------------------------------------------
r24041 | raeburn | 2010-05-15 22:49:53 -0400 (Sat, 15 May 2010) | 1 line
Changed paths:
   M /trunk/src/appl/gss-sample/deps
   M /trunk/src/lib/gssapi/krb5/deps
   M /trunk/src/lib/gssapi/mechglue/deps
   M /trunk/src/lib/krb5/krb/deps
   M /trunk/src/plugins/kdb/db2/deps

Update dependencies.
------------------------------------------------------------------------
r24040 | raeburn | 2010-05-15 22:49:49 -0400 (Sat, 15 May 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/krb5/libkrb5.exports
   M /trunk/src/util/profile/libprofile.exports

Stop exporting some profile symbols that aren't either published in
the header or known serialization functions used by the krb5 library.
------------------------------------------------------------------------
r24039 | raeburn | 2010-05-15 22:49:45 -0400 (Sat, 15 May 2010) | 1 line
Changed paths:
   M /trunk/src/util/k5test.py

Force hostname to lower-case for use in principal names.
------------------------------------------------------------------------
r24021 | ghudson | 2010-05-13 14:58:43 -0400 (Thu, 13 May 2010) | 6 lines
Changed paths:
   M /trunk/src/lib/krb5/ccache/cc_file.c

ticket: 6723
subject: Negative enctypes improperly read from ccaches

When reading enctypes from ccaches, we need to sign-extend the 16-bit
value we read in order to properly read negative enctypes.

------------------------------------------------------------------------
r24020 | ghudson | 2010-05-13 14:49:20 -0400 (Thu, 13 May 2010) | 8 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/get_in_tkt.c

ticket: 6722
subject: Error handling bug in krb5_init_creds_init()
tags: pullup
target_version: 1.8.2

Fix a bug in krb5_init_creds_init() where a freed context could be
returned to the caller in certain error cases.

------------------------------------------------------------------------
r24016 | ghudson | 2010-05-13 13:34:33 -0400 (Thu, 13 May 2010) | 7 lines
Changed paths:
   M /trunk/src/lib/krb5/keytab/kt_file.c

ticket: 6720
subject: Negative enctypes improperly read from keytabs

When reading enctypes from keytabs, we need to ntohs() the 16-bit
value we read in before sign-extending it to a 32-bit value in the
keyblock, or we run the risk of extending the wrong sign.

------------------------------------------------------------------------
r24015 | ghudson | 2010-05-13 12:46:50 -0400 (Thu, 13 May 2010) | 2 lines
Changed paths:
   M /trunk/src/util/k5test.py

Make k5test.py work for builds in the source dir.

------------------------------------------------------------------------
r24013 | tlyu | 2010-05-12 17:58:54 -0400 (Wed, 12 May 2010) | 1 line
Changed paths:
   M /trunk/src/lib/krb5_32.def

Remove krb5_get_in_tkt.
------------------------------------------------------------------------
r24012 | ghudson | 2010-05-12 16:49:11 -0400 (Wed, 12 May 2010) | 11 lines
Changed paths:
   M /trunk/src/include/k5-int.h
   M /trunk/src/include/krb5/krb5.hin
   M /trunk/src/lib/krb5/krb/Makefile.in
   M /trunk/src/lib/krb5/krb/get_in_tkt.c
   M /trunk/src/lib/krb5/krb/in_tkt_sky.c
   D /trunk/src/lib/krb5/krb/preauth.c
   M /trunk/src/lib/krb5/libkrb5.exports

Reimplement krb5_get_in_tkt_with_skey in terms of krb5_get_init_creds,
similar to how the password and keytab equivalents were done.

Eliminate krb5_get_in_tkt.  It's been very hard to use since we made
krb5_kdc_rep_decrypt_proc private (in krb5 1.7 the prototype was taken
out of krb5.h altogether), and it's unlikely that anything would have
used it directly in the first place.

Remove and/or simplify a lot of code depended on by krb_get_in_tkt,
including all of preauth.c.

------------------------------------------------------------------------
r24003 | ghudson | 2010-05-10 18:42:04 -0400 (Mon, 10 May 2010) | 12 lines
Changed paths:
   M /trunk/doc/admin.texinfo
   M /trunk/src/include/k5-int.h
   M /trunk/src/plugins/kdb/db2/kdb_db2.c
   M /trunk/src/plugins/kdb/db2/kdb_db2.h
   M /trunk/src/plugins/kdb/db2/lockout.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap.h
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_misc.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/lockout.c

ticket: 6719
subject: Add lockout-related performance tuning variables

The account lockout feature of krb5 1.8 came at a cost in database
accesses for principals requiring preauth, even if lockout is not
used.  Add dbmodules variables disable_last_success and
disable_lockout for the DB2 and LDAP back ends, allowing the admin to
recover the lost performance at the cost of new functionality.

(Unrelated documentation fix: document database_name as a DB2-specific
dbmodules variable instead of the realm variable it used to be.)

------------------------------------------------------------------------
r24002 | ghudson | 2010-05-10 18:23:57 -0400 (Mon, 10 May 2010) | 14 lines
Changed paths:
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_principal2.c

ticket: 6718
subject: Make KADM5_FAIL_AUTH_COUNT_INCREMENT more robust with LDAP
target_version: 1.8.2
tags: pullup

In krb5_ldap_put_principal, use krb5_get_attributes_mask to determine
whether krbLoginFailedCount existed on the entry when it was
retrieved.  If it didn't exist, don't try to use LDAP_MOD_INCREMENT,
and don't assert an old value when not using LDAP_MOD_INCREMENT.

Also, create the krbLoginFailedCount attribute when creating new
entries.  This allows us to use LDAP_MOD_INCREMENT during the first
failed login (if the server supports it), avoiding a race condition.

------------------------------------------------------------------------
r23973 | ghudson | 2010-05-05 13:11:39 -0400 (Wed, 05 May 2010) | 4 lines
Changed paths:
   M /trunk/src/plugins/kdb/db2/kdb_db2.c

General code consistency pass in kdb_db2.c.
Removes some pointless null checks.
Frees the DB context when a DB is finalized.

------------------------------------------------------------------------
r23972 | tlyu | 2010-05-04 18:00:41 -0400 (Tue, 04 May 2010) | 1 line
Changed paths:
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/libkdb_ldap.exports

Adjust for removal of krb5_ldap_set_option in r23965.
------------------------------------------------------------------------
r23971 | ghudson | 2010-05-04 15:01:16 -0400 (Tue, 04 May 2010) | 3 lines
Changed paths:
   M /trunk/src/kadmin/dbutil/dump.c

Get rid of some kdb5_util load code which is no longer useful after
the introduction of the DAL.

------------------------------------------------------------------------
r23970 | ghudson | 2010-05-04 13:08:39 -0400 (Tue, 04 May 2010) | 2 lines
Changed paths:
   M /trunk/src/kadmin/dbutil/dump.c

Remove some unused format string definitions from kdb5_util's dump.c.

------------------------------------------------------------------------
r23969 | ghudson | 2010-05-04 12:54:00 -0400 (Tue, 04 May 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/kadm5/admin.h
   M /trunk/src/lib/kadm5/alt_prof.c
   M /trunk/src/lib/kadm5/clnt/Makefile.in
   M /trunk/src/lib/kadm5/srv/Makefile.in

Remove some unused fields from kadm5_config_params.  Bump the client
and server sonames.

------------------------------------------------------------------------
r23968 | ghudson | 2010-05-04 11:58:59 -0400 (Tue, 04 May 2010) | 2 lines
Changed paths:
   M /trunk/src/include/adm.h
   M /trunk/src/kdc/extern.h
   M /trunk/src/kdc/main.c
   M /trunk/src/lib/kadm5/admin.h
   M /trunk/src/lib/kadm5/alt_prof.c

Eliminate the unused realm_dbname field from krb5_realm_params.

------------------------------------------------------------------------
r23967 | ghudson | 2010-05-04 01:49:39 -0400 (Tue, 04 May 2010) | 2 lines
Changed paths:
   M /trunk/src/plugins/kdb/db2/kdb_db2.c

Remove a stray comment from r23966.

------------------------------------------------------------------------
r23966 | ghudson | 2010-05-04 01:44:07 -0400 (Tue, 04 May 2010) | 4 lines
Changed paths:
   M /trunk/src/plugins/kdb/db2/kdb_db2.c
   M /trunk/src/plugins/kdb/db2/kdb_db2.h

Refactor the kdb_db2.c code which processes db_args and profile
variables to configure a DB context, to avoid repeating that code
three times in open/create/destroy.

------------------------------------------------------------------------
r23965 | ghudson | 2010-05-04 00:12:24 -0400 (Tue, 04 May 2010) | 3 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/plugins/kdb/db2/db2_exp.c
   M /trunk/src/plugins/kdb/db2/kdb_db2.c
   M /trunk/src/plugins/kdb/hdb/kdb_hdb.c
   M /trunk/src/plugins/kdb/ldap/ldap_exp.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ldap.h
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/ldap_misc.c

Remove krb5_db_set_option and the associated DAL entry.  It was not
used.

------------------------------------------------------------------------
r23964 | ghudson | 2010-05-03 19:44:30 -0400 (Mon, 03 May 2010) | 2 lines
Changed paths:
   M /trunk/src/include/kdb.h

Correct the DAL documentation for db_create.

------------------------------------------------------------------------
r23963 | ghudson | 2010-05-03 15:42:29 -0400 (Mon, 03 May 2010) | 5 lines
Changed paths:
   M /trunk/src/clients/klist/klist.c
   M /trunk/src/clients/ksu/ccache.c
   M /trunk/src/kadmin/dbutil/kdb5_stash.c
   M /trunk/src/lib/rpc/unit-test/rpc_test_svc.c
   M /trunk/src/slave/kprop.c
   M /trunk/src/slave/kpropd.c

ticket: 6714

Eliminate some uses of variables as format strings.  Based on a patch
from Guillaume Rousse <Guillaume.Rousse@inria.fr>.

------------------------------------------------------------------------
r23962 | ghudson | 2010-05-03 15:02:16 -0400 (Mon, 03 May 2010) | 8 lines
Changed paths:
   M /trunk/src/kadmin/dbutil/Makefile.in
   M /trunk/src/kadmin/dbutil/deps
   M /trunk/src/kadmin/dbutil/dump.c
   M /trunk/src/kadmin/dbutil/kadm5_create.c
   M /trunk/src/kadmin/dbutil/kdb5_util.c
   M /trunk/src/kadmin/dbutil/kdb5_util.h
   D /trunk/src/kadmin/dbutil/string_table.c
   D /trunk/src/kadmin/dbutil/string_table.h

ticket: 6714
status: open

Eliminate the use of variables for format strings in kdb5_util.  Many
were unused, and localization will probably be done through _()
macros, not collecting all the strings together.  Elminates a number
of format-security static analysis defects.

------------------------------------------------------------------------
r23961 | ghudson | 2010-05-01 13:53:04 -0400 (Sat, 01 May 2010) | 4 lines
Changed paths:
   M /trunk/src/lib/gssapi/krb5/acquire_cred.c
   M /trunk/src/lib/gssapi/krb5/iakerb.c
   M /trunk/src/lib/krb5/krb/kfree.c

Fix some bugs in the IAKERB code discovered by Coverity.  Also trim
down iakerb_initiator_step() a little using krb5_data constructors
and avoiding vertical function arguments.

------------------------------------------------------------------------
r23960 | ghudson | 2010-04-30 17:22:48 -0400 (Fri, 30 Apr 2010) | 11 lines
Changed paths:
   M /trunk/src/appl/gss-sample/gss-client.c
   M /trunk/src/appl/gss-sample/gss-server.c
   M /trunk/src/appl/gss-sample/t_gss_sample.py
   M /trunk/src/include/k5-int.h
   M /trunk/src/include/krb5/krb5.hin
   M /trunk/src/lib/gssapi/generic/gssapi_ext.h
   M /trunk/src/lib/gssapi/krb5/Makefile.in
   M /trunk/src/lib/gssapi/krb5/accept_sec_context.c
   M /trunk/src/lib/gssapi/krb5/acquire_cred.c
   M /trunk/src/lib/gssapi/krb5/add_cred.c
   M /trunk/src/lib/gssapi/krb5/gssapiP_krb5.h
   M /trunk/src/lib/gssapi/krb5/gssapi_err_krb5.et
   M /trunk/src/lib/gssapi/krb5/gssapi_krb5.c
   M /trunk/src/lib/gssapi/krb5/gssapi_krb5.hin
   A /trunk/src/lib/gssapi/krb5/iakerb.c (from /branches/iakerb/src/lib/gssapi/krb5/iakerb.c:23959)
   M /trunk/src/lib/gssapi/krb5/init_sec_context.c
   M /trunk/src/lib/gssapi/krb5/inq_cred.c
   M /trunk/src/lib/gssapi/krb5/inq_names.c
   M /trunk/src/lib/gssapi/krb5/rel_cred.c
   M /trunk/src/lib/gssapi/krb5/ser_sctx.c
   M /trunk/src/lib/gssapi/libgssapi_krb5.exports
   M /trunk/src/lib/gssapi/mechglue/Makefile.in
   A /trunk/src/lib/gssapi/mechglue/g_acquire_cred_with_pw.c (from /branches/iakerb/src/lib/gssapi/mechglue/g_acquire_cred_with_pw.c:23959)
   M /trunk/src/lib/gssapi/mechglue/g_initialize.c
   M /trunk/src/lib/gssapi/mechglue/mglueP.h
   M /trunk/src/lib/gssapi/spnego/gssapiP_spnego.h
   M /trunk/src/lib/gssapi/spnego/spnego_mech.c
   M /trunk/src/lib/krb5/asn.1/asn1_k_decode.c
   M /trunk/src/lib/krb5/asn.1/asn1_k_decode.h
   M /trunk/src/lib/krb5/asn.1/asn1_k_encode.c
   M /trunk/src/lib/krb5/asn.1/krb5_decode.c
   M /trunk/src/lib/krb5/error_tables/krb5_err.et
   M /trunk/src/lib/krb5/krb/kfree.c
   R /trunk/src/lib/krb5/krb/val_renew.c (from /branches/iakerb/src/lib/krb5/krb/val_renew.c:23959)
   M /trunk/src/lib/krb5/libkrb5.exports
   M /trunk/src/tests/asn.1/krb5_decode_leak.c
   M /trunk/src/tests/asn.1/krb5_decode_test.c
   M /trunk/src/tests/asn.1/krb5_encode_test.c
   M /trunk/src/tests/asn.1/ktest.c
   M /trunk/src/tests/asn.1/ktest.h
   M /trunk/src/tests/asn.1/ktest_equal.c
   M /trunk/src/tests/asn.1/ktest_equal.h
   M /trunk/src/tests/asn.1/reference_encode.out
   M /trunk/src/tests/asn.1/trval_reference.out

ticket: 6712
subject: Add IAKERB mechanism and gss_acquire_cred_with_password

Merge branches/iakerb to trunk.  Includes the following:

* New IAKERB mechanism.
* New gss_acquire_cred_with_password mechglue function.
* ASN.1 encoders and decoders for IAKERB structures (with tests).
* New shortcuts in gss-sample client and server.
* Tests to exercise SPNEGO and IAKERB using gss-sample application.

------------------------------------------------------------------------
r23959 | tlyu | 2010-04-30 17:10:55 -0400 (Fri, 30 Apr 2010) | 7 lines
Changed paths:
   M /trunk/src/kdc/do_tgs_req.c

ticket: 6711
subject: memory leak in process_tgs_req in r23724
tags: pullup
target_version: 1.8.2

Fix a KDC memory leak that was introduced by r23724 that could leak
the decoded request.
------------------------------------------------------------------------
r23945 | ghudson | 2010-04-27 05:02:48 -0400 (Tue, 27 Apr 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/get_creds.c

Fix a backwards check in get_cached_tgt() in the TGS code.

------------------------------------------------------------------------
r23942 | ghudson | 2010-04-26 12:54:38 -0400 (Mon, 26 Apr 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/crypto/krb/old_api_glue.c

Squash some warnings in the old crypto API glue.  Use make_data()
where appropriate so that magic fields get initialized.

------------------------------------------------------------------------
r23937 | ghudson | 2010-04-24 15:33:33 -0400 (Sat, 24 Apr 2010) | 2 lines
Changed paths:
   M /trunk/src/appl/gss-sample/Makefile.in
   A /trunk/src/appl/gss-sample/t_gss_sample.py

Add a Python test script to exercise the GSS sample app.

------------------------------------------------------------------------
r23936 | ghudson | 2010-04-24 15:24:36 -0400 (Sat, 24 Apr 2010) | 3 lines
Changed paths:
   M /trunk/src/appl/simple/server/sim_server.c
   M /trunk/src/tests/dejagnu/krb-standalone/simple.exp

Add a sentinel line to sim_server after the socket is ready, and use
it in simple.exp in the dejagnu test suite instead of sleeping.

------------------------------------------------------------------------
r23935 | ghudson | 2010-04-24 15:20:11 -0400 (Sat, 24 Apr 2010) | 4 lines
Changed paths:
   M /trunk/src/tests/dejagnu/config/default.exp

Eliminate the use of tail -f in the dejagnu test suite.  Instead, use
the sentinel lines printed by krb5kdc and kadmind to detect when the
listening sockets are ready.

------------------------------------------------------------------------
r23934 | ghudson | 2010-04-24 15:12:34 -0400 (Sat, 24 Apr 2010) | 3 lines
Changed paths:
   M /trunk/src/appl/gss-sample/gss-server.c
   M /trunk/src/tests/dejagnu/krb-standalone/gssapi.exp

Add a sentinel to the sample gss-server after the socket is ready, and
use it in gssapi.exp in the dejagnu test suite instead of sleeping.

------------------------------------------------------------------------
r23933 | ghudson | 2010-04-24 14:53:25 -0400 (Sat, 24 Apr 2010) | 3 lines
Changed paths:
   M /trunk/src/config/pre.in
   M /trunk/src/util/k5test.py

Simplify how k5test scripts get run by importing runenv by pathname
(using the imp module) instead of by module name.

------------------------------------------------------------------------
r23932 | ghudson | 2010-04-24 13:33:04 -0400 (Sat, 24 Apr 2010) | 6 lines
Changed paths:
   M /trunk/src/Makefile.in
   M /trunk/src/config/post.in
   M /trunk/src/config/pre.in
   M /trunk/src/tests/Makefile.in
   M /trunk/src/tests/gssapi/Makefile.in
   M /trunk/src/util/k5test.py

Run Python tests as individual rule commands (friendlier to make -k)
instead of in a loop.  Build runenv.py as part of make fake-install;
it's harmless if Python is unavailable.  Import runenv later in
k5test so that we get a beter error message if make fake-install
hasn't been run.

------------------------------------------------------------------------
r23931 | ghudson | 2010-04-24 12:39:49 -0400 (Sat, 24 Apr 2010) | 3 lines
Changed paths:
   M /trunk/src/config/post.in

Fix the actual python command to match the displayed one in the
check-pytests-yes rule in r23913.

------------------------------------------------------------------------
r23929 | tlyu | 2010-04-22 21:30:48 -0400 (Thu, 22 Apr 2010) | 6 lines
Changed paths:
   M /trunk/src/util/support/plugins.c

ticket: 6697
target_version: 1.8.2
tags: pullup

Adapted patch from Arlene Berry to handle dlerror() returning a null
pointer.
------------------------------------------------------------------------
r23928 | tlyu | 2010-04-22 21:10:20 -0400 (Thu, 22 Apr 2010) | 9 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/str_conv.c
   M /trunk/src/slave/kproplog.c

ticket: 6698
target_version: 1.8.2
tags: pullup

Adapted patch from Jason Rogers.  It wasn't complete, so this commit
fixes the other instances of the 64-bit problem.

Also fix krb5_deltat_to_str(), which would previously always return an
empty string.
------------------------------------------------------------------------
r23927 | ghudson | 2010-04-22 19:29:40 -0400 (Thu, 22 Apr 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/s4u_creds.c

From Luke: fix the post-canonicalization cache check logic in
krb5_get_credentials_for_user().

------------------------------------------------------------------------
r23926 | ghudson | 2010-04-22 16:07:08 -0400 (Thu, 22 Apr 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/gssapi/krb5/init_sec_context.c

In kg_new_connection(), make sure k_cred is freed in all failure
cases.

------------------------------------------------------------------------
r23925 | tlyu | 2010-04-22 16:04:01 -0400 (Thu, 22 Apr 2010) | 7 lines
Changed paths:
   M /trunk/src/lib/gssapi/mechglue/g_accept_sec_context.c

ticket: 6696
target_version: 1.8.2
tags: pullup

Apply patch from Arlene Berry to cease freeing error tokens output by
accept_sec_context, allowing them to actually be sent to the
initiator.
------------------------------------------------------------------------
r23922 | ghudson | 2010-04-21 23:44:44 -0400 (Wed, 21 Apr 2010) | 5 lines
Changed paths:
   M /trunk/src/kdc/dispatch.c

Eliminate a non-useful NULL check in the KDC's dispatch() function.
If process_as_req or process_tgs_req return successfully, they will
always fill in *response.  (If they didn't, the subsequence
(*response)->length check would crash anyway.)

------------------------------------------------------------------------
r23921 | ghudson | 2010-04-21 23:19:34 -0400 (Wed, 21 Apr 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/krb5/os/changepw.c

In kpasswd_sendto_msg_callback(), properly compare against the
wildcard IPv6 address instead of comparing an array address to 0.

------------------------------------------------------------------------
r23920 | ghudson | 2010-04-21 19:47:50 -0400 (Wed, 21 Apr 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/get_creds.c

Fix a memory leak in get_creds.c's try_fallback_realm().

------------------------------------------------------------------------
r23919 | ghudson | 2010-04-21 19:37:04 -0400 (Wed, 21 Apr 2010) | 5 lines
Changed paths:
   M /trunk/src/tests/hammer/kdc5_hammer.c

In the kdc5_hammer test program, simplify the cleanup logic of
get_server_key.  Fixes a memory leak where the result of
krb5_get_credentials() didn't get freed if krb5_mk_req_extended()
failed.

------------------------------------------------------------------------
r23918 | ghudson | 2010-04-21 19:23:09 -0400 (Wed, 21 Apr 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/gssapi/krb5/init_sec_context.c

Amend r23917 to correct some uses of *out_creds which should now use
the local variable.

------------------------------------------------------------------------
r23917 | ghudson | 2010-04-21 19:20:29 -0400 (Wed, 21 Apr 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/gssapi/krb5/init_sec_context.c

In the get_credentials() helper of the gss-krb5 init_sec_context code,
ensure that *out_creds is only filled in on successful return.

------------------------------------------------------------------------
r23916 | ghudson | 2010-04-21 19:14:49 -0400 (Wed, 21 Apr 2010) | 3 lines
Changed paths:
   M /trunk/src/tests/dejagnu/t_inetd.c

In t_inetd, zero out l_inaddr before filling it in, as is relatively
common in networking code.  Silences a Coverity defect.

------------------------------------------------------------------------
r23913 | tlyu | 2010-04-20 18:35:42 -0400 (Tue, 20 Apr 2010) | 2 lines
Changed paths:
   M /trunk/src/Makefile.in
   M /trunk/src/config/post.in
   M /trunk/src/util/k5test.py

Only create runenv.py at BUILDTOP.  Fix bugs in k5test.py relating to
environment initialization, also so that "make testrealm" works again.
------------------------------------------------------------------------
r23912 | tlyu | 2010-04-20 17:12:10 -0400 (Tue, 20 Apr 2010) | 10 lines
Changed paths:
   M /trunk/src/kdc/do_tgs_req.c
   M /trunk/src/tests/dejagnu/config/default.exp
   M /trunk/src/tests/dejagnu/krb-standalone/standalone.exp

ticket: 6702
target_version: 1.8.2
tags: pullup

Fix CVE-2010-1230 (MITKRB5-SA-2010-004) double-free in KDC triggered
by ticket renewal.  Add a test case.

See also http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=577490

Thanks to Joel Johnson and Brian Almeida for the reports.
------------------------------------------------------------------------
r23909 | ghudson | 2010-04-20 03:56:58 -0400 (Tue, 20 Apr 2010) | 9 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/get_creds.c

When setting up to get a TGT for the service realm in the TGS code,
get the cached local TGT before setting up the realm path.

Prior to this change, calling krb5_get_credentials() with an empty
ccache would result in KRB5_CC_NOTFOUND for a foreign server
principal, but would result in KRB5_NO_TKT_IN_REALM (generated by
krb5_walk_realm_tree) for a local server principal.  With this change,
KRB5_CC_NOTFOUND is returned in both cases.

------------------------------------------------------------------------
r23906 | ghudson | 2010-04-20 03:38:12 -0400 (Tue, 20 Apr 2010) | 5 lines
Changed paths:
   M /trunk/src/include/krb5/krb5.hin
   M /trunk/src/lib/krb5/krb/get_creds.c
   M /trunk/src/lib/krb5/krb/get_in_tkt.c
   M /trunk/src/lib/krb5/krb/init_creds_ctx.h

Add KRB5_INIT_CREDS_STEP_FLAG_CONTINUE for parity with Heimdal.
Rename KRB5_TKT_CREDS_CONTINUE to KRB5_TKT_CREDS_STEP_FLAG_CONTINUE
 for consistency.
Adjust init_creds context to be less confusing in light of the above.

------------------------------------------------------------------------
r23905 | tlyu | 2010-04-16 17:45:22 -0400 (Fri, 16 Apr 2010) | 4 lines
Changed paths:
   M /trunk/src/aclocal.m4
   M /trunk/src/config/post.in
   M /trunk/src/config/pre.in
   M /trunk/src/config/shlib.conf
   M /trunk/src/tests/dejagnu/Makefile.in
   M /trunk/src/util/k5test.py

Build runenv.py, holding environment variable settings required for
running programs out of the build tree during python-based tests.
Also updates shilb.conf to set RUN_VARS to make it easier to generate
this sort of thing.
------------------------------------------------------------------------
r23900 | ghudson | 2010-04-14 10:36:32 -0400 (Wed, 14 Apr 2010) | 9 lines
Changed paths:
   M /trunk/src/include/k5-int.h
   M /trunk/src/include/krb5/krb5.hin
   M /trunk/src/lib/krb5/krb/Makefile.in
   D /trunk/src/lib/krb5/krb/gc_frm_kdc.c
   M /trunk/src/lib/krb5/krb/get_creds.c
   M /trunk/src/lib/krb5/krb/int-proto.h
   M /trunk/src/lib/krb5/libkrb5.exports

ticket: 6700
subject: Introduce new krb5_tkt_creds API

Merged from branches/iakerb: add new asynchronous krb5_tkt_creds APIs,
which allow a caller to take responsibility for transporting requests
to the KDC and getting responses back.  Rewrite the existing
krb5_get_credentials API in terms of the new functions.  Get rid of
krb5_get_cred_from_kdc and friends, since they are no longer used.

------------------------------------------------------------------------
r23899 | ghudson | 2010-04-14 10:01:05 -0400 (Wed, 14 Apr 2010) | 3 lines
Changed paths:
   M /trunk/src/clients/ksu/krb_auth_su.c

Use krb5_get_credentials in ksu instead of krb5_get_cred_from_kdc, so
we can get rid of the latter.  (Also simplifies the code.)

------------------------------------------------------------------------
r23891 | ghudson | 2010-04-13 18:57:34 -0400 (Tue, 13 Apr 2010) | 10 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/Makefile.in
   M /trunk/src/lib/krb5/krb/get_creds.c
   A /trunk/src/lib/krb5/krb/val_renew.c

ticket: 6699
subject: Validate and renew should work on non-TGT creds

The validate and renew APIs were using get_cred_from_kdc, which
always presents a TGT to get credentials.  Instead, they should
present the ticket they are trying to validate or renew.  This is
most easily done with krb5_get_cred_via_tkt().  Move the relevant
code into a new file since it now has nothing in common with the
other APIs implemented in get_creds.c.

------------------------------------------------------------------------
r23881 | ghudson | 2010-04-08 16:37:11 -0400 (Thu, 08 Apr 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/int-proto.h
   M /trunk/src/lib/krb5/krb/s4u_creds.c
   M /trunk/src/lib/krb5/krb/send_tgs.c

Remove krb5int_send_tgs(); it is unused as of r23358.

------------------------------------------------------------------------
r23874 | ghudson | 2010-04-08 12:39:31 -0400 (Thu, 08 Apr 2010) | 2 lines
Changed paths:
   M /trunk/src/include/krb5/krb5.hin
   M /trunk/src/lib/krb5/ccache/ccbase.c

Add krb5_cc_dup() to make it possible to copy ccache handles.

------------------------------------------------------------------------
r23870 | ghudson | 2010-04-07 23:15:44 -0400 (Wed, 07 Apr 2010) | 3 lines
Changed paths:
   M /trunk/src/clients/ksu/ccache.c
   M /trunk/src/configure.in

Assume lstat in Unix code, specifically clients/ksu/ccache.c.  Fix bad
indentation caused by an #ifdef HAVE_LSTAT block.

------------------------------------------------------------------------
r23858 | ghudson | 2010-04-04 16:46:02 -0400 (Sun, 04 Apr 2010) | 3 lines
Changed paths:
   M /trunk/src/util/testrealm.py

In testrealm.py, add ksu and kvno to the list of build directories
containing programs.

------------------------------------------------------------------------
r23844 | ghudson | 2010-03-29 18:08:21 -0400 (Mon, 29 Mar 2010) | 9 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/get_in_tkt.c

ticket: 6693
subject: Fix backwards flag output in krb5_init_creds_step()
tags: pullup
target_version: 1.8.1

krb5_init_creds_step() is taken from Heimdal, which sets *flags to 1
for "continue" and 0 for "stop".  Unfortunately, we got it backwards
in 1.8; fix it for 1.8.1.

------------------------------------------------------------------------
r23838 | raeburn | 2010-03-27 17:30:43 -0400 (Sat, 27 Mar 2010) | 1 line
Changed paths:
   M /trunk/src/kadmin/testing/scripts/init_db
   M /trunk/src/tests/Makefile.in
   M /trunk/src/tests/dejagnu/config/default.exp
   M /trunk/src/tests/mkeystash_compat/Makefile.in

Always pass -W option to kdb5_util create in testing.
------------------------------------------------------------------------
r23837 | ghudson | 2010-03-26 18:43:11 -0400 (Fri, 26 Mar 2010) | 7 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/gc_frm_kdc.c

In gc_frm_kdc.c, rename cur_kdc to cur_realm and nxt_kdc to nxt_realm,
to make it easier to distinguish them from cur_tgt and nxt_tgt.  Make
similar name changes to lst_kdc and kdc_list, as well as the function
find_nxt_kdc().

No functional changes.

------------------------------------------------------------------------
r23836 | ghudson | 2010-03-24 23:08:12 -0400 (Wed, 24 Mar 2010) | 4 lines
Changed paths:
   M /trunk/src/plugins/preauth/encrypted_challenge/encrypted_challenge_main.c

Straighten the if-ladder in encrypted challenge's process_preauth,
making it clearer that control drops through if one of the first
couple of steps fails.

------------------------------------------------------------------------
r23834 | tlyu | 2010-03-23 18:00:13 -0400 (Tue, 23 Mar 2010) | 6 lines
Changed paths:
   M /trunk/src/lib/gssapi/krb5/import_sec_context.c

ticket: 6678
target_version: 1.8.1
tags: pullup

Apply patch from Arlene Berry to not use freed memory in
gss_import_sec_context in some error paths.
------------------------------------------------------------------------
r23832 | tlyu | 2010-03-23 14:53:52 -0400 (Tue, 23 Mar 2010) | 7 lines
Changed paths:
   M /trunk/src/lib/gssapi/spnego/spnego_mech.c

ticket: 6690
target_version: 1.8.1
tags: pullup
subject: MITKRB5-SA-2010-002 CVE-2010-0628 denial of service in SPNEGO

The SPNEGO implementation in krb5-1.7 and later could crash due to
assertion failure when receiving some sorts of invalid GSS-API tokens.
------------------------------------------------------------------------
r23831 | epeisach | 2010-03-23 10:08:23 -0400 (Tue, 23 Mar 2010) | 3 lines
Changed paths:
   M /trunk/src/tests/gssapi/Makefile.in

Include t_spengno.o in list of OBJS so make clean will remove.


------------------------------------------------------------------------
r23829 | tlyu | 2010-03-23 02:09:02 -0400 (Tue, 23 Mar 2010) | 9 lines
Changed paths:
   M /trunk/src/include/k5-int-pkinit.h
   M /trunk/src/include/krb5/krb5.hin

ticket: 6689
target_version: 1.8.1
tags: pullup
subject: krb5_typed_data not castable to krb5_pa_data on 64-bit MacOSX

Move krb5_typed_data to krb5.hin from k5-int-pkinit.h because
krb5int_fast_process_error was assuming that it was safe to cast it to
krb5_pa_data.  It's not safe to do the cast on 64-bit MacOSX because
krb5.hin uses #pragma pack on that platform.
------------------------------------------------------------------------
r23821 | ghudson | 2010-03-19 23:50:06 -0400 (Fri, 19 Mar 2010) | 17 lines
Changed paths:
   M /trunk/src/include/krb5/krb5.hin

ticket: 6687
subject: Change KRB5_AUTHDATA_SIGNTICKET from 142 to 512
target_version: 1.8.1
tags: pullup

KRB5_AUTHDATA_SIGNTICKET, originally a Heimdal authorization data
type, was used to implement PAC-less constrained delegation in krb5
1.8.  Unfortunately, it was found that Microsoft was using 142 for
other purposes, which could result in a ticket issued by an MIT or
Heimdal KDC being rejected by a Windows Server 2008 R2 application
server.  Because KRB5_AUTHDATA_SIGNTICKET is only used to communicate
among a realm's KDCs, it is relatively easy to change the number, so
MIT and Heimdal are both migrating to a new number.  This change will
cause a transitional interoperability issue when a realm mixes MIT
krb5 1.8 (or Heimdal 1.3.1) KDCs with MIT krb5 1.8.1 (or Heimdal
1.3.2) KDCs, but only for constrained delegation evidence tickets.

------------------------------------------------------------------------
r23820 | ghudson | 2010-03-19 12:17:05 -0400 (Fri, 19 Mar 2010) | 7 lines
Changed paths:
   M /trunk/doc/admin.texinfo
   M /trunk/src/config-files/krb5.conf.M

ticket: 6680
target_version: 1.8.1
tags: pullup

Document the ticket_lifetime libdefaults setting (which was added in
r16656, #2656).  Based on a patch from nalin@redhat.com.

------------------------------------------------------------------------
r23819 | ghudson | 2010-03-18 13:37:31 -0400 (Thu, 18 Mar 2010) | 7 lines
Changed paths:
   M /trunk/src/clients/kpasswd/kpasswd.c

ticket: 6683
target_version: 1.8.1
tags: pullup

Fix the kpasswd fallback from the ccache principal name to the
username in the case where the ccache doesn't exist.

------------------------------------------------------------------------
r23818 | ghudson | 2010-03-18 13:17:31 -0400 (Thu, 18 Mar 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/mk_req_ext.c

Include int-proto.h in mk_req_ext.c for krb5int_validate_times
declaration.

------------------------------------------------------------------------
r23817 | raeburn | 2010-03-17 22:45:57 -0400 (Wed, 17 Mar 2010) | 1 line
Changed paths:
   M /trunk/src/include/net-server.h

Untabify.
------------------------------------------------------------------------
r23816 | raeburn | 2010-03-17 22:44:41 -0400 (Wed, 17 Mar 2010) | 1 line
Changed paths:
   M /trunk/src/include/net-server.h

Copyright notice.
------------------------------------------------------------------------
r23815 | ghudson | 2010-03-17 17:10:10 -0400 (Wed, 17 Mar 2010) | 7 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/gic_pwd.c

ticket: 6681
target_version: 1.8.1
tags: pullup

When checking for KRB5_GET_INIT_CREDS_OPT_CHG_PWD_PRMPT, don't
dereference options if it's NULL.

------------------------------------------------------------------------
r23814 | ghudson | 2010-03-17 16:16:32 -0400 (Wed, 17 Mar 2010) | 5 lines
Changed paths:
   M /trunk/src/clients/kinit/kinit.c

ticket: 6684

Add more verbosity when the -V option to kinit is specified.  Based on
a patch from Jeff Blaine <jblaine@kickflop.net>.

------------------------------------------------------------------------
r23813 | ghudson | 2010-03-17 15:34:48 -0400 (Wed, 17 Mar 2010) | 3 lines
Changed paths:
   M /trunk/src/configure.in

Fix the Python version check to use constructs available in older
versions of Python.  (python --version was added in 2.5.)

------------------------------------------------------------------------
r23812 | ghudson | 2010-03-17 15:11:09 -0400 (Wed, 17 Mar 2010) | 3 lines
Changed paths:
   M /trunk/src/configure.in

Add a version check to the Python test, so that we don't try to run
k5test in Python 2.3 or below.

------------------------------------------------------------------------
r23811 | raeburn | 2010-03-17 02:00:56 -0400 (Wed, 17 Mar 2010) | 8 lines
Changed paths:
   A /trunk/src/include/net-server.h (from /users/raeburn/branches/network-merge/src/include/net-server.h:23804)
   M /trunk/src/kadmin/server/Makefile.in
   M /trunk/src/kadmin/server/deps
   M /trunk/src/kadmin/server/misc.c
   M /trunk/src/kadmin/server/misc.h
   D /trunk/src/kadmin/server/network.c
   M /trunk/src/kadmin/server/ovsec_kadmd.c
   M /trunk/src/kadmin/server/schpw.c
   M /trunk/src/kdc/Makefile.in
   M /trunk/src/kdc/deps
   M /trunk/src/kdc/dispatch.c
   M /trunk/src/kdc/extern.c
   M /trunk/src/kdc/extern.h
   M /trunk/src/kdc/kdc_util.c
   M /trunk/src/kdc/kdc_util.h
   M /trunk/src/kdc/main.c
   D /trunk/src/kdc/network.c
   M /trunk/src/lib/apputils/Makefile.in
   M /trunk/src/lib/apputils/deps
   D /trunk/src/lib/apputils/dummy.c
   A /trunk/src/lib/apputils/net-server.c (from /users/raeburn/branches/network-merge/src/lib/apputils/net-server.c:23804)

Merge users/raeburn/branches/network-merge.

Re-integrates the forked versions of network.c in kdc and
kadmin/server.  Server-specific initialization and SIGHUP-reset code
is moved into other source files; the more generic network-servicing
code is merged and moved into apputils library already used by both
programs.

------------------------------------------------------------------------
r23810 | tlyu | 2010-03-16 15:14:33 -0400 (Tue, 16 Mar 2010) | 7 lines
Changed paths:
   M /trunk/src/kdc/do_tgs_req.c

ticket: 6685
target_version: 1.8.1
subject: handle NT_SRV_INST in service principal referrals

Handle NT_SRV_INST in service principal cross-realm referrals, as
Windows apparently uses that instead of NT_SRV_HST for at least some
service principals.
------------------------------------------------------------------------
r23805 | tlyu | 2010-03-15 14:53:02 -0400 (Mon, 15 Mar 2010) | 2 lines
Changed paths:
   M /trunk/src/config/post.in
   M /trunk/src/config/pre.in
   M /trunk/src/tests/t_anonpkinit.py

Set up KRB5_RUN_ENV for pytests, so that Python-based tests can run
without first running "make install".
------------------------------------------------------------------------
r23799 | ghudson | 2010-03-11 12:05:24 -0500 (Thu, 11 Mar 2010) | 8 lines
Changed paths:
   M /trunk/src/lib/kadm5/srv/server_kdb.c
   M /trunk/src/lib/kadm5/unit-test/api.current/randkey-principal.exp

ticket: 6679
subject: Lazy history key creation

Create kadmin/history lazily when we need it (i.e. when a password is
changed on a principal with a policy) instead of whenever we open the
database.  Allows kadmin.local to be used as a read-only tool on non-
kadmin-conformant database back ends such as the Samba bridge.

------------------------------------------------------------------------
r23798 | tsitkova | 2010-03-10 15:45:12 -0500 (Wed, 10 Mar 2010) | 2 lines
Changed paths:
   M /trunk/src/include/k5-int.h
   M /trunk/src/lib/kadm5/logger.c

Use KRB5_CONF_ macros instead of strings in the source file for profile config attributes "default" and "logging"

------------------------------------------------------------------------
r23796 | ghudson | 2010-03-10 14:30:58 -0500 (Wed, 10 Mar 2010) | 1 line
Changed paths:
   D /trunk/src/include/spnego-asn1.h

Remove vestigial include/spnego-asn1.h.
------------------------------------------------------------------------
r23794 | ghudson | 2010-03-07 23:39:08 -0500 (Sun, 07 Mar 2010) | 4 lines
Changed paths:
   M /trunk/src/Makefile.in
   M /trunk/src/util/k5test.py
   A /trunk/src/util/testrealm.py

Add a "make testrealm" target using the Python test framework.  As
part of this, expose the environments in K5Realm as attributes so
that test scripts can modify them.

------------------------------------------------------------------------
r23773 | epeisach | 2010-03-07 15:01:36 -0500 (Sun, 07 Mar 2010) | 8 lines
Changed paths:
   M /trunk/src/tests/dejagnu/Makefile.in
   M /trunk/src/tests/dejagnu/t_inetd.c
   M /trunk/src/util/k5test.py

subject: Make python test start_in_inetd function

util/k5test.py: Fix incorrect variable used
tests/dejagnu/t_inetd.c: Flush stdout after outputting "Ready!" 
tests/dejagnu/Makefile.in: Always compile t_inetd - even in runtest is not
			    present


------------------------------------------------------------------------
r23772 | ghudson | 2010-03-05 15:35:26 -0500 (Fri, 05 Mar 2010) | 7 lines
Changed paths:
   M /trunk/src/lib/gssapi/spnego/spnego_mech.c

ticket: 6674
target_version: 1.8.1
tags: pullup

Release the internal_name field of a SPNEGO context if it has not been
claimed for a caller argument.

------------------------------------------------------------------------
r23771 | ghudson | 2010-03-05 15:33:37 -0500 (Fri, 05 Mar 2010) | 1 line
Changed paths:
   M /trunk/src/tests/gssapi/Makefile.in
   A /trunk/src/tests/gssapi/t_gssapi.py

Add a Python test to run t_spnego.
------------------------------------------------------------------------
r23770 | ghudson | 2010-03-05 15:32:40 -0500 (Fri, 05 Mar 2010) | 3 lines
Changed paths:
   M /trunk/src/config/post.in

In post.in, add a check-pytests intermediate target for Makefile.in to
add dependencies to, for test scripts which run C test programs.

------------------------------------------------------------------------
r23769 | ghudson | 2010-03-05 15:31:13 -0500 (Fri, 05 Mar 2010) | 3 lines
Changed paths:
   M /trunk/src/tests/gssapi/t_spnego.c

Fix a double-free in the t_spnego test program resulting from overly
careless cutting and pasting.

------------------------------------------------------------------------
r23768 | ghudson | 2010-03-05 14:30:32 -0500 (Fri, 05 Mar 2010) | 3 lines
Changed paths:
   M /trunk/src/tests/t_anonpkinit.py
   M /trunk/src/tests/t_general.py
   M /trunk/src/util/k5test.py

Add a message parameter to k5test's success(), to briefly indicate the
scope of test scripts.  Only displayed when verbose is set.

------------------------------------------------------------------------
r23767 | ghudson | 2010-03-05 14:19:42 -0500 (Fri, 05 Mar 2010) | 7 lines
Changed paths:
   M /trunk/src/lib/krb5/os/changepw.c

ticket: 6661
target_version: 1.8.1
tags: pullup

Add IPv6 support to changepw.c (reverting r21004 since it is no longer
necessary).  Patch from Submit Bose <sbose@redhat.com>.

------------------------------------------------------------------------
r23766 | ghudson | 2010-03-05 12:45:46 -0500 (Fri, 05 Mar 2010) | 10 lines
Changed paths:
   M /trunk/src/kdc/kdc_authdata.c

ticket: 6676
subject: Ignore improperly encoded signedpath AD elements
target_version: 1.8.1
tags: pullup

We have some reason to believe Microsoft and Heimdal are both using
the authdata value 142 for different purposes, leading to failures in
verify_ad_signedpath().  For better interoperability, treat such
tickets as unsigned, rather than invalid.

------------------------------------------------------------------------
r23765 | ghudson | 2010-03-04 23:18:51 -0500 (Thu, 04 Mar 2010) | 2 lines
Changed paths:
   M /trunk/src/config/post.in

Error out if a Python test program fails.

------------------------------------------------------------------------
r23764 | ghudson | 2010-03-04 16:37:20 -0500 (Thu, 04 Mar 2010) | 2 lines
Changed paths:
   M /trunk/src/util/k5test.py

Clean up a help string in k5test.

------------------------------------------------------------------------
r23763 | ghudson | 2010-03-04 16:24:54 -0500 (Thu, 04 Mar 2010) | 9 lines
Changed paths:
   M /trunk/src/config/post.in
   M /trunk/src/config/pre.in
   M /trunk/src/configure.in
   M /trunk/src/tests/Makefile.in
   A /trunk/src/tests/t_anonpkinit.py
   A /trunk/src/tests/t_general.py
   M /trunk/src/util
   A /trunk/src/util/k5test.py

ticket: 6672
subject: Python test framework

Add a framework for writing tests in Python.  Documentation is in the
initial docstring of util/k5test.py.  Inaugurate the framework with
two test scripts, t_general.py and t_anonypkinit.py, which together
test the same operations as standalone.exp from the dejagnu test
suite.

------------------------------------------------------------------------
r23759 | ghudson | 2010-02-28 15:32:00 -0500 (Sun, 28 Feb 2010) | 10 lines
Changed paths:
   M /trunk/src/lib/kadm5/unit-test/api.current/init-v2.exp
   M /trunk/src/tests/dejagnu/config/default.exp

Remove some more test suite cruft:
* localhostname from get_hostname was unused.
* database_name is no longer used except (misleadingly) in kdb5_util
  output.
* admin_database_name and admin_database_lockfile are no longer used.
* default_domain is only used for v4->v5 principal conversion, which
  isn't tested.
* libkadm5's init-v2.exp had a copy of get_hostname; domain and
  localhostname from it were unused.

------------------------------------------------------------------------
r23758 | ghudson | 2010-02-27 04:49:32 -0500 (Sat, 27 Feb 2010) | 6 lines
Changed paths:
   M /trunk/src/config/shlib.conf

On Linux platforms, use -Wl,--enable-new-dtags when linking shared
libraries and programs using them.  The primary effect is to get ld to
set DT_RUNPATH in addition to DT_RPATH, which in turn allows the
LD_LIBRARY_PATH environment variable to override the compiled-in
runpath, which is friendlier to the test framework.

------------------------------------------------------------------------
r23752 | tsitkova | 2010-02-25 16:16:16 -0500 (Thu, 25 Feb 2010) | 2 lines
Changed paths:
   M /trunk/doc/build.texinfo

Updated documentation  with information about --with-crypto-impl=IMPL configuration flag

------------------------------------------------------------------------
r23750 | tlyu | 2010-02-25 15:09:45 -0500 (Thu, 25 Feb 2010) | 6 lines
Changed paths:
   M /trunk/doc/admin.texinfo
   M /trunk/src/config-files/krb5.conf.M

ticket: 6669
target_version: 1.8
tags: pullup
subject: doc updates for allow_weak_crypto

Update documentation to be more helpful about allow_weak_crypto.
------------------------------------------------------------------------
r23749 | ghudson | 2010-02-24 13:57:08 -0500 (Wed, 24 Feb 2010) | 9 lines
Changed paths:
   M /trunk/src/lib/kadm5/srv/svr_principal.c

ticket: 6668
subject: Two problems in kadm5_get_principal mask handling
target_version: 1.8
tags: pullup

KADM5_MOD_NAME was being applied to entry->principal instead of
entry->mod_name.  KADM5_MKVNO was not being applied to entry->mkvno.
Patch from Marcus Watts <mdw@umich.edu>.

------------------------------------------------------------------------
r23745 | ghudson | 2010-02-22 13:27:55 -0500 (Mon, 22 Feb 2010) | 4 lines
Changed paths:
   M /trunk/src/tests/dejagnu/config/default.exp

Remove some more dejagnu test suite cruft:
  * check_date was only used by the application tests.
  * touch was never used.

------------------------------------------------------------------------
r23744 | ghudson | 2010-02-22 13:12:51 -0500 (Mon, 22 Feb 2010) | 10 lines
Changed paths:
   M /trunk/src/tests/dejagnu/config/default.exp

Remove some unused cruft in the dejagnu test suite's default.exp:
  * RLOGIN, RLOGIN_FLAGS, ROOT_PROMPT, ROOT_SHELL, check_k5login,
    restore_kerberos_env, setup_root_shell, setup_root_shell_noremote,
    setup_wrapper: No longer used now that the applications are in a
    separate tree.
  * v4_compatible_enctype: No longer used with krb4 support gone.
  * tail1, krb_exit: Apparently never used.
  * KERBEROS_SERVER: Added long ago in r5686 and removed shortly after
    in r5695, but the test suite support for it never got excised.

------------------------------------------------------------------------
r23743 | ghudson | 2010-02-22 11:10:05 -0500 (Mon, 22 Feb 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/gssapi/spnego/spnego_mech.c

Explain the current SPNEGO initiator/acceptor design in comments.  No
code changes.

------------------------------------------------------------------------
r23742 | ghudson | 2010-02-21 23:52:30 -0500 (Sun, 21 Feb 2010) | 24 lines
Changed paths:
   M /trunk/src/lib/gssapi/spnego/spnego_mech.c

ticket: 6603
target_version: 1.8
tags: pullup

Fix two unrelated problems in SPNEGO which don't crop up with the krb5
mechanism.

1. The third call to spnego_init_accept_context uses faulty logic to
determine if the exchange is complete, preventing a third mech token
from being sent to the acceptor if no MIC exchange is required.
Follow the logic used in the second call (in init_ctx_nego), which is
correct.

2. If the acceptor selects a mech other than the optimistic mech, it
sets sc->mic_reqd to 1 whether or not the selected mech supports MICs
(which isn't known until the mech completes).  Most code outside of
handle_mic checks sc->mic_reqd along with (sc->ctx_flags &
GSS_C_INTEG_FLAG), but the code in acc_ctx_call_acc neglected to do
so, so it could improperly delegate responsibility for deciding when
the negotiation was finished to handle_mic--which never gets called if
(sc->ctx_flags & GSS_C_INTEG_FLAG) is false.  Fix acc_ctx_call_acc to
check sc->ctx_flags so that mechs which don't support integrity
protection can complete if they are selected non-optimistically.

------------------------------------------------------------------------
r23741 | raeburn | 2010-02-20 02:37:13 -0500 (Sat, 20 Feb 2010) | 1 line
Changed paths:
   M /trunk/src/include/k5-platform.h

Use bswap16 and bswap32 on NetBSD.
------------------------------------------------------------------------
r23740 | raeburn | 2010-02-19 23:26:53 -0500 (Fri, 19 Feb 2010) | 1 line
Changed paths:
   M /trunk/src/lib/gssapi/mechglue/deps
   M /trunk/src/plugins/authdata/greet_client/deps
   M /trunk/src/plugins/authdata/greet_server/deps
   M /trunk/src/plugins/kdb/hdb/deps
   M /trunk/src/plugins/locate/python/deps
   M /trunk/src/util/ss/deps

Update dependencies.
------------------------------------------------------------------------
r23739 | raeburn | 2010-02-19 23:26:50 -0500 (Fri, 19 Feb 2010) | 2 lines
Changed paths:
   M /trunk/src/plugins/preauth/wpse/wpse_main.c

Move array decl from mixed within code down into the block where it's
actually used, for C90 compliance.
------------------------------------------------------------------------
r23738 | raeburn | 2010-02-19 23:26:47 -0500 (Fri, 19 Feb 2010) | 1 line
Changed paths:
   M /trunk/src/plugins/preauth/wpse/wpse.exports

Update export list for 2007 plugin interface change.
------------------------------------------------------------------------
r23737 | raeburn | 2010-02-19 23:26:43 -0500 (Fri, 19 Feb 2010) | 2 lines
Changed paths:
   M /trunk/src/plugins/preauth/cksum_body/cksum_body_main.c

Move array decl from mixed within code down into the block where it's
actually used, for C90 compliance.
------------------------------------------------------------------------
r23736 | ghudson | 2010-02-19 12:06:58 -0500 (Fri, 19 Feb 2010) | 3 lines
Changed paths:
   M /trunk/src/plugins/preauth/cksum_body/cksum_body.exports
   D /trunk/src/plugins/preauth/cksum_body/src

Make plugins/cksum_body more likely to build, and remove the empty src
directory within.

------------------------------------------------------------------------
r23735 | ghudson | 2010-02-18 13:49:11 -0500 (Thu, 18 Feb 2010) | 8 lines
Changed paths:
   M /trunk/src/kdc/do_tgs_req.c

ticket: 6659
target_version: 1.8
tags: pullup

The TGS code was not freeing authdata.  This is an old leak which was
made more evident in 1.8 by the addition of ad-signedpath authdata
appearing in most tickets issued through the TGS path.

------------------------------------------------------------------------
r23734 | ghudson | 2010-02-18 13:04:47 -0500 (Thu, 18 Feb 2010) | 17 lines
Changed paths:
   M /trunk/src/lib/crypto/openssl/enc_provider/des.c
   M /trunk/src/lib/crypto/openssl/enc_provider/des3.c
   M /trunk/src/lib/crypto/openssl/enc_provider/rc4.c

ticket: 6665
subject: Fix cipher state chaining in OpenSSL back end
target_version: 1.8
tags: pullup

Make cipher state chaining work in the OpenSSL back end for des, des3,
and arcfour enc providers.  Subtleties:

* DES and DES3 have checks to avoid clobbering ivec with uninitialized
  data if there is no data to encrypt.
* Arcfour saves the OpenSSL cipher context across calls.  To protect
  against a caller improperly copying the state (which happens to work
  with other enc providers), a loopback pointer is used, as in GSSAPI.
* EVP_EncryptFinal_ex is unnecessary with stream ciphers and would
  interfere with cipher state chaining if it did anything, so just
  remove it.

------------------------------------------------------------------------
r23733 | ghudson | 2010-02-17 15:27:22 -0500 (Wed, 17 Feb 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/crypto/crypto_tests/t_encrypt.c

Add display statements for the encrypted tokens generated by t_encrypt
so that its output can be compared between different back ends.

------------------------------------------------------------------------
r23732 | tsitkova | 2010-02-17 11:09:43 -0500 (Wed, 17 Feb 2010) | 6 lines
Changed paths:
   A /trunk/src/util/confvalidator
   A /trunk/src/util/confvalidator/README
   A /trunk/src/util/confvalidator/confparser.py
   A /trunk/src/util/confvalidator/rules.yml
   A /trunk/src/util/confvalidator/validator.conf
   A /trunk/src/util/confvalidator/validator.py

validator.py is a tool to validate kerb configuration files. 
First, the configuration file is parsed (confparser.py) and validated against formating errors (such as mismatching brackets)
Then the list of the allowed configuration attributes is compiled from k5-int.h and rules.yml 
Finally, the kerb configuration file is validated against the list of the allowed strings.
If the error, or something that validator does not understand, is found the warning is issued in the tree-like form indicating the layer where the problem has occurred.

------------------------------------------------------------------------
r23726 | tlyu | 2010-02-16 17:41:27 -0500 (Tue, 16 Feb 2010) | 7 lines
Changed paths:
   M /trunk/src/util/mkrel

ticket: 6663
subject: update mkrel to deal with changed source layout
target_version: 1.8
tags: pullup

Update mkrel so it deals somewhat better with removed src/lib/des425,
NOTICES, etc.
------------------------------------------------------------------------
r23724 | tlyu | 2010-02-16 17:10:17 -0500 (Tue, 16 Feb 2010) | 9 lines
Changed paths:
   M /trunk/src/kdc/do_as_req.c
   M /trunk/src/kdc/do_tgs_req.c
   M /trunk/src/kdc/fast_util.c

ticket: 6662
subject: MITKRB5-SA-2010-001 CVE-2010-0283 KDC denial of service
tags: pullup
target_version: 1.8

Code introduced in krb5-1.7 can cause an assertion failure if a
KDC-REQ is internally inconsistent, specifically if the ASN.1 tag
doesn't match the msg_type field.  Thanks to Emmanuel Bouillon (NATO
C3 Agency) for discovering and reporting this vulnerability.
------------------------------------------------------------------------
r23723 | raeburn | 2010-02-14 20:49:19 -0500 (Sun, 14 Feb 2010) | 1 line
Changed paths:
   D /trunk/src/lib/krb4_32.def

Remove another remnant of krb4.
------------------------------------------------------------------------
r23722 | ghudson | 2010-02-13 13:39:37 -0500 (Sat, 13 Feb 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/gssapi/spnego/spnego_mech.c

Clarify the SPNEGO NegHints code and plug two cases where half-created
context could be leaked.

------------------------------------------------------------------------
r23717 | ghudson | 2010-02-12 14:18:17 -0500 (Fri, 12 Feb 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/gssapi/spnego/spnego_mech.c

Simplify the SPNEGO neg_mechs intersection logic a bit using
gss_test_oid_set_member.

------------------------------------------------------------------------
r23716 | ghudson | 2010-02-11 11:07:08 -0500 (Thu, 11 Feb 2010) | 15 lines
Changed paths:
   M /trunk/doc/admin.texinfo
   M /trunk/src/lib/kadm5/server_internal.h
   M /trunk/src/lib/kadm5/srv/libkadm5srv_mit.exports
   M /trunk/src/lib/kadm5/srv/server_kdb.c
   M /trunk/src/lib/kadm5/srv/svr_principal.c
   M /trunk/src/lib/kadm5/unit-test/api.current/randkey-principal.exp

ticket: 6660
subject: Minimal support for updating history key
target_version: 1.8
tags: pullup

Add minimal support for re-randomizing the history key:

* cpw -randkey kadmin/history now works, but creates only one key.
* cpw -randkey -keepold kadmin/history still fails.
* libkadm5 no longer caches the history key.  Performance impact
  is minimal since password changes are not common.
* randkey no longer checks the newly randomized key against old keys,
  and the disabled code to do so in setkey/setv4key is gone, so now
  only kadm5_chpass_principal_3 accesses the password history.

------------------------------------------------------------------------
r23715 | ghudson | 2010-02-10 18:44:18 -0500 (Wed, 10 Feb 2010) | 14 lines
Changed paths:
   M /trunk/src/lib/gssapi/generic/gssapi.hin
   M /trunk/src/lib/gssapi/krb5/gssapi_krb5.c
   M /trunk/src/lib/gssapi/libgssapi_krb5.exports
   M /trunk/src/lib/gssapi/mechglue/Makefile.in
   M /trunk/src/lib/gssapi/mechglue/g_initialize.c
   A /trunk/src/lib/gssapi/mechglue/g_set_neg_mechs.c
   M /trunk/src/lib/gssapi/mechglue/mglueP.h
   M /trunk/src/lib/gssapi/spnego/gssapiP_spnego.h
   M /trunk/src/lib/gssapi/spnego/spnego_mech.c
   M /trunk/src/tests/gssapi/Makefile.in
   A /trunk/src/tests/gssapi/t_spnego.c

ticket: 6658
subject: Implement gss_set_neg_mechs
target_version: 1.8
tags: pullup

Implement gss_set_neg_mechs in SPNEGO by intersecting the provided
mech set with the mechanisms available in the union credential.  As
we now need space to hold the mech set, the SPNEGO credential is now
a structure and not just a mechglue credential.

t_spnego.c is a test program which exercises the new logic.  Like the
other GSSAPI tests, it is not run as part of "make check" at this
time.

------------------------------------------------------------------------
r23714 | ghudson | 2010-02-09 20:55:36 -0500 (Tue, 09 Feb 2010) | 13 lines
Changed paths:
   M /trunk/src/kdc/do_as_req.c
   M /trunk/src/kdc/do_tgs_req.c
   M /trunk/src/kdc/kdc_preauth.c
   M /trunk/src/kdc/kdc_util.c
   M /trunk/src/kdc/kdc_util.h

ticket: 6656

Followon fixes to r23712:
* A few formatting fixes.
* Fix unlikely leak in kdc_handle_protected_negotiation: if
  add_pa_data_element with copy == FALSE fails, it's still the
  caller's responsibility to free pa.contents.
* Fix pre-existing (since r23465) leak of reply_encpart.enc_padata in
  process_as_req.
* Call add_pa_data_element with copy == TRUE in
  return_referral_enc_padata since we are passing memory owned by the
  database entry.

------------------------------------------------------------------------
r23713 | hartmans | 2010-02-09 14:15:12 -0500 (Tue, 09 Feb 2010) | 9 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/fast.c

subject: krb5int_fast_free_state segfaults if state is null
ticket: 6657
target_version: 1.8
tags: pullup

krb5int_fast_free_state fails if state is null.  INstead it should
simply return Reorganization of the get_init_creds logic has created
situations where the init_creds loop can fail between the time when
the context is initialized and the fast state is initialized.
------------------------------------------------------------------------
r23712 | hartmans | 2010-02-09 14:15:07 -0500 (Tue, 09 Feb 2010) | 13 lines
Changed paths:
   M /trunk/src/kdc/do_as_req.c
   M /trunk/src/kdc/do_tgs_req.c
   M /trunk/src/kdc/kdc_preauth.c
   M /trunk/src/kdc/kdc_util.c
   M /trunk/src/kdc/kdc_util.h

subject: enc_padata can include empty sequence
ticket: 6656
target_version: 1.8
tags: pullup

There are two issues with return_enc_padata.
1)  It often will return an empty sequence of enc_padata rather than not including the field
2) FAST negotiation is double supported in the referral tgs path and not supported in the non-referral path

Rewrite the return_enc_padata logic to:

* Split  out referral interactions with kdb into its own function
* Use add_pa_data_element
------------------------------------------------------------------------
r23699 | ghudson | 2010-02-05 16:46:35 -0500 (Fri, 05 Feb 2010) | 10 lines
Changed paths:
   M /trunk/src/config/shlib.conf

ticket: 6643
target_version: 1.8
tags: pullup

Consistently place $(LDFLAGS) after $(SHLIB_EXPFLAGS) when building
shared libraries.  Previously we sometimes failing to use $(LDFLAGS)
at all, and at other times were putting it before $(SHLIB_EXPFLAGS)
where it could pick up tree-internal libraries from outside the build
tree.

------------------------------------------------------------------------
r23698 | tlyu | 2010-02-05 15:52:42 -0500 (Fri, 05 Feb 2010) | 7 lines
Changed paths:
   M /trunk/src/lib/gssapi/mechglue/g_set_cred_option.c

ticket: 6601
tags: pullup
target_version: 1.8

Apply patch from Arlene Berry to handle the case where a mechanism
implements set_cred_option but does not implement the requested
option.
------------------------------------------------------------------------
r23697 | ghudson | 2010-02-04 22:43:54 -0500 (Thu, 04 Feb 2010) | 12 lines
Changed paths:
   M /trunk/src/kdc/kdc_authdata.c
   M /trunk/src/kdc/kdc_util.c
   M /trunk/src/kdc/kdc_util.h

ticket: 6655
subject: Fix cross-realm handling of AD-SIGNEDPATH
target_version: 1.8
tags: pullup

Avoid setting AD-SIGNEDPATH when returning a cross-realm TGT.
Previously we were avoiding it when answering a cross-realm client,
which was wrong.

Don't fail out on an invalid AD-SIGNEDPATH checksum; just don't trust
the ticket for S4U2Proxy (as if AD-SIGNEDPATH weren't present).

------------------------------------------------------------------------
r23696 | tlyu | 2010-02-04 22:25:49 -0500 (Thu, 04 Feb 2010) | 6 lines
Changed paths:
   M /trunk/src/lib/gssapi/mechglue/g_inq_context.c

ticket: 6600
tags: pullup
target_version: 1.8

Apply patch from Arlene Berry to avoid segfault if a mech
gss_inquire_context returns GSS_C_NO_NAME for the target name.
------------------------------------------------------------------------
r23695 | tlyu | 2010-02-04 22:05:42 -0500 (Thu, 04 Feb 2010) | 7 lines
Changed paths:
   M /trunk/src/lib/gssapi/krb5/init_sec_context.c

ticket: 6598
tags: pullup
target_version: 1.8

Apply patch from Arlene Berry to return a comparable static OID object
instead of the application-passed (probably dynamically allocated)
OID, to avoid use-after-free problems.
------------------------------------------------------------------------
r23694 | ghudson | 2010-02-03 14:55:05 -0500 (Wed, 03 Feb 2010) | 7 lines
Changed paths:
   M /trunk/src/plugins/authdata/greet_server/greet_server.exports

ticket: 6654
subject: Fix greet_server build
target_version: 1.8
tags: pullup

Fix the export list for the greet_server plugin.

------------------------------------------------------------------------
r23682 | ghudson | 2010-02-01 19:37:33 -0500 (Mon, 01 Feb 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/send_tgs.c

Clean up error handling in krb5int_make_tgs_request_ext, closing some
unlikely memory leaks.

------------------------------------------------------------------------
r23681 | tlyu | 2010-02-01 16:48:19 -0500 (Mon, 01 Feb 2010) | 14 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/init_ctx.c
   M /trunk/src/lib/krb5/krb/t_etypes.c

ticket: 6653
subject: set_default_enctype_var should filter not reject weak enctypes
tags: pullup
target_version: 1.8

With allow_weak_crypto=false, set_default_enctype_var() (helper
function for krb5_set_default_tgs_enctypes(), etc.) was rejecting any
application-provided enctype list that contained any weak enctype even
when valid strong enctypes were present.  This broke some Samba
things.  Filter the weak enctypes instead.  Add test cases.

Reported to Debian by Holger Isenberg. (Debian bug #566977)
http://bugs.debian.org/cgi-bin/bugreport.cgi?bug=566977
Thanks to Simo Sorce for testing.
------------------------------------------------------------------------
r23680 | ghudson | 2010-02-01 12:18:23 -0500 (Mon, 01 Feb 2010) | 4 lines
Changed paths:
   M /trunk/src/include/kdb.h

Correct the DAL documentation of
KRB5_KDB_METHOD_CHECK_ALLOWED_TO_DELEGATE; proxy is the target
service, not the delegating service.

------------------------------------------------------------------------
r23679 | ghudson | 2010-01-31 16:04:48 -0500 (Sun, 31 Jan 2010) | 4 lines
Changed paths:
   M /trunk/src/kadmin/dbutil/kdb5_mkey.c

ticket: 6650

Fix minor error-handling bug in r23676.

------------------------------------------------------------------------
r23678 | ghudson | 2010-01-29 18:51:00 -0500 (Fri, 29 Jan 2010) | 2 lines
Changed paths:
   M /trunk/src/include/kdb.h

Correct the DAL documentation for how modules should handle referrals.

------------------------------------------------------------------------
r23677 | ghudson | 2010-01-28 20:22:17 -0500 (Thu, 28 Jan 2010) | 14 lines
Changed paths:
   M /trunk/src/lib/kdb/kdb_default.c

ticket: 6652
subject: Make decryption of master key list more robust
target_version: 1.8
tags: pullup

krb5_def_fetch_mkey_list was incorrectly filtering mkey_aux entries
when searching the list for an entry which can be decrypted with the
stashed master key.  This bug was masked in most cases by the mkvno
heuristic.

Remove the mkvno heuristic, since performance is not an issue for this
rarely-performed operation, and remove the incorrect enctype
comparison in the brute-force search.

------------------------------------------------------------------------
r23676 | ghudson | 2010-01-28 16:39:31 -0500 (Thu, 28 Jan 2010) | 17 lines
Changed paths:
   M /trunk/src/include/kdb.h
   M /trunk/src/kadmin/dbutil/kdb5_mkey.c
   M /trunk/src/lib/kadm5/srv/svr_principal.c
   M /trunk/src/lib/kdb/kdb5.c
   M /trunk/src/lib/kdb/libkdb5.exports

ticket: 6650
subject: Handle migration from pre-1.7 databases with master key kvno != 1
target_version: 1.7.1
tags: pullup

krb5_dbe_lookup_mkvno assumes an mkvno of 1 for entries with no
explicit tl_data.  We've seen at least one pre-1.7 KDB with a master
kvno of 0, violating this assumption.  Fix this as follows:

* krb5_dbe_lookup_mkvno outputs 0 instead of 1 if no tl_data exists.
* A new function krb5_dbe_get_mkvno translates this 0 value to the
  minimum version number in the mkey_list.  (krb5_dbe_lookup_mkvno
  cannot do this as it doesn't take the mkey_list as a parameter.)
* Call sites to krb5_dbe_lookup_mkvno are converted to
  krb5_dbe_get_mkvno, except for an LDAP case where it is acceptable
  to store 0 if the mkvno is unknown.

------------------------------------------------------------------------
r23675 | ghudson | 2010-01-27 17:17:12 -0500 (Wed, 27 Jan 2010) | 4 lines
Changed paths:
   M /trunk/src/plugins/kdb/ldap/deps
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/deps

ticket: 6649

Update the LDAP dependencies for r23674.

------------------------------------------------------------------------
r23674 | ghudson | 2010-01-26 22:52:52 -0500 (Tue, 26 Jan 2010) | 10 lines
Changed paths:
   M /trunk/src/include/kdb.h
   D /trunk/src/include/kdb_ext.h
   M /trunk/src/kdc/deps
   M /trunk/src/kdc/kdc_util.h
   M /trunk/src/lib/crypto/crypto_tests/deps
   M /trunk/src/lib/kdb/deps
   M /trunk/src/lib/kdb/kdb5.h
   M /trunk/src/lib/krb5/krb/deps
   M /trunk/src/lib/krb5/os/deps
   M /trunk/src/plugins/authdata/greet_server/greet_auth.c
   M /trunk/src/plugins/kdb/db2/deps
   M /trunk/src/plugins/kdb/db2/kdb_ext.c
   M /trunk/src/plugins/kdb/ldap/libkdb_ldap/kdb_ext.c
   M /trunk/src/util/ss/deps

ticket: 6649
subject: Get rid of kdb_ext.h and allow out-of-tree KDB plugins
target_version: 1.8
tags: pullup

Move the contents of kdb_ext.h into kdb.h, since there is no meaningful
"extensions" category of DB interfaces now that this stuff is in our
tree.  Allows out-of-tree KDB plugins to be built since we install
kdb.h.

------------------------------------------------------------------------
r23673 | tlyu | 2010-01-26 17:55:07 -0500 (Tue, 26 Jan 2010) | 8 lines
Changed paths:
   M /trunk/src/lib/gssapi/krb5/prf.c

ticket: 6648
target_version: 1.8
tags: pullup
subject: define MIN() in lib/gssapi/krb5/prf.c

Apply patch from Doug Engert to define MIN(), which was causing prf.c
to fail compilation on Solaris.  (The definition was probably leaking
from sys/param.h, included indirectly somehow.)
------------------------------------------------------------------------
r23672 | tlyu | 2010-01-26 13:43:29 -0500 (Tue, 26 Jan 2010) | 5 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/rd_req_dec.c

ticket: 6599
target_version: 1.8
tags: pullup

Apply patch from Arlene Berry to plug a memory leak.
------------------------------------------------------------------------
r23667 | ghudson | 2010-01-25 13:15:46 -0500 (Mon, 25 Jan 2010) | 4 lines
Changed paths:
   M /trunk/src/include/kdb.h

In the DAL comments, document KRB5_KDB_INCLUDE_PAC, and correct the
documentation of the S4U flags to indicate that they affect PAC
generation.

------------------------------------------------------------------------
r23666 | ghudson | 2010-01-24 23:12:21 -0500 (Sun, 24 Jan 2010) | 3 lines
Changed paths:
   M /trunk/src/include/kdb.h

Document the DAL interface in comments, as an aid to module
implementors.

------------------------------------------------------------------------
r23663 | ghudson | 2010-01-19 18:35:39 -0500 (Tue, 19 Jan 2010) | 9 lines
Changed paths:
   M /trunk/src/include/krb5/krb5.hin
   M /trunk/src/lib/krb5/krb/Makefile.in
   A /trunk/src/lib/krb5/krb/allow_weak.c
   M /trunk/src/lib/krb5/libkrb5.exports

ticket: 6645
subject: Add krb5_allow_weak_crypto API
target_version: 1.8
tags: pullup

Add an API to allow apps to override the profile setting of
allow_weak_crypto, so that aklog can work with krb5 1.8 out of the box
until OpenAFS finishes migrating away from DES.

------------------------------------------------------------------------
r23662 | ghudson | 2010-01-19 13:44:57 -0500 (Tue, 19 Jan 2010) | 3 lines
Changed paths:
   M /trunk/src/config/pre.in
   M /trunk/src/krb5-config.in
   M /trunk/src/lib/kadm5/clnt/Makefile.in
   D /trunk/src/lib/kadm5/clnt/libkadm5clnt.exports
   A /trunk/src/lib/kadm5/clnt/libkadm5clnt_mit.exports (from /trunk/src/lib/kadm5/clnt/libkadm5clnt.exports:23656)
   M /trunk/src/lib/kadm5/srv/Makefile.in
   D /trunk/src/lib/kadm5/srv/libkadm5srv.exports
   A /trunk/src/lib/kadm5/srv/libkadm5srv_mit.exports (from /trunk/src/lib/kadm5/srv/libkadm5srv.exports:23656)

ticket: 6644
subject: Change basename of libkadm5 libraries to avoid Heimdal conflict

------------------------------------------------------------------------
r23661 | ghudson | 2010-01-19 12:20:45 -0500 (Tue, 19 Jan 2010) | 3 lines
Changed paths:
   M /trunk/src/tests/dejagnu/config/default.exp

In kinit_anonymous, fail out if we receive a password request from
kinit, instead of hanging.

------------------------------------------------------------------------
r23657 | ghudson | 2010-01-14 11:09:24 -0500 (Thu, 14 Jan 2010) | 9 lines
Changed paths:
   M /trunk/src/lib/kadm5/srv/server_kdb.c

ticket: 6640
subject: Make history key exempt from permitted_enctypes
tags: pullup
target_version: 1.8

In kdb_init_hist, just use the first key entry in the kadmin/history
entry.  This makes the history key work even if the enctype is
disallowed by allow_weak_crypto=false or other configuration.

------------------------------------------------------------------------
r23652 | ghudson | 2010-01-12 16:59:58 -0500 (Tue, 12 Jan 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/crypto/crypto_tests/Makefile.in
   A /trunk/src/lib/crypto/crypto_tests/t_short.c

Add test program for decryption of overly short buffers.

------------------------------------------------------------------------
r23629 | ghudson | 2010-01-11 20:07:48 -0500 (Mon, 11 Jan 2010) | 9 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/fast.c

ticket: 6633
subject: Use keyed checksum type for DES FAST
target_version: 1.7
tags: pullup

DES enctypes have unkeyed mandatory-to-implement checksums.  Since
FAST requires a keyed checksum, we must pick something else in that
case.

------------------------------------------------------------------------
r23628 | ghudson | 2010-01-11 20:05:37 -0500 (Mon, 11 Jan 2010) | 9 lines
Changed paths:
   M /trunk/src/kdc/fast_util.c

ticket: 6632
subject: Simplify and fix FAST check for keyed checksum type
target_version: 1.8
tags: pullup

Use krb5_c_is_keyed_checksum to detect unkeyed checksums when handling
FAST requests.  The old check was broken for 1.8 because
krb5_c_verify_checksum got pickier about invalid keyblocks.

------------------------------------------------------------------------
r23625 | tsitkova | 2010-01-11 10:19:42 -0500 (Mon, 11 Jan 2010) | 4 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/Makefile.in
   M /trunk/src/lib/krb5/krb/gic_opt.c
   A /trunk/src/lib/krb5/krb/gic_opt_set_pa.c
   M /trunk/src/lib/krb5/krb/preauth2.c

Group together the funtions related to the supplying options to preauth plugin modules.
Also, removed krb5int_ prefix from the names of some static functions in gic_opt.c.s


------------------------------------------------------------------------
r23624 | epeisach | 2010-01-09 23:31:51 -0500 (Sat, 09 Jan 2010) | 4 lines
Changed paths:
   M /trunk/src/tests/asn.1/ktest.c

ktest_make_sample_ad_signedpath_data: Do not initialize client field twice. 
(memory leak).


------------------------------------------------------------------------
r23623 | tsitkova | 2010-01-09 21:12:55 -0500 (Sat, 09 Jan 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/Makefile.in
   M /trunk/src/lib/krb5/krb/authdata.c
   A /trunk/src/lib/krb5/krb/authdata_exp.c

Move krb5_authdata_export_authdata into the separate file for better code modularity.

------------------------------------------------------------------------
r23622 | epeisach | 2010-01-09 11:02:13 -0500 (Sat, 09 Jan 2010) | 10 lines
Changed paths:
   M /trunk/src/lib/crypto/builtin/pbkdf2.c

subject: krb5int_pbkdf2_hmac_sha1 fails to set enctype on keyblock
ticket: 6630
tags: pullup

krb5int_pbkdf2_hmac_sha1 fails to set enctype on a termporary keyblock
- resulting in valgrind picking up on a conditional branch w/ unset
value. Initialize value.



------------------------------------------------------------------------
r23614 | tsitkova | 2010-01-08 14:53:34 -0500 (Fri, 08 Jan 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/krb5/os/t_locate_kdc.c

Fix t_locate_kdc.c test program after r23613 when krb5_ prefix was removed from the names of the static functions in locate_kdc.c

------------------------------------------------------------------------
r23613 | tsitkova | 2010-01-08 14:35:40 -0500 (Fri, 08 Jan 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/Makefile.in
   M /trunk/src/lib/krb5/krb/authdata.h
   M /trunk/src/lib/krb5/krb/pac.c
   A /trunk/src/lib/krb5/krb/pac_sign.c
   M /trunk/src/lib/krb5/os/locate_kdc.c

Move kdc related functionality from pac.c into pac_sign.c

------------------------------------------------------------------------
r23612 | epeisach | 2010-01-08 09:54:04 -0500 (Fri, 08 Jan 2010) | 8 lines
Changed paths:
   M /trunk/src/lib/crypto/krb/dk/stringtokey.c

ticket: 6628
subject: krb5int_dk_string_to_key fails to set enctype
tags: pullup

Failure to set the enctype before invoking krb5_k_create_key results in 
potential memory leak.


------------------------------------------------------------------------
r23611 | epeisach | 2010-01-07 22:43:37 -0500 (Thu, 07 Jan 2010) | 8 lines
Changed paths:
   M /trunk/src/lib/crypto/crypto_tests/aes-test.c
   M /trunk/src/lib/crypto/crypto_tests/t_cts.c

subject: Set enctype in crypto_tests to prevent memory leaks
ticket: 6627
tags: pullup

The key caching is causing memory leaks if enctype is not set as the
enctype specific cleanup handlers are not called.


------------------------------------------------------------------------
r23610 | ghudson | 2010-01-07 21:43:21 -0500 (Thu, 07 Jan 2010) | 10 lines
Changed paths:
   M /trunk/src/lib/kadm5/srv/svr_principal.c

ticket: 6626
subject: Restore interoperability with 1.6 addprinc -randkey
tags: pullup
target_version: 1.8

The arcfour string-to-key operation in krb5 1.7 (or later) disagrees
with the dummy password used by the addprinc -randkey operation in
krb5 1.6's kadmin client, because it's not valid UTF-8.  Recognize the
1.6 dummy password and use a random password instead.

------------------------------------------------------------------------
r23609 | epeisach | 2010-01-07 21:12:24 -0500 (Thu, 07 Jan 2010) | 25 lines
Changed paths:
   M /trunk/src/lib/crypto/krb/yarrow/ycipher.c
   M /trunk/src/lib/crypto/krb/yarrow/ycipher.h

subject: yarrow code does not initialize keyblock enctype and uses unitialized value
ticket: 6625
tags: pullup

The yarrow code uses a keyblock that is partially initialized. This results
in krb5_k_free_key trying to look up the enctype to call the free handler.

One of the valgrind reports: (there are several paths)

==26701== Conditional jump or move depends on uninitialised value(s)
==26701==    at 0x40E9AF0: find_enctype (etypes.h:81)
==26701==    by 0x40E9C9E: krb5_k_free_key (key.c:91)
==26701==    by 0x40D641A: krb5int_yarrow_cipher_init (ycipher.c:49)
==26701==    by 0x40D593A: yarrow_gate_locked (yarrow.c:578)
==26701==    by 0x40D5349: krb5int_yarrow_output_Block (yarrow.c:423)
==26701==    by 0x40D581B: yarrow_output_locked (yarrow.c:553)
==26701==    by 0x40D5667: krb5int_yarrow_output (yarrow.c:513)
==26701==    by 0x40EBD2D: krb5_c_random_make_octets (prng.c:112)
==26701==    by 0x40D4119: krb5int_old_encrypt (old_aead.c:97)
==26701==    by 0x40E9696: krb5_k_encrypt_iov (encrypt_iov.c:42)
==26701==    by 0x8049554: main (t_encrypt.c:206)
==26701== 



------------------------------------------------------------------------
r23608 | epeisach | 2010-01-07 20:51:19 -0500 (Thu, 07 Jan 2010) | 25 lines
Changed paths:
   M /trunk/src/lib/crypto/krb/dk/derive.c

subject: krb5int_derive_key results in cache with uninitialized values

krb5int_derive_key creates a temporary keyblock to add to the derived cache.
krb5_k_free_key will iterate over the derived keys and for ones with cache will
lookup the enctype for the key_cleanup handler.

Unfortunatly, there isn't a keyblock init function that does not allocate the 
keyblock - as I suspect this problem will appear in other places.

The valgrind log of this problem is:

==7281== Conditional jump or move depends on uninitialised value(s)
==7281==    at 0x40E9AE8: find_enctype (etypes.h:81)
==7281==    by 0x40E9C96: krb5_k_free_key (key.c:91)
==7281==    by 0x40E9C52: krb5_k_free_key (key.c:86)
==7281==    by 0x40EBB00: krb5_c_prf (prf.c:87)
==7281==    by 0x40E7B1B: prf_plus (cf2.c:77)
==7281==    by 0x40E7CE6: krb5_c_fx_cf2_simple (cf2.c:125)
==7281==    by 0x804899C: main (t_cf2.c:70)
==7281==

with memory leaks.



------------------------------------------------------------------------
r23607 | ghudson | 2010-01-07 15:57:02 -0500 (Thu, 07 Jan 2010) | 7 lines
Changed paths:
   M /trunk/src/lib/kadm5/srv/server_kdb.c

ticket: 6546
status: open

When retrieving the kadmin/history key, accept any enctype, as the
current master key enctype may not match the one the KDB was created
with.

------------------------------------------------------------------------
r23606 | tsitkova | 2010-01-07 14:17:55 -0500 (Thu, 07 Jan 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/auth_con.c
   M /trunk/src/lib/krb5/krb/copy_athctr.c

Move krb5_auth_con_getauthenticator into copy_athctr.c as a better logical location.

------------------------------------------------------------------------
r23605 | hartmans | 2010-01-07 13:35:15 -0500 (Thu, 07 Jan 2010) | 3 lines
Changed paths:
   M /trunk/src/tests/dejagnu/Makefile.in

ticket: 6624

Revert change to Makefile.in that ended up not being needed
------------------------------------------------------------------------
r23604 | hartmans | 2010-01-07 13:32:20 -0500 (Thu, 07 Jan 2010) | 9 lines
Changed paths:
   M /trunk/src/tests/dejagnu/Makefile.in
   M /trunk/src/tests/dejagnu/config/default.exp
   M /trunk/src/tests/dejagnu/krb-standalone/standalone.exp
   A /trunk/src/tests/dejagnu/pkinit-certs
   A /trunk/src/tests/dejagnu/pkinit-certs/ca.pem
   A /trunk/src/tests/dejagnu/pkinit-certs/kdc.pem
   A /trunk/src/tests/dejagnu/pkinit-certs/privkey.pem

Subject: automated tests for anonymous pkinit
ticket: 6624
target_version: 1.8
tags: pullup

Implement tests for anonymous pkinit.  A certificate and private key
are checked in; these tests will stop working in 2023.

Note that r23602 needs to be pulled up before this ticket.
------------------------------------------------------------------------
r23603 | hartmans | 2010-01-07 13:32:15 -0500 (Thu, 07 Jan 2010) | 6 lines
Changed paths:
   M /trunk/src/kdc/do_as_req.c

subject: Always treat anonymous as preauth required
ticket: 6623
target_version: 1.8
tags: pullup

Always treat the WELLKNOWN/ANONYMOUS principal as requiring pre-authentication.  The anonymous draft depends on a pre-auth exchange to invoke pkinit.
------------------------------------------------------------------------
r23602 | ghudson | 2010-01-07 12:26:58 -0500 (Thu, 07 Jan 2010) | 4 lines
Changed paths:
   M /trunk/src/kdc/kdc_preauth.c
   M /trunk/src/lib/krb5/krb/preauth2.c

Make preauth_module_dir override, rather than supplement, the
built-in path list, to avoid problems with running the same preauth
module twice.

------------------------------------------------------------------------
r23601 | ghudson | 2010-01-07 12:07:36 -0500 (Thu, 07 Jan 2010) | 3 lines
Changed paths:
   M /trunk/src/tests/dejagnu/config/default.exp

Use a distinct pass/fail string for kinit_fast so its failures can be
distinguished from kinit's.

------------------------------------------------------------------------
r23600 | tsitkova | 2010-01-07 09:52:11 -0500 (Thu, 07 Jan 2010) | 2 lines
Changed paths:
   A /trunk/src/lib/krb5/krb/authdata_dec.c
   A /trunk/src/lib/krb5/krb/authdata_enc.c

Add miising files from rev #23593.

------------------------------------------------------------------------
r23599 | ghudson | 2010-01-06 18:44:04 -0500 (Wed, 06 Jan 2010) | 4 lines
Changed paths:
   M /trunk/src/lib/kdb/kdb_default.c

Make krb5_dbe_def_search_enctype more consistent about when it returns
KRB5_KDB_NO_PERMITTED_KEY.  Now it will return that error if it sees
any non-permitted enctypes which match the search criteria.

------------------------------------------------------------------------
r23598 | tlyu | 2010-01-06 18:25:53 -0500 (Wed, 06 Jan 2010) | 1 line
Changed paths:
   A /trunk/NOTICE (from /trunk/README:23597)
   M /trunk/README

Move copyright and other notices to NOTICE.
------------------------------------------------------------------------
r23597 | ghudson | 2010-01-06 18:14:14 -0500 (Wed, 06 Jan 2010) | 8 lines
Changed paths:
   M /trunk/src/lib/kdb/kdb_default.c

ticket: 6622
target_version: 1.8
tags: pullup

Don't return KRB5_KDB_NO_PERMITTED_KEY from
krb5_dbe_def_search_enctype if we previously returned results (i.e. if
*start > 0).

------------------------------------------------------------------------
r23593 | tsitkova | 2010-01-06 16:56:02 -0500 (Wed, 06 Jan 2010) | 6 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/Makefile.in
   M /trunk/src/lib/krb5/krb/authdata.c
   M /trunk/src/lib/krb5/krb/copy_auth.c
   M /trunk/src/lib/krb5/krb/int-proto.h
   M /trunk/src/lib/krb5/krb/kfree.c

Divide copy_auth.c into three files based on the functionality. Namely, 
1. copy/merge authdata
2. KDC related encode authdata 
3. decode authdata


------------------------------------------------------------------------
r23592 | tsitkova | 2010-01-06 13:39:18 -0500 (Wed, 06 Jan 2010) | 2 lines
Changed paths:
   M /trunk/src/include/k5-int.h
   M /trunk/src/lib/krb5/krb/int-proto.h
   M /trunk/src/lib/krb5/krb/valid_times.c
   M /trunk/src/lib/krb5/libkrb5.exports

Since krb5int_validate_times is used only inside krb dir do not export it and move its prototype into int-proto.h.

------------------------------------------------------------------------
r23591 | tsitkova | 2010-01-05 16:20:15 -0500 (Tue, 05 Jan 2010) | 2 lines
Changed paths:
   M /trunk/src/include/k5-int.h
   M /trunk/src/lib/krb5/krb/mk_req_ext.c
   M /trunk/src/lib/krb5/krb/rd_req_dec.c
   M /trunk/src/lib/krb5/krb/valid_times.c
   M /trunk/src/lib/krb5/libkrb5.exports

Rename krb5_validate_times into krb5int_validate_times as it is internal function

------------------------------------------------------------------------
r23590 | tsitkova | 2010-01-05 16:11:03 -0500 (Tue, 05 Jan 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/fast.c
   M /trunk/src/lib/krb5/krb/gc_frm_kdc.c
   M /trunk/src/lib/krb5/krb/int-proto.h
   M /trunk/src/lib/krb5/krb/s4u_creds.c
   M /trunk/src/lib/krb5/krb/tgtname.c
   M /trunk/src/lib/krb5/krb/walk_rtree.c
   M /trunk/src/lib/krb5/libkrb5.exports

Rename krb5int_tgtname into krb5_tgtname as an internal function

------------------------------------------------------------------------
r23589 | tlyu | 2010-01-04 23:48:57 -0500 (Mon, 04 Jan 2010) | 1 line
Changed paths:
   M /trunk/README
   M /trunk/src/patchlevel.h

Update trunk for post-1.8-branch
------------------------------------------------------------------------
r23587 | tlyu | 2010-01-04 23:37:07 -0500 (Mon, 04 Jan 2010) | 1 line
Changed paths:
   M /trunk/README
   M /trunk/doc/copyright.texinfo
   M /trunk/src/patchlevel.h

README, copyright, patchlevel for krb5-1.8 branch
------------------------------------------------------------------------
r23586 | tlyu | 2010-01-04 21:47:58 -0500 (Mon, 04 Jan 2010) | 5 lines
Changed paths:
   M /trunk/src/include/osconf.hin
   M /trunk/src/kadmin/testing/proto/krb5.conf.proto
   M /trunk/src/lib/krb5/krb/decrypt_tk.c
   M /trunk/src/lib/krb5/krb/init_ctx.c
   M /trunk/src/tests/dejagnu/config/default.exp
   M /trunk/src/tests/mkeystash_compat/Makefile.in

ticket: 6621
subject: disable weak crypto by default

Set allow_weak_crypto=false by default.  Set default master key
enctype to sha256.  Adjust test suite to compensate.
------------------------------------------------------------------------
r23585 | tlyu | 2010-01-04 16:45:23 -0500 (Mon, 04 Jan 2010) | 1 line
Changed paths:
   M /trunk/src/Makefile.in

Install encrypted_challenge plugin during fake-install.
------------------------------------------------------------------------
r23584 | ghudson | 2010-01-04 16:22:00 -0500 (Mon, 04 Jan 2010) | 4 lines
Changed paths:
   M /trunk/src/kdc/kdc_preauth.c

Add preauth_module_dir support to the KDC preauth module loader
(should have been part of r23531).  Most or all of this logic should
be moved into the plugin code or a layer above it, after the branch.

------------------------------------------------------------------------
r23583 | hartmans | 2010-01-04 14:59:25 -0500 (Mon, 04 Jan 2010) | 1 line
Changed paths:
   M /trunk/src/clients/kinit/kinit.M
   M /trunk/src/kadmin/cli/kadmin.M

Anonymous documentation
------------------------------------------------------------------------
r23582 | hartmans | 2010-01-04 14:59:20 -0500 (Mon, 04 Jan 2010) | 4 lines
Changed paths:
   M /trunk/src/plugins/preauth/pkinit/pkinit_srv.c

ticket: 6607

Other changes in this ticket guarantee that the padata argument to
return callbacks is non-null; don't check for null in pkinit_srv.c.
------------------------------------------------------------------------
r23581 | hartmans | 2010-01-04 14:59:16 -0500 (Mon, 04 Jan 2010) | 3 lines
Changed paths:
   M /trunk/src/include/k5-int.h
   M /trunk/src/include/krb5/krb5.hin

Bring back krb5_kt_free_entry which really does the same thing as
krb5_free_keytab_entry_contents per discussion on krbdev in order to
avoid breaking samba builds.
------------------------------------------------------------------------
r23580 | hartmans | 2010-01-04 14:59:12 -0500 (Mon, 04 Jan 2010) | 4 lines
Changed paths:
   M /trunk/src/tests/dejagnu/config/default.exp
   M /trunk/src/tests/dejagnu/krb-standalone/iprop.exp
   M /trunk/src/tests/dejagnu/krb-standalone/standalone.exp

Test FAST authentication during each pass

Because a new principal is added to the database, the iprop test
expected output is updated.
------------------------------------------------------------------------
r23579 | hartmans | 2010-01-04 14:59:03 -0500 (Mon, 04 Jan 2010) | 1 line
Changed paths:
   M /trunk/src/clients/kinit/kinit.M

Fix documentation of armor cache based on fast negotiation project.
------------------------------------------------------------------------
r23578 | tlyu | 2010-01-04 14:34:33 -0500 (Mon, 04 Jan 2010) | 5 lines
Changed paths:
   M /trunk/src/config-files/kdc.conf.M
   M /trunk/src/tests/dejagnu/config/default.exp

ticket: 6620
subject: kdc_supported_enctypes does nothing; eradicate mentions thereof

kdc_supported_enctypes does nothing.  Remove all mention of it from
documentation and test suites.
------------------------------------------------------------------------
r23577 | ghudson | 2010-01-04 12:00:23 -0500 (Mon, 04 Jan 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/get_in_tkt.c

Don't accept AS replies encrypted in enctypes other than the ones we
asked for.

------------------------------------------------------------------------
r23576 | tsitkova | 2010-01-04 01:22:41 -0500 (Mon, 04 Jan 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/Makefile.in
   M /trunk/src/lib/krb5/krb/etype_list.c
   D /trunk/src/lib/krb5/krb/free_rtree.c
   M /trunk/src/lib/krb5/krb/walk_rtree.c
   M /trunk/src/lib/krb5/os/Makefile.in
   D /trunk/src/lib/krb5/os/free_hstrl.c
   M /trunk/src/lib/krb5/os/hst_realm.c

For the better code modularity keep some "free" routines closer to the resource allocators. Also, reindent cleanup in the touched files.

------------------------------------------------------------------------
r23575 | raeburn | 2010-01-03 18:41:49 -0500 (Sun, 03 Jan 2010) | 1 line
Changed paths:
   M /trunk/src/lib/crypto/krb/checksum/deps
   M /trunk/src/lib/crypto/krb/deps
   M /trunk/src/lib/crypto/krb/dk/deps
   M /trunk/src/lib/crypto/krb/prf/deps
   M /trunk/src/lib/gssapi/krb5/deps
   M /trunk/src/lib/gssapi/mechglue/deps
   M /trunk/src/lib/krb5/ccache/deps
   M /trunk/src/lib/krb5/krb/deps
   M /trunk/src/tests/gssapi/deps

Update dependencies.
------------------------------------------------------------------------
r23574 | raeburn | 2010-01-03 18:39:12 -0500 (Sun, 03 Jan 2010) | 9 lines
Changed paths:
   M /trunk/src/include/k5-int.h
   M /trunk/src/lib/crypto/builtin/enc_provider/aes.c
   M /trunk/src/lib/crypto/krb/key.c

Enable caching of key-derived context info such as key schedules from
one encryption operation to another.  Use a new function in the
enc_provider structure for cleanup.  Implement caching of aes_ctx
values.

Using Greg's performance tests from the derived-key caching work, on a
2.8GHz Xeon, I see 1 million AES-128 encryptions of 16 bytes improved
by 5-6%; encryptions of 1024 bytes and checksums are not significantly
affected.
------------------------------------------------------------------------
r23573 | ghudson | 2010-01-03 18:12:19 -0500 (Sun, 03 Jan 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/crypto/builtin/enc_provider/aes.c

Fix a case where krb5int_aes_decrypt was trying to encrypt a block
instead of decrypting it.

------------------------------------------------------------------------
r23572 | epeisach | 2010-01-03 10:14:51 -0500 (Sun, 03 Jan 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/gssapi/krb5/acquire_cred.c

krb5_gss_acquire_cred will deref garbage pointer if actual_mechs is NULL.


------------------------------------------------------------------------
r23571 | epeisach | 2010-01-03 09:27:02 -0500 (Sun, 03 Jan 2010) | 1 line
Changed paths:
   M /trunk/src/kadmin/testing/util/tcl_kadm5.c

Initialize variables in case of error path winds up freeing stack garbage
------------------------------------------------------------------------
r23570 | raeburn | 2010-01-02 22:00:24 -0500 (Sat, 02 Jan 2010) | 2 lines
Changed paths:
   M /trunk/src/kdc/network.c

Ignore some routing messages indicating changes that don't affect our
set of local addresses.
------------------------------------------------------------------------
r23569 | raeburn | 2010-01-02 22:00:19 -0500 (Sat, 02 Jan 2010) | 1 line
Changed paths:
   M /trunk/src/tests/dejagnu/config/default.exp

Remove old 'full' arg to KDC that should've gone away with '-4'.
------------------------------------------------------------------------
r23568 | epeisach | 2010-01-02 19:19:53 -0500 (Sat, 02 Jan 2010) | 3 lines
Changed paths:
   M /trunk/src/appl/gss-sample/gss-misc.c
   M /trunk/src/clients/klist/klist.c
   M /trunk/src/kadmin/ktutil/ktutil.c
   M /trunk/src/kadmin/testing/util/tcl_kadm5.c

Some unsigned/signed warning cleanup


------------------------------------------------------------------------
r23567 | ghudson | 2010-01-01 21:35:40 -0500 (Fri, 01 Jan 2010) | 2 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/rd_req_dec.c

Use krb5int_count_etypes in rd_req_decoded_opt.

------------------------------------------------------------------------
r23566 | epeisach | 2010-01-01 21:16:23 -0500 (Fri, 01 Jan 2010) | 4 lines
Changed paths:
   M /trunk/src/tests/dejagnu/config/default.exp

Test -P options to kdc and kadmind to write out a pid file. Verify contents of 
pid file match pid of executable.


------------------------------------------------------------------------
r23565 | ghudson | 2010-01-01 18:20:56 -0500 (Fri, 01 Jan 2010) | 3 lines
Changed paths:
   M /trunk/src/lib/krb5/ccache/cc_retr.c
   M /trunk/src/lib/krb5/krb/Makefile.in
   M /trunk/src/lib/krb5/krb/auth_con.c
   M /trunk/src/lib/krb5/krb/copy_ctx.c
   A /trunk/src/lib/krb5/krb/etype_list.c
   M /trunk/src/lib/krb5/krb/get_in_tkt.c
   M /trunk/src/lib/krb5/krb/init_ctx.c
   M /trunk/src/lib/krb5/krb/int-proto.h
   M /trunk/src/lib/krb5/krb/ser_ctx.c

Factor out copying and counting of zero-terminated enctype lists into
a new file src/lib/krb5/krb/etype_list.c.

------------------------------------------------------------------------
r23564 | ghudson | 2010-01-01 17:34:29 -0500 (Fri, 01 Jan 2010) | 2 lines
Changed paths:
   M /trunk/src/prototype/prototype.c
   M /trunk/src/prototype/prototype.h

Update copyright year in prototype sources.

------------------------------------------------------------------------
r23563 | epeisach | 2010-01-01 11:41:04 -0500 (Fri, 01 Jan 2010) | 6 lines
Changed paths:
   M /trunk/src/kdc/extern.h
   M /trunk/src/kdc/main.c

Change db_args from being a global to only defined in the function
that uses it. This removes a warning of shadowed variable names.  Change
several functions to static when limited to main.c



------------------------------------------------------------------------
r23562 | epeisach | 2010-01-01 08:00:08 -0500 (Fri, 01 Jan 2010) | 3 lines
Changed paths:
   M /trunk/src/kdc/kdc_util.h

Add gcc printf attribute for kdc_err prototype.


------------------------------------------------------------------------
r23561 | epeisach | 2010-01-01 07:58:42 -0500 (Fri, 01 Jan 2010) | 2 lines
Changed paths:
   M /trunk/src/kadmin/server/ovsec_kadmd.c

Unsigned/signed cleanup

------------------------------------------------------------------------
r23560 | rra | 2010-01-01 00:09:57 -0500 (Fri, 01 Jan 2010) | 6 lines
Changed paths:
   M /trunk/src/kadmin/server/kadmind.M
   M /trunk/src/kadmin/server/ovsec_kadmd.c
   M /trunk/src/kdc/krb5kdc.M
   M /trunk/src/kdc/main.c

Ticket: 6618

Add a new -P option to krb5kdc and kadmind which, if given, specifies
the path to which to write the PID file of the daemon after it finishes
initializing.

------------------------------------------------------------------------
r23559 | epeisach | 2009-12-31 18:18:16 -0500 (Thu, 31 Dec 2009) | 3 lines
Changed paths:
   M /trunk/src/tests/threads/init_ctx.c

Free tinfo at end - so program runs with new memory leaks.


------------------------------------------------------------------------
r23558 | epeisach | 2009-12-31 18:13:56 -0500 (Thu, 31 Dec 2009) | 9 lines
Changed paths:
   M /trunk/src/configure.in

Remove tests for functions that we do not conditionalize on.  Most deprecated
from breakoff of apps.

Specifically, do not test for:

gethostbyname2 getifaddrs pthread_mutex_lock sched_yield ftime strstr
timezone umask waitpid sem_init sem_trywait daemon


------------------------------------------------------------------------
r23557 | epeisach | 2009-12-31 17:49:52 -0500 (Thu, 31 Dec 2009) | 3 lines
Changed paths:
   M /trunk/src/lib/crypto/crypto_tests/t_cts.c

Declare function as static to avoid compiler warning on missing prototypes.


------------------------------------------------------------------------
r23556 | epeisach | 2009-12-31 17:48:19 -0500 (Thu, 31 Dec 2009) | 2 lines
Changed paths:
   M /trunk/src/lib/crypto/builtin/des/Makefile.in

Remove $(TOBJS) for make clean.

------------------------------------------------------------------------
r23555 | epeisach | 2009-12-31 17:25:11 -0500 (Thu, 31 Dec 2009) | 4 lines
Changed paths:
   M /trunk/src/slave/kpropd.c

Use krb5_free_default_realm instead of free on the results of
krb5_get_default_realm().


------------------------------------------------------------------------
r23554 | rra | 2009-12-30 23:21:34 -0500 (Wed, 30 Dec 2009) | 8 lines
Changed paths:
   M /trunk/src/config-files/krb5.conf.M
   M /trunk/src/kadmin/dbutil/kdb5_util.M
   M /trunk/src/kdc/krb5kdc.M
   M /trunk/src/slave/kpropd.M

ticket: 6616
subject: Fix spelling and hyphen errors in man pages
component: krb5-doc

Fix spelling errors in man pages detected by Debian's Lintian program.
Also escape some -'s that are intended to be literal ASCII dashes and
not Unicode hyphens so that groff won't change them into true hyphens.

------------------------------------------------------------------------
r23553 | raeburn | 2009-12-30 23:07:03 -0500 (Wed, 30 Dec 2009) | 3 lines
Changed paths:
   M /trunk/src/plugins/preauth/pkinit/pkinit_crypto_openssl.c

NetBSD 5.0.1 uses an OpenSSL snapshot that describes itself as 0.9.9,
and has the EVP_PKEY_decrypt API change that was already being worked
around for OpenSSL 1.0.0.  Work around it for 0.9.9 too.
------------------------------------------------------------------------
r23552 | raeburn | 2009-12-30 22:37:40 -0500 (Wed, 30 Dec 2009) | 1 line
Changed paths:
   M /trunk/src/tests/resolve/addrinfo-test.c

format %p wants void*
------------------------------------------------------------------------
r23551 | raeburn | 2009-12-30 22:37:37 -0500 (Wed, 30 Dec 2009) | 1 line
Changed paths:
   M /trunk/src/lib/crypto/krb/checksum/confounder.c

Initialize hash_iov, in case of premature error exit.
------------------------------------------------------------------------
r23550 | raeburn | 2009-12-30 22:37:34 -0500 (Wed, 30 Dec 2009) | 1 line
Changed paths:
   M /trunk/src/lib/krb5/ccache/ccbase.c

Convert C++ style comments into traditional C comments.
------------------------------------------------------------------------
r23549 | raeburn | 2009-12-30 22:37:30 -0500 (Wed, 30 Dec 2009) | 1 line
Changed paths:
   M /trunk/src/kdc/kdc_util.h

No comma at end of enumerator list.
------------------------------------------------------------------------
r23548 | raeburn | 2009-12-30 20:32:00 -0500 (Wed, 30 Dec 2009) | 1 line
Changed paths:
   M /trunk/src/include/krb5/preauth_plugin.h

No comma at end of enumerator list.
------------------------------------------------------------------------
r23547 | epeisach | 2009-12-30 18:03:48 -0500 (Wed, 30 Dec 2009) | 4 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/libdef_parse.c

Include os-proto.h for _krb5_conf_boolean prototype before declaration
of function. (gcc warning)


------------------------------------------------------------------------
r23546 | tsitkova | 2009-12-30 14:53:16 -0500 (Wed, 30 Dec 2009) | 2 lines
Changed paths:
   M /trunk/src/include/k5-int.h
   M /trunk/src/kdc/kdc_util.c
   M /trunk/src/kdc/kdc_util.h
   M /trunk/src/lib/krb5/libkrb5.exports
   M /trunk/src/lib/krb5/os/def_realm.c

Move krb5int_get_domain_realm_mapping into kdc_util.c as this function is a helper in kdc code.

------------------------------------------------------------------------
r23545 | ghudson | 2009-12-30 14:39:35 -0500 (Wed, 30 Dec 2009) | 4 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/init_ctx.c

Eliminate the krb5_set_default_in_tkt_ktypes and
krb5_set_default_tgs_ktypes during context initialization, as they
weren't doing anything.

------------------------------------------------------------------------
r23538 | tsitkova | 2009-12-29 15:30:29 -0500 (Tue, 29 Dec 2009) | 2 lines
Changed paths:
   M /trunk/src/lib/krb5/krb/Makefile.in
   A /trunk/src/lib/krb5/krb/copy_ctx.c
   M /trunk/src/lib/krb5/krb/init_ctx.c

Create a separate file for krb5_copy_context for better code modularity.

------------------------------------------------------------------------
r23537 | tsitkova | 2009-12-29 15:08:42 -0500 (Tue, 29 Dec 2009) | 2 lines
Changed paths:
   M /trunk/src/lib/crypto/krb/Makefile.in
   D /trunk/src/lib/crypto/krb/enctype_compare.c
   D /trunk/src/lib/crypto/krb/enctype_to_string.c
   A /trunk/src/lib/crypto/krb/enctype_util.c
   D /trunk/src/lib/crypto/krb/string_to_enctype.c
